<?php
namespace HCM\BTL\Controllers;

use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DTO\Response\Message;
use \HCM\Geral\Services\EnviarMensagemService;
use \HCM\Geral\Controllers\EnviarMensagemController;
use \HCM\AVL\Controllers\QuestionarioController;
use Zeedhi\Framework\DTO;

class ProcessoSeletivoController {

    protected $processoSeletivoService;
    protected $enviarMensagemController;
    protected $enviarEmailService;

    public function __construct(\HCM\BTL\Services\ProcessoSeletivoService $processoSeletivoService, 
        EnviarMensagemService $enviarMensagemService, EnviarMensagemController $enviarMensagemController,
        QuestionarioController $questionarioController) {
        $this->processoSeletivoService  = $processoSeletivoService;
        $this->enviarMensagemService    = $enviarMensagemService;
        $this->enviarMensagemController = $enviarMensagemController;
        $this->questionarioController   = $questionarioController;
    }

    public function setMediaTotal($request, $response) {
        try {
            $filters = $request->getFilterCriteria()->getConditions();
            $parameters = array();
            foreach ($filters as $filter) {
                unset($filter['operator']);
                foreach ($filter as $key => $value) {
                    if ($key == 'columnName') {
                        $parameters[$value] = $filter['value'];
                        unset($filter['columnName']);
                    }
                }
            }
            $result = $this->processoSeletivoService->setMediaTotal($parameters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('setMediaTotal', array($result)));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function setReprovados($request, $response) {
        try {
            $filters = $request->getFilterCriteria()->getConditions();
            $parameters = array();
            foreach ($filters as $filter) {
                unset($filter['operator']);
                foreach ($filter as $key => $value) {
                    if ($key == 'columnName') {
                        $parameters[$value] = $filter['value'];
                        unset($filter['columnName']);
                    }
                }
            }
            $result = $this->processoSeletivoService->setReprovados($parameters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('setReprovados', array($result)));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function setDtConclusaoProcesso($request, $response) {
        try {
            $filters = $request->getFilterCriteria()->getConditions();
            $parameters = array();
            foreach ($filters as $filter) {
                unset($filter['operator']);
                foreach ($filter as $key => $value) {
                    if ($key == 'columnName') {
                        $parameters[$value] = $filter['value'];
                        unset($filter['columnName']);
                    }
                }
            }
            $result = $this->processoSeletivoService->setDtConclusaoProcesso($parameters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('setDtConclusaoProcesso', array($result)));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function setNrAvaliacao($request, $response){
        $row = $request->getDataSet()->getRows();
        foreach ($request->getDataSet()->getRows() as $row) {
            if(array_key_exists('CANDIDATOS', $row)){
                foreach ($row['CANDIDATOS'] as $candidatos) {
                    $candidatos['NRAVALIACAO'] = $row['NRAVALIACAO'];
                    $this->processoSeletivoService->setNrAvaliacao($candidatos);
                }
            }
        }
    }

    public function sendLinkQuestionario($request, $response){
        $row = $request->getDataSet()->getRows();
        foreach ($request->getDataSet()->getRows() as $row) {
            if(array_key_exists('CANDIDATOS', $row)){
                foreach ($row['CANDIDATOS'] as $candidatos) {
                    $candidatos['CDOPERADOR'] = $this->processoSeletivoService->getOperadorParcnegocio($row['NRORGCANDIDATO'], $candidatos['NRPARCNEGOCIOCAND']);
                    if(!array_key_exists('NRCOMBQUESTAVAL', $candidatos)){
                        $candidatos['NRCOMBQUESTAVAL'] = null;
                    }

                    if(!array_key_exists('DTEXECUCAOAVAL', $candidatos)){
                        $candidatos['DTEXECUCAOAVAL'] = $row['DATAATUAL'];
                    }
                    
                    if(!array_key_exists('NRPARCAVALIADO', $candidatos)){
                        $candidatos['NRPARCAVALIADO'] = $candidatos['NRPARCNEGOCIOCAND'];
                    }

                    if(!array_key_exists('NRPARCEXECAVAL', $candidatos)){
                        $candidatos['NRPARCEXECAVAL'] = $candidatos['NRPARCNEGOCIOCAND'];
                    }

                    if(!array_key_exists('NRTIPORELACIONA', $candidatos)){
                        $candidatos['NRTIPORELACIONA'] = 11;
                    }

                    if(!array_key_exists('IDSITUACAOAVAL', $candidatos)){
                        $candidatos['IDSITUACAOAVAL'] = 'PENDENTE';
                    }

                    $dados = array_merge($candidatos, array("NRORGCANDIDATO" => $row['NRORGCANDIDATO'], "NRAVALIACAO" => $row['NRAVALIACAO'], "CDOPERADOR_LOG" => $row['CDOPERADOR_LOG'], "NRORGOPERADOR" => $row['NRORGOPERADOR'], "DATAATUAL" => $row['DATAATUAL']));
                    
                    $this->insertParticipaval($dados);
                    $this->insertExecavaliacao($dados);

                    $candidatos['linkQuestionario'].="&CDOPERADOR=".$candidatos['CDOPERADOR'];
                    $candidatos['NMPROCESSO'] = $row['NMPROCESSO'];
                    $candidatos['NMESTRUTURAM'] = $row['NMESTRUTURAM'];
                    $candidatos = array($candidatos);
                    $mensagem = array("DSMENSAGEM" => $row["DSMENSAGEM"], "DSTITULOMENSAGEM" => $row["DSTITULOMENSAGEM"]);
                    $requestSave = new DTO\Request\DataSet ((new \Zeedhi\Framework\DataSource\DataSet('candidatos', array(array('CANDIDATO' => $candidatos, 'MENSAGEM' => $mensagem)))), $request->getMethod(), $request->getRoutePath(), $request->getUserId());
                    $this->enviarMensagemController->enviarMensagem($requestSave, $response);
                }
            }
        }
    }

    public function insertParticipaval($dados){
        if($this->questionarioController->verificaExistenciaParticipaval($dados)){
            if(is_null($dados['NRCOMBQUESTAVAL'])){
                $dados['NRCOMBQUESTAVAL'] = 1;
            }
            $dados['NRPARTICIPAVAL'] = \HCM\Util\NovoCodigo::geraCodigo($dados['NRORG'], 'PARTICIPAVAL', 1, 12, true);
            $dados['IDATIVO'] = 'S';
            $this->questionarioController->insertParticipaval($dados);
        };
    }
    
    public function insertExecavaliacao($dados){
        $execAval = $this->questionarioController->getExecavaliacao($dados['NRAVALIACAO'], $dados['NRORG'], $dados['NRPARCNEGOCIOCAND']);
        foreach($execAval as $exec){
            $params = array_merge($dados, $exec);

            $params['IDATIVO'] = 'S';
            $params['NREXECAVALIACAO'] = \HCM\Util\NovoCodigo::geraCodigo($params['NRORG'], 'EXECAVALIACAO', 1, 12, true);
            $params['IDORIGEMEXECAVAL'] = 'SISTEMA';

            $this->questionarioController->insertExecavaliacao($params);
        }
        
    }      

}