<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomRescisaoRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */

    public function getRelatCustomRescisao($parameters, $filters) {
      
        $dtOcorrencia = " AND FPA_CALCULOFOLHA.DTOCORRENCIA = TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY') ";
        foreach($filters as $key=>$value){
          if($value['columnName'] == 'DTOCORRENCIA'){
              $dtOcorrencia = " AND FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN '".$value['value'][0]."' AND '".$value['value'][1]."' ";
              unset($filters[$key]);
          }
        }
        
        $conditions = Util::createQueryFiltered($filters);
        
        $params = array(
        "P_COMPETENCIA"    => $parameters['P_DTMESCOMPETENC'],
        "P_NRORG"          => $parameters['P_NRORG'],
        "P_NRTPMODALIDCAL" => $parameters['NRTPMODALIDCAL'],
        "P_NROCORRECAL"    => isset($parameters['NROCORRECAL']) && !empty($parameters['NROCORRECAL']) ? $parameters['NROCORRECAL'] : null,
        "P_NRORG_PADRAO"   => $parameters['P_NRORG_PADRAO']
        );
        
        if(array_key_exists('NRTIPOHIERARQORG', $parameters) && isset($parameters['NRTIPOHIERARQORG']) && !empty($parameters['NRTIPOHIERARQORG']) ) {
        $tipohierarquia = $parameters['NRTIPOHIERARQORG'];
          
        $joinHierarquia = " LEFT JOIN HIERARQUIAORG
                                  ON HIERARQUIAORG.NRESTRUTURAMREL = VINCULOH.NRESTRUTGEREN
                                  AND HIERARQUIAORG.NRORG          = GPE_VINCULOM.NRORG 
                                  AND HIERARQUIAORG.NRTIPOHIERARQORG = $tipohierarquia 
                               
                            LEFT JOIN ESTRUTURAM ESTRUTSUPERIORM
                                  ON VINCULOH.NRORG                 = ESTRUTSUPERIORM.NRORG
                                  AND HIERARQUIAORG.NRESTRUTURAMSUP = ESTRUTSUPERIORM.NRESTRUTURAM
                               
                            LEFT JOIN ESTRUTURAH ESTRUTSUPERIORH
                                  ON ESTRUTSUPERIORM.NRORG           = ESTRUTSUPERIORH.NRORG
                                  AND ESTRUTSUPERIORM.NRESTRUTURAM   = ESTRUTSUPERIORH.NRESTRUTURAM
                                  AND ESTRUTSUPERIORH.DTMESCOMPETENC = (SELECT MAX(ESTRUTURAH4.DTMESCOMPETENC)
                                                                          FROM ESTRUTURAH ESTRUTURAH4
                                                                         WHERE ESTRUTURAH4.NRORG         = ESTRUTSUPERIORH.NRORG
                                                                           AND ESTRUTURAH4.NRESTRUTURAM    = ESTRUTSUPERIORH.NRESTRUTURAM
                                                                           AND ESTRUTURAH4.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))
                                ";
                
            $selectHierarquia = "HIERARQUIAORG.NRTIPOHIERARQORG AS TIPOHIERARQORG,
                                 ESTRUTSUPERIORM.NRESTRUTURAM   AS NRESTRUTSUPERIORM,
                                 ESTRUTSUPERIORH.NMESTRUTURAH   AS NMESTRUTSUPERIORM, ";     
        }else{
          $joinHierarquia =  " ";
        
          $selectHierarquia = "NULL AS TIPOHIERARQORG,
                               NULL AS NRESTRUTSUPERIORM,
                               NULL AS NMESTRUTSUPERIORM, ";     
        }
        
        if(array_key_exists('NRESTRUTLEGAL', $parameters)) {
          /*$listEstrutLegal = array_map(function($estrutlegal) {
              return $estrutlegal;
          },
          $parameters['NRESTRUTLEGAL']);*/
          $nrestrutlegal = implode(",", $parameters['NRESTRUTLEGAL']);
          $condEstrutLegal = "AND VINCULOH.NRESTRUTLEGAL IN ($nrestrutlegal)";
        } else {
        $condEstrutLegal = "";
        }
        
        if(array_key_exists('NRESTRUTGEREN', $parameters)) {
          /*$listEstrutGeren = array_map(function($estrutgeren) {
              return $estrutgeren;
          },
          $parameters['NRESTRUTGEREN']);*/
          $nrestrutgeren = implode(",", $parameters['NRESTRUTGEREN']);
          $condEstrutGeren = "AND VINCULOH.NRESTRUTGEREN IN ($nrestrutgeren)";
        } else {
        $condEstrutGeren = "";
        }
        
        if(array_key_exists('NREVENTOM', $parameters)){
          $nreventom = implode(",", $parameters['NREVENTOM']);
          $condicaoEventos = "AND FPA_ITECALCFOLHA.NREVENTOM IN ($nreventom)";
        }else {
          $condicaoEventos = ' ';
        }
        
        if(array_key_exists('NRLOTEVINC_LIST', $parameters)){
          $numerolote = implode(",", $parameters['NRLOTEVINC_LIST']);
          
          $pertencelote = 'AND LV.NRLOTEVINC IN ('.$numerolote.')';
          
        }else {
            $pertencelote = ' ';
        }
        
        $sql = "
      SELECT * FROM (
        SELECT
            REPLACE( TRANSLATE (GPE_VINCULOM.CDMATRICULA, '~!@#$%^&*_-+=|\(){}[]:;<>,.?/' , ' ' ), ' ', '' ) CDMATRICULA,
            VINCULOH.CDMATRICULAESOCIAL,
            VINCULOH.NRESTRUTLEGAL,
            ESTRUTLEGALH.NMESTRUTURAH AS NMESTRUTLEGAL,
            VINCULOH.NRESTRUTGEREN,
            ESTRUTGERENCH.NMESTRUTURAH AS NMESTRUTGEREN,
            VINCULOH.NRESTRUTSIND,
            ESTRUTSINDH.NMESTRUTURAH AS NMESTRUTSIND,
            $selectHierarquia
            GPE_VINCULOM.NRVINCULOM,
            GPE_VINCULOM.NMVINCULOM AS NMVINCULOM,
            GPE_VINCULOM.NRTIPOVINCULOM,
            GVH.NMTIPOVINCULOH,
            TO_DATE(TO_CHAR(GPE_VINCULOM.DTADMISSAOVINC,'DD/MM/YYYY'),'DD/MM/YYYY') DTADMISSAOVINC,     
            GPE_PESSOAH.NRCPFPESSOA,
            ESTRUTGERENCM.CDINTESTRUTEXP,
            BANCO.CDBANCO,
            BANCO.NMBANCO AS NMBANCO,
            CONTCORRPARC.CDAGENCIA,
            AGENCIA.NMAGENCIA,
            CONTCORRPARC.CDCONTCORR,
            /*SUBSTR(GPE_VINCULOM.DTRESCISAOVINC,1,10) DTRESCISAOVINC,*/
            TO_DATE(TO_CHAR(GPE_VINCULOM.DTRESCISAOVINC,'DD/MM/YYYY'),'DD/MM/YYYY') DTRESCISAOVINC,
            GPE_VINCULOM.NRTPADMISSAO,
            FPA_TPADMISSAO.NMABREV AS NMTPADMISSAO,
            GPE_VINCULOM.NRTPAVIPRE,
            /*SUBSTR(GPE_VINCULOM.DTAVISOPREVIO,1,10) DTAVISOPREVIO,*/
            TO_DATE(TO_CHAR(GPE_VINCULOM.DTAVISOPREVIO,'DD/MM/YYYY'),'DD/MM/YYYY') DTAVISOPREVIO,
            GPE_TIPOAVISOPRE.DSTPAVIPRE AS DSTPAVIPRE,
            FPA_TPDEMISSAO.NRTPDEMISSAO AS NRTPDEMISSAO,
            FPA_TPDEMISSAO.NMABREV AS NMTPDEMISSAO,
            GPE_MOTIVORESC.NRMOTIVORESC AS NRMOTIVORESC,
            GPE_MOTIVORESC.NMMOTIVORESC AS NMMOTIVORESC,
            GPE_VINCULOM.DSOBSRESCISAO,
            /*SUBSTR(FPA_ITECALCFOLHA.DTOCORRENCIA,1,10) DTOCORRENCIA,*/
            TO_DATE(TO_CHAR(FPA_ITECALCFOLHA.DTOCORRENCIA,'DD/MM/YYYY'),'DD/MM/YYYY') DTOCORRENCIA,
            FPA_ITECALCFOLHA.VREVENTOFOLHA,
            FPA_ITECALCFOLHA.NREVENTOM,
            FPA_EVENTOH.NMEVENTOH AS NMEVENTOH,
            FPA_ITECALCFOLHA.VRREFFOLHA,
            ATS.VRSALARIO, /*Rafael Pickbrenner pck - 13/07/2016 - Tarefa 32282*/
            FPA_ITECALCFOLHA.DTGERULTGRRF,
            (SELECT SUM(DECODE(IE.IDINCIDEVENTO, 'N', 0, DECODE(IE.IDINCIDEVENTO, '-', -1 * IC.VREVENTOFOLHA, IC.VREVENTOFOLHA)))
              FROM FPA_ITECALCFOLHA IC, FPA_INCIDEVENTO IE
             WHERE IC.NRORG = FPA_ITECALCFOLHA.NRORG
               AND IC.NRCALCULOFOLHA = FPA_ITECALCFOLHA.NRCALCULOFOLHA
               AND IC.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
               AND IC.NREVENTOM = IE.NREVENTOM
               AND (IC.NRORG = IE.NRORG OR IE.NRORG = 0)
               AND IE.NRTIPOINCIDE = 66) VRAVISOINDENIZADO,
            (SELECT SUM(DECODE(IE.IDINCIDEVENTO, 'N', 0, DECODE(IE.IDINCIDEVENTO, '-', -1 * IC.VREVENTOFOLHA, IC.VREVENTOFOLHA)))
              FROM FPA_ITECALCFOLHA IC, FPA_INCIDEVENTO IE
             WHERE IC.NRORG = FPA_ITECALCFOLHA.NRORG
               AND IC.NRCALCULOFOLHA = FPA_ITECALCFOLHA.NRCALCULOFOLHA
               AND IC.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
               AND IC.NREVENTOM = IE.NREVENTOM
               AND (IC.NRORG = IE.NRORG OR IE.NRORG = 0)
               AND IE.NRTIPOINCIDE = 67) VRMESRECISAO,
            (SELECT SUM(DECODE(IE.IDINCIDEVENTO, 'N', 0, DECODE(IE.IDINCIDEVENTO, '-', -1 * IC.VREVENTOFOLHA, IC.VREVENTOFOLHA)))
              FROM FPA_ITECALCFOLHA IC, FPA_INCIDEVENTO IE
             WHERE IC.NRORG = FPA_ITECALCFOLHA.NRORG
               AND IC.NRCALCULOFOLHA = FPA_ITECALCFOLHA.NRCALCULOFOLHA
               AND IC.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
               AND IC.NREVENTOM = IE.NREVENTOM
               AND (IC.NRORG = IE.NRORG OR IE.NRORG = 0)
               AND IE.NRTIPOINCIDE = 54) VRSALDOBANCO,
            (SELECT SUM(DECODE(IE.IDINCIDEVENTO, 'N', 0, DECODE(IE.IDINCIDEVENTO, '-', -1 * IC.VREVENTOFOLHA, IC.VREVENTOFOLHA)))
              FROM FPA_ITECALCFOLHA IC, FPA_INCIDEVENTO IE
             WHERE IC.NRORG = FPA_ITECALCFOLHA.NRORG
               AND IC.NRCALCULOFOLHA = FPA_ITECALCFOLHA.NRCALCULOFOLHA
               AND IC.NRVINCULOM = FPA_ITECALCFOLHA.NRVINCULOM
               AND IC.NREVENTOM = IE.NREVENTOM
               AND (IC.NRORG = IE.NRORG OR IE.NRORG = 0)
               AND (IE.NRTIPOINCIDE = 52 OR IE.NRTIPOINCIDE = 105)) VRGRRF

    FROM GPE_VINCULOM

        JOIN GPE_VINCULOH VINCULOH
            ON (GPE_VINCULOM.NRORG           = VINCULOH.NRORG
           AND  GPE_VINCULOM.NRVINCULOM      = VINCULOH.NRVINCULOM)
           AND  VINCULOH.DTMESCOMPETENC =
               (SELECT MAX(DTMESCOMPETENC)
                        FROM GPE_VINCULOH
                        WHERE NRORG              = VINCULOH.NRORG
                            AND NRVINCULOM       = VINCULOH.NRVINCULOM
                            AND DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))
                            
        LEFT JOIN FPA_ITEMLOTEVINC LV
            ON LV.NRORG = GPE_VINCULOM.NRORG 
            AND LV.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
        
        /*RESCISÃO*/
        LEFT JOIN FPA_TPDEMISSAO
               ON FPA_TPDEMISSAO.NRTPDEMISSAO = GPE_VINCULOM.NRTPDEMISSAO
        LEFT JOIN GPE_MOTIVORESC
               ON GPE_MOTIVORESC.NRMOTIVORESC = GPE_VINCULOM.NRMOTIVORESC
        LEFT JOIN GPE_TIPOAVISOPRE
               ON GPE_TIPOAVISOPRE.NRTPAVIPRE = GPE_VINCULOM.NRTPAVIPRE
        LEFT JOIN FPA_TPADMISSAO
               ON FPA_TPADMISSAO.NRTPADMISSAO = GPE_VINCULOM.NRTPADMISSAO

        /*INTEM CALC*/
        LEFT JOIN FPA_CALCULOFOLHA
               ON FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 1
              /*AND ( FPA_CALCULOFOLHA.DTOCORRENCIA = TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY') OR :P_IDUSARCOMP != 0)*/
              $dtOcorrencia
              AND FPA_CALCULOFOLHA.NRORG = :P_NRORG
              AND (FPA_CALCULOFOLHA.NROCORRECAL = :P_NROCORRECAL OR :P_NROCORRECAL IS NULL)
              AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = :P_NRTPMODALIDCAL

        LEFT JOIN FPA_ITECALCFOLHA
               ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
              AND GPE_VINCULOM.NRVINCULOM      = FPA_ITECALCFOLHA.NRVINCULOM
              AND FPA_CALCULOFOLHA.NRORG          = FPA_ITECALCFOLHA.NRORG
              $condicaoEventos
        /*EVENTOS VINC
        LEFT JOIN FPA_VINCEVENTO
               ON GPE_VINCULOM.NRVINCULOM     = FPA_VINCEVENTO.NRVINCULOM
              AND GPE_VINCULOM.NRORG          = FPA_VINCEVENTO.NRORG*/
        /* NMEVENTO */
        LEFT JOIN FPA_EVENTOH
               ON FPA_EVENTOH.NREVENTOM = FPA_ITECALCFOLHA.NREVENTOM
              AND FPA_EVENTOH.DTMESCOMPETENC =
               (SELECT MAX(DTMESCOMPETENC)
                        FROM FPA_EVENTOH MAXEVENTOH
                        WHERE MAXEVENTOH.NREVENTOM       = FPA_EVENTOH.NREVENTOM
                          AND MAXEVENTOH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))

        /*ESTRUTURAS*/
        LEFT JOIN ESTRUTURAM ESTRUTLEGALM
            ON (VINCULOH.NRORG         = ESTRUTLEGALM.NRORG
           AND  VINCULOH.NRESTRUTLEGAL = ESTRUTLEGALM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTLEGALH
            ON (ESTRUTLEGALM.NRORG        = ESTRUTLEGALH.NRORG
           AND  ESTRUTLEGALM.NRESTRUTURAM = ESTRUTLEGALH.NRESTRUTURAM
       AND  ESTRUTLEGALH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTLEGALH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTLEGALH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY')))
        LEFT JOIN ESTRUTURAM ESTRUTGERENCM
            ON (VINCULOH.NRORG         = ESTRUTGERENCM.NRORG
           AND  VINCULOH.NRESTRUTGEREN = ESTRUTGERENCM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTGERENCH
            ON (ESTRUTGERENCM.NRORG        = ESTRUTGERENCH.NRORG
           AND  ESTRUTGERENCM.NRESTRUTURAM = ESTRUTGERENCH.NRESTRUTURAM)
       AND  ESTRUTGERENCH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTGERENCH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTGERENCH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))
        LEFT JOIN ESTRUTURAM ESTRUTSINDM
            ON (VINCULOH.NRORG         = ESTRUTSINDM.NRORG
           AND  VINCULOH.NRESTRUTSIND  = ESTRUTSINDM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTSINDH
            ON (ESTRUTSINDM.NRORG        = ESTRUTSINDH.NRORG
           AND  ESTRUTSINDM.NRESTRUTURAM = ESTRUTSINDH.NRESTRUTURAM)
       AND  ESTRUTSINDH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTSINDH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSINDH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))
        JOIN GPE_PESSOA
            ON GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
           AND GPE_VINCULOM.NRORG = GPE_PESSOA.NRORG

        JOIN GPE_PESSOAH
            ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
           AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
           AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(MAX_PESSOAH.DTMESCOMPETENC)
                                               FROM GPE_PESSOAH MAX_PESSOAH
                                              WHERE MAX_PESSOAH.NRPESSOA = GPE_PESSOAH.NRPESSOA
                                                AND MAX_PESSOAH.NRORG = GPE_PESSOAH.NRORG
                                                AND MAX_PESSOAH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))

                /* INFORMAÇÔES BANCÁRIAS*/
        LEFT JOIN CONTCORRPARC
               ON CONTCORRPARC.NRORG = GPE_VINCULOM.NRORG
              AND CONTCORRPARC.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
        LEFT JOIN BANCO
               ON BANCO.CDBANCO = CONTCORRPARC.CDBANCO
              AND (BANCO.NRORG = GPE_VINCULOM.NRORG OR BANCO.NRORG = :P_NRORG_PADRAO)
        LEFT JOIN AGENCIA
               ON AGENCIA.CDAGENCIA = CONTCORRPARC.CDAGENCIA
              AND AGENCIA.CDBANCO   = CONTCORRPARC.CDBANCO
              AND (AGENCIA.NRORG = GPE_VINCULOM.NRORG OR AGENCIA.NRORG = :P_NRORG_PADRAO)

        /*ESTRUTURA SUPERIOR*/
        $joinHierarquia

        /*alteração salarial*/
        /*Rafael Pickbrenner pck - 13/07/2016 - Tarefa 32282*/
        LEFT JOIN GPE_ALTESALARIO ATS ON ATS.NRORG         = GPE_VINCULOM.NRORG
                                     AND ATS.NRVINCULOM    = GPE_VINCULOM.NRVINCULOM
                                     AND ATS.DTALTESALARIO = ( SELECT MAX(DTALTESALARIO) FROM GPE_ALTESALARIO
                                                                WHERE DTALTESALARIO <= LAST_DAY(TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))
                                                                  AND NRORG      = GPE_VINCULOM.NRORG
                                                                  AND NRVINCULOM = GPE_VINCULOM.NRVINCULOM )
                                     AND ATS.NROCORRENCIA  = ( SELECT MAX(NROCORRENCIA) FROM GPE_ALTESALARIO
                                                                WHERE DTALTESALARIO = ATS.DTALTESALARIO
                                                                  AND NRORG      = GPE_VINCULOM.NRORG
                                                                  AND NRVINCULOM = GPE_VINCULOM.NRVINCULOM )
                                     AND ATS.VRSALARIO     = ( SELECT MAX(VRSALARIO) FROM GPE_ALTESALARIO /*Quando o nr de ocorrência repetir ele considera o maior salário*/
                                                                WHERE DTALTESALARIO = ATS.DTALTESALARIO
                                                                  AND NROCORRENCIA  = ATS.NROCORRENCIA
                                                                  AND NRORG         = GPE_VINCULOM.NRORG
                                                                  AND NRVINCULOM    = GPE_VINCULOM.NRVINCULOM )
        LEFT JOIN GPE_TIPOVINCULOM 
               ON GPE_TIPOVINCULOM.NRTIPOVINCULOM = GPE_VINCULOM.NRTIPOVINCULOM
              AND GPE_TIPOVINCULOM.NRORG = :P_NRORG_PADRAO
        LEFT JOIN GPE_TIPOVINCULOH GVH
               ON GVH.NRTIPOVINCULOM = GPE_TIPOVINCULOM.NRTIPOVINCULOM
              AND GVH.NRORG = GPE_TIPOVINCULOM.NRORG
              AND GVH.DTMESCOMPETENC =
                   (SELECT MAX(DTMESCOMPETENC)
                      FROM GPE_TIPOVINCULOH 
                     WHERE NRORG           = GVH.NRORG
                       AND NRTIPOVINCULOM  = GVH.NRTIPOVINCULOM
                       AND DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY'))
        WHERE GPE_VINCULOM.NRORG           = :P_NRORG
      AND VINCULOH.DTMESCOMPETENC <= TO_DATE(:P_COMPETENCIA, 'DD/MM/YYYY')
      AND (CONTCORRPARC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) NRCONTCORRPARC
                                      FROM CONTCORRPARC C
                                     WHERE NRORG = GPE_PESSOA.NRORG
                                       AND NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO) OR CONTCORRPARC.NRCONTCORRPARC IS NULL)
          AND (GPE_VINCULOM.DTADMISSAOVINC <> GPE_VINCULOM.DTRESCISAOVINC OR GPE_VINCULOM.DTRESCISAOVINC IS NOT NULL)
          $condicaoEventos
          $condEstrutLegal
          $condEstrutGeren
          $pertencelote
      ) WHERE 1=1
          $conditions
";
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        
        $query->execute($params);
        
        
        return $query->fetchAll();
    }
    
    public function getWhereFilters($filters) {
     	$whereFilter = " ";
     	foreach ($filters as $filter) {
     	    if($filter['columnName']=='DTADMISSAOVINC')
     	    $whereFilter .= " AND GPE_VINCULOM.DTADMISSAOVINC BETWEEN '".$filter['value'][0]."' AND '".$filter['value'][1]."' ";
     	    else if($filter['columnName']=='DTRESCISAOVINC')
     	    $whereFilter .= " AND GPE_VINCULOM.DTRESCISAOVINC = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRTIPOHIERARQORG')
     	    $whereFilter .= " AND HIERARQUIAORG.NRTIPOHIERARQORG = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRESTRUTSUPERIORM')
            $whereFilter .= " AND ESTRUTSUPERIORM.NRESTRUTURAM = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRESTRUTSIND')
     	    $whereFilter .= " AND GPE_VINCULOH.NRESTRUTSIND = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRVINCULOM')
     	    $whereFilter .= " AND GPE_VINCULOM.NRVINCULOM = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRTIPOVINCULOM')
     	    $whereFilter .= " AND GPE_VINCULOM.NRTIPOVINCULOM = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRTPADMISSAO')
     	    $whereFilter .= " AND GPE_VINCULOM.NRTPADMISSAO = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRTPDEMISSAO')
     	    $whereFilter .= " AND GPE_VINCULOM.NRTPDEMISSAO = '".$filter['value']."' ";
     	    else if($filter['columnName']=='DTINIPERIODO')
     	    $whereFilter .= " AND  <= '".$filter['value']."' ";
     	    else if($filter['columnName']=='DTFIMPERIODO')
     	    $whereFilter .= " AND  >= '".$filter['value']."' ";
     	}

     	return $whereFilter;
 	
    }    
}

