<?php

namespace HCM\Geral\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\DateUtil;

class EsoRemuneracaoEntity extends TkEntity
{
    private $_nrOrg;
    private $_nrOrgPadrao;

    public function __construct($entityManager, $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrg = $this->hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $this->hcmParameters->getNrorgPadrao();
        
        $this->esoRemuneracao = Repositories::ESO_REMUNOUTREMPR;
        
        parent::__construct(null, $entityManager);
    }

    
    public function retornaRemuneracaoOutrasFontes($cpf, $mesCompetencia) {
        try {
            return $this->entityManager->getRepository(Repositories::ESO_REMUNOUTREMPR)->retornaRemuneracaoOutrasFontes($this->_nrOrg, $cpf, $mesCompetencia);
        } catch (\Exception $e) {
            throw $e->getMessage();
        }
    }  
    
     public function persisteRegistro(
        $nrOrg, $cpf, $mesCompetencia, $nrPessoa, $nrtipomoviment, $cdcodcateg, $vrremunoutrempr, $cdinscoutrempr
    ){
       /* $item = $this->entityManager->getRepository(Repositories::ESO_REMUNOUTREMPR)->retornaRemuneracaoOutrasFontes(
            $this->_nrOrg, $cpf, $mesCompetencia
        );*/

        if ($item) {
            //$item->setDslinharegistro($linha);
        } else {
            $item = new $this->esoRemuneracao;
            
            $item->setNrremunoutrempr(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'ESO_REMUNOUTREMPR', 1, 12, true));
            $item->setIdativo('S');
            $item->setNrorg($nrOrg);
            $item->setNrpessoa($nrPessoa);
            $item->setNrtipomoviment($nrtipomoviment);
            $item->setDtmescompetenc($mesCompetencia);
            $item->setCdcodcateg($cdcodcateg);
            $item->setVrremunoutrempr($vrremunoutrempr);
            $item->setCdinscoutrempr($cdinscoutrempr);
            
            $item->setDtinclusao(DateUtil::getDataAtual());
            $item->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
            $item->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $item->setDtultatu(DateUtil::getDataAtual());
            $item->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $item->setCdoperultatu($this->hcmParameters->getCdoperador());
        }
        
        $this->entityManager->persist($item);
        $this->entityManager->flush($item);
    }

}
















