<?php

namespace HCM\Geral\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\MsgCalculo;

class GpeParamestrutmEntity extends TkEntity
{
    private $_nrOrg;
    private $_mesCompetencia;
    private $_paramEstrutura;
    private $_nrEstruturaAnterior;

    public function __construct($entityManager, $hcmParameters) {
         
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrg = $this->hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $this->hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $this->hcmParameters->getDtCompetencia();
        parent::__construct(null, $entityManager);
    }
    
    public function insereParametrosEstrutura($nrorg, $nrestruturam, $dtinivigencia) {
        $this->setNrorg($nrorg);
        $this->setNrestruturam($nrestruturam);
        $this->setDtinivigencia($dtinivigencia);
    }

    public function getParamEstrutura() {
        return $this->_paramEstrutura;
    }

    public function getNrParamFolha(){
        if (is_object($this->_paramEstrutura) == true) {
			if ($this->_paramEstrutura->historico){
				return $this->_paramEstrutura->historico->getNrparamfolham();
			}	
        }
    }

    public function getNrParamFerias(){
        if (is_object($this->_paramEstrutura) === true) {
			if ($this->_paramEstrutura->historico){
				return $this->_paramEstrutura->historico->getNrparamferiasm();
			}	
        }
    }

    public function carregaParametrosEstrutra($nrEstrutura){
        try {
            if ($this->_nrEstruturaAnterior !== $nrEstrutura) {
                $posicao = $this->_procuraParametroEstrutura($nrEstrutura);
                if ($posicao === -1) {
                    $this->_paramEstrutura = $this->entityManager->getRepository(Repositories::GPE_PARAMESTRUTM)->retornaParametrosEstrutura(
                        $this->_nrOrg, $this->_mesCompetencia, $nrEstrutura
                    );
                    if (is_object($this->_paramEstrutura) === true) {
                        $this->addItem($this->_paramEstrutura);
                        $this->_nrEstruturaAnterior = $nrEstrutura;
                    } else {
                        MsgCalculo::getInstance()->adicionaMensagem('Não encontrado registro de Parametro de Estrutura para a organização '.$this->_nrOrg,MsgCalculo::ERRO);
                    }
                } else {
                    $this->_paramEstrutura = $this->getItem($posicao);
                    
                    if (is_object($this->_paramEstrutura) === false) {
                        MsgCalculo::getInstance()->adicionaMensagem('Não encontrado registro de Parametro de Estrutura para a organização '.$this->_nrOrg,MsgCalculo::ERRO);
                    }
                }
            }
        } catch (Exception $e){
            throw  $e;
        }
    }

    private function _procuraParametroEstrutura($nrEstrutura) {
        $itens = $this->getItems();
        foreach ($itens as $key=>$item) {
            if (($item->getNrorg() === $this->_nrOrg) && ($item->getNrestruturam() === $nrEstrutura)) {
                return $key;
            }
        }
        return -1;
    }
}

