<?php
namespace HCM\Geral\Repository\Esocial;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class S2399Repository {

    protected  $connection;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function getItensParaEnvioS2399($params) {
        $sql = <<<SQL
SELECT VH.NRVINCULOM as NRCHAVE,
       VH.NRVINCULOM,
       'I' as IDOPERACAO,
       NVL(MS.DTFIMMOVIMENT,VM.DTRESCISAOVINC) as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT * FROM(SELECT H1.DTMESCOMPETENC FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  ORDER BY H1.DTMESCOMPETENC DESC)WHERE ROWNUM = 1)
   LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                          AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                          AND EH.DTMESCOMPETENC = (SELECT * FROM(SELECT H1.DTMESCOMPETENC FROM ESTRUTURAH H1
                                                     WHERE H1.NRORG = EH.NRORG
                                                       AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                       AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       ORDER BY H1.DTMESCOMPETENC DESC)WHERE ROWNUM = 1)
   /*Transferencia de saida*/
   LEFT JOIN GPE_MOVIMENTACAO MS ON MS.NRORG = VM.NRORG
                                AND MS.NRVINCULOM = VM.NRVINCULOM
                                AND MS.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                AND MS.NRTPMOVTRANSFM = 9
                                AND MS.DTFIMMOVIMENT BETWEEN ADD_MONTHS(:P_DTMESCOMPETENC, '-1') AND LAST_DAY(:P_DTMESCOMPETENC)
   LEFT JOIN ESTRUTURAH ES ON ES.NRORG = MS.NRORG
                          AND ES.NRESTRUTURAM = MS.NRESTRUTURAM
                          AND ES.DTMESCOMPETENC = (SELECT * FROM(SELECT H1.DTMESCOMPETENC FROM ESTRUTURAH H1
                                                     WHERE H1.NRORG = ES.NRORG
                                                       AND H1.NRESTRUTURAM = ES.NRESTRUTURAM
                                                       AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       ORDER BY H1.DTMESCOMPETENC DESC)WHERE ROWNUM = 1)
   /*Transferencia de entrada*/
   LEFT JOIN GPE_MOVIMENTACAO ME ON ME.NRORG = MS.NRORG
                                AND ME.NRVINCULOM = MS.NRVINCULOM
                                AND ME.NRTIPOTRANSFER = MS.NRTIPOTRANSFER
                                AND ME.NRTIPOESTRUTURA = MS.NRTIPOESTRUTURA
                                AND ME.NRTPMOVTRANSFM = 8
                                AND ME.DTINIMOVIMENT > MS.DTFIMMOVIMENT
   LEFT JOIN ESTRUTURAH EE ON EE.NRORG = ME.NRORG
                          AND EE.NRESTRUTURAM = ME.NRESTRUTURAM
                          AND EE.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                     WHERE H1.NRORG = EE.NRORG
                                                       AND H1.NRESTRUTURAM = EE.NRESTRUTURAM
                                                       AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   /*Rescindidos ou transferidos para outro empregador*/
   AND ((SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.'),'/'),'-'),1,8) = SUBSTR(REPLACE(REPLACE(REPLACE(:P_CDCNPJEMPREGADOR,'.'),'/'),'-'),1,8) AND VM.DTRESCISAOVINC BETWEEN ADD_MONTHS(:P_DTMESCOMPETENC, '-1') AND LAST_DAY(:P_DTMESCOMPETENC)) OR
        (MS.NRMOVIMENTACAO IS NOT NULL AND SUBSTR(REPLACE(REPLACE(REPLACE(EE.CDCNPJESTRUT,'.'),'/'),'-'),1,8) <> SUBSTR(REPLACE(REPLACE(REPLACE(ES.CDCNPJESTRUT,'.'),'/'),'-'),1,8)))
   AND (EXISTS (SELECT 1 
                 FROM FPA_ITECALCFOLHA ITC
                 JOIN FPA_CALCULOFOLHA CFL ON CFL.NRORG = ITC.NRORG
                                          AND CFL.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                          AND CFL.NRTIPOMOVIMENT = 1
                                          AND CFL.NRTPMODALIDCAL = 1
            LEFT JOIN ESO_PARAMETRO ESOPARAMS ON ESOPARAMS.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                             AND ESOPARAMS.NRORG = VH.NRORG 
                WHERE ITC.NRVINCULOM = VH.NRVINCULOM
                  AND ITC.NRORG = VH.NRORG
                  AND ITC.NREVENTOM = '3050'
                  AND CFL.DTOCORRENCIA = (SELECT MAX(CF.DTOCORRENCIA)
                                            FROM FPA_ITECALCFOLHA IT
                                            JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                                                    AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                                                    AND CF.NRTIPOMOVIMENT = 1
                                                                    AND CF.NRTPMODALIDCAL = 1
                                           WHERE IT.NRORG      = ITC.NRORG
                                             AND IT.NRVINCULOM = ITC.NRVINCULOM
                                             AND IT.NREVENTOM = '3050'
                                             AND IT.DTOCORRENCIA <= ADD_MONTHS(LAST_DAY(VM.DTRESCISAOVINC),1)) 
                  AND((ESOPARAMS.IDAPROVACALCRESC = 'S'AND EXISTS(SELECT 1
                                                                    FROM FPA_ITECALCFOLHA ITFEC 
                                                                   WHERE ITFEC.NRORG = ITC.NRORG
                                                                     AND ITFEC.NRVINCULOM = ITC.NRVINCULOM
                                                                     AND ITFEC.NREVENTOM = 3035
                                                                     AND ITFEC.NRCALCULOFOLHA = CFL.NRCALCULOFOLHA)) OR NVL(ESOPARAMS.IDAPROVACALCRESC, 'N') = 'N')) OR MS.DTFIMMOVIMENT IS NOT NULL)
   AND VM.NRTIPOVINCULOM IN (2,3,10) --Estagiario, Socio, Autonomo
   AND (VM.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL)
   AND (NVL(MS.DTFIMMOVIMENT,VM.DTRESCISAOVINC) >= :P_DTREFNAOPERIOD OR :P_DTREFNAOPERIOD IS NULL)
 ORDER BY 4,1
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_CDCNPJEMPREGADOR" => isset($params['CDCNPJEMPREGADOR']) ? $params['CDCNPJEMPREGADOR'] : null,
            "P_NRTPAMBIENTE" => isset($params['NRTPAMBIENTE']) ? $params['NRTPAMBIENTE'] : null,
            "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
            "P_NRVINCULOM" => isset($params['NRVINCULOM']) ? $params['NRVINCULOM'] : null,
            "P_DTREFNAOPERIOD" => isset($params['DTREFNAOPERIOD']) ? $params['DTREFNAOPERIOD'] : null,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS2399($params) {
        try {
            $dados = $this->getDadosPrincipais($params['NRENVIO'], $params['NRCHAVE'], $params['NRESTRUTURAM'], $params['NRTPAMBIENTE']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosPrincipais($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
/*getDadosS2399*/
SELECT VM.NRVINCULOM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR ET.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR ET.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --ideTrabSemVinculo
       REPLACE(REPLACE(PH.NRCPFPESSOA,'.'),'-') AS CPFTRAB,
       DECODE(NP.NRENVIO,NULL,NULL,NVL(VH.CDMATRICULAESOCIAL, VM.NRVINCULOM)) matricula,
       DECODE(NP.NRENVIO,NULL,CE.CDESOCIAL,NULL) codCateg,
       --infoTSVTermino
       TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM-DD') dtTerm,
       DECODE(CE.CDESOCIAL,'721',TD.CDESOCIAL,'') mtvDesligTSV,
       CASE WHEN CE.CDESOCIAL IN ('201','202','721') THEN '0' ELSE '' END pensAlim,
       '' percAliment,
       '' vrAlim,
       '' nrProcTrab,
       --dmDev getDadosS2399dmDev       
       --ideEstabLot getDadosS2399ideEstabLot       
       --detVerbas getDadosS2399detVerbas       
       --detOper getDadosS2399detOper       
       --detPlano getDadosS2399detPlano       
       --procJudTrab getDadosS2399procJudTrab       
       --infoMV
       --getDadosS2399remunOutrEmpr
       DECODE(OV.VREVENTOFOLHA, NULL, '', DECODE(VH.IDMULTVINC, 'PRIMARIO', '1', '3')) indMV,
       null dtFimQuar,
       VM.NRORG, VM.NRVINCULOM, VM.DTRESCISAOVINC, VM.NRPESSOA, PE.NRPARCNEGOCIO, VH.NRESTRUTLEGAL, VH.NRESTRUTGEREN, CE.CDESOCIAL CDCATEGTRAB, 
       DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMP.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR) INIVALIDADEAMB, :P_DTMESCOMPETENC DTMESCOMPETENC,
       VH.NRAGENTENOCIVO, VM.NRTIPOVINCULOM
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.NRORG = VM.NRORG
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND GPE_VINCULOH.NRVINCULOM = VH.NRVINCULOM
                                                  AND GPE_VINCULOH.NRORG = VH.NRORG)
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Dados do Empregado - Pessoa*/
  JOIN GPE_PESSOA PE ON VM.NRPESSOA = PE.NRPESSOA
                    AND VM.NRORG    = PE.NRORG
  JOIN GPE_PESSOAH PH ON PE.NRPESSOA = PH.NRPESSOA
                     AND PE.NRORG    = PH.NRORG
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                               WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND GPE_PESSOAH.NRPESSOA = PH.NRPESSOA
                                                 AND GPE_PESSOAH.NRORG = PH.NRORG)
  /*Tipo Demissao*/                   
  JOIN FPA_TPDEMISSAO TD ON VM.NRTPDEMISSAO = TD.NRTPDEMISSAO
                        AND (TD.NRORG = :P_NRORG OR TD.NRORG = 0)
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = VH.NRORG
                     AND EMP.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH ET ON ET.NRORG = EMP.NRORG
                         AND ET.NRESTRUTURAM = EMP.NRESTRUTURAM
                         AND ET.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                   WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                     AND ESTRUTURAH.NRESTRUTURAM = ET.NRESTRUTURAM
                                                     AND ESTRUTURAH.NRORG = ET.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = ET.NRPARCNEGOCIO
                      AND PAR.NRORG = ET.NRORG
  /*Remuneração Outra Empresa*/
  LEFT JOIN (SELECT OV.NRORG, OV.NRVINCULOM, OV.NRPESSOA, SUM(ITC.VREVENTOFOLHA) VREVENTOFOLHA
               FROM GPE_VINCULOM OV
               JOIN FPA_ITECALCFOLHA ITC ON ITC.NRORG = OV.NRORG
                                        AND ITC.NRVINCULOM = OV.NRVINCULOM
                                        AND ITC.NREVENTOM = 3050
                                        AND ITC.VREVENTOFOLHA > 0
               JOIN FPA_CALCULOFOLHA CF ON CF.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                       AND CF.NRORG = ITC.NRORG
                                       AND CF.NRTIPOMOVIMENT = 1
                                       AND CF.NRTPMODALIDCAL = 1
                                       AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
              WHERE OV.NRORG = :P_NRORG
                --AND OV.NRVINCULOM = P_NRCHAVE
              GROUP BY OV.NRORG, OV.NRVINCULOM, OV.NRPESSOA) OV ON OV.NRORG = VM.NRORG
                                                               AND OV.NRPESSOA = VM.NRPESSOA
                                                               AND OV.NRVINCULOM <> VM.NRVINCULOM
  /*Envio do S2300 na versão S-1.0*/
  LEFT JOIN ESO_NAOPERIODICO NP ON NP.NRORG = VM.NRORG
                               AND NP.NRVINCULOM = VM.NRVINCULOM
                               AND NP.NMEVENTO = 'S-2300'
                               AND NP.IDATIVO = 'S'
                               AND (NP.IDSTATUS = 'C' OR NP.IDSTATUS = 'A')
                               AND NP.NRENVIOEXCL IS NULL
                               AND NP.NRTPAMBIENTE = :P_NRTPAMBIENTE
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRTIPOVINCULOM IN (2,3,10) --Estagiario, Socio, Autonomo
   AND VM.NRVINCULOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidPeriodProducao(),
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidPeriodProdRest(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidPeriodNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    public function getDadosS2399dmDev($params) {
        try {
            // A partir da versão 1.0 as verbas rescisórias do S-2399 só deve ser informada para a categoria 721 (diretor com fgts). Outras categorias de TSV é informado no S-1200.
            if ($params['CDCATEGTRAB'] == '721') {
                $dados = $this->getDadosDmDev(
                    $params['NRORG'], $params['NRVINCULOM'], $params['DTRESCISAOVINC'], $params['NRESTRUTLEGAL'], $params['NRESTRUTGEREN'], $params['CDCATEGTRAB'], $params['INIVALIDADEAMB'], $params['DTMESCOMPETENC'], $params['NRAGENTENOCIVO'], $params['NRTIPOVINCULOM']
                );
                return $dados;
            } else {
                return array();
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosDmDev($nrorg, $nrvinculom, $dtrescisao, $nrestrutlegal, $nrestrutgeren, $cdcategtrab, $inivalidadeamb, $dtmescompetenc, $nragentenocivo, $nrtipovinculom) {
        $sql = <<<SQL
/*getDadosS2399dmDev*/
SELECT :P_NRTIPOVINCULOM||'.'||:P_CDCATEGTRAB||'.'||ITC.NRCALCULOFOLHA AS ideDmDev,
       ITC.NRORG, ITC.NRVINCULOM, ITC.NRCALCULOFOLHA, :P_NRESTRUTLEGAL NRESTRUTLEGAL, :P_NRESTRUTGEREN NRESTRUTGEREN, :P_CDCATEGTRAB CDCATEGTRAB, :P_DTMESCOMPETENC DTMESCOMPETENC, :P_NRAGENTENOCIVO NRAGENTENOCIVO
  FROM FPA_ITECALCFOLHA ITC
  JOIN FPA_CALCULOFOLHA CFL ON CFL.NRORG = ITC.NRORG
                           AND CFL.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                           AND CFL.NRTIPOMOVIMENT IN (1,4,10,19)
                           AND CFL.NRTPMODALIDCAL = 1
 WHERE ITC.NRVINCULOM = :P_NRCHAVE
   AND ITC.NRORG = :P_NRORG
   AND ((CFL.NRTIPOMOVIMENT = 1 AND ITC.NREVENTOM = '3050' AND CFL.DTOCORRENCIA = (SELECT MAX(CF.DTOCORRENCIA)
                                                                                     FROM FPA_ITECALCFOLHA IT
                                                                                     JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                                                                                             AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                                                                                             AND CF.NRTIPOMOVIMENT = CFL.NRTIPOMOVIMENT
                                                                                                             AND CF.NRTPMODALIDCAL = 1
                                                                                    WHERE IT.NRORG      = ITC.NRORG
                                                                                      AND IT.NRVINCULOM = ITC.NRVINCULOM
                                                                                      AND IT.NREVENTOM = ITC.NREVENTOM
                                                                                      AND CF.DTOCORRENCIA <= FIRST_DAY(:P_DTRESCISAOVINC)))
        OR (CFL.NRTIPOMOVIMENT = 10 AND ITC.NREVENTOM = '3030' AND CFL.DTOCORRENCIA = FIRST_DAY(:P_DTRESCISAOVINC))
        OR (CFL.NRTIPOMOVIMENT = 19 AND ITC.NREVENTOM = '3030' AND CFL.DTOCORRENCIA = FIRST_DAY(:P_DTRESCISAOVINC))
        OR (CFL.NRTIPOMOVIMENT = 4 AND ITC.NREVENTOM = '3030' AND CFL.DTOCORRENCIA = FIRST_DAY(:P_DTRESCISAOVINC) AND SUBSTR(CFL.DTOCORRENCIA, 3, 2) <> '12'))
   AND TO_DATE(:P_DTRESCISAOVINC) >= :P_INIVALIDADEAMB
   AND EXISTS (/*getDadosS2399detVerbas*/
               SELECT 1
                 FROM FPA_ITECALCFOLHA IT
                 JOIN FPA_CALCULOFOLHA CF ON IT.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                         AND IT.NRORG = CF.NRORG
                 JOIN FPA_EVENTOH EH ON EH.NREVENTOM = IT.NREVENTOM
                                    AND (EH.NRORG = :P_NRORG OR EH.NRORG = 0)
                                    AND EH.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                               WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                 AND EHH.NREVENTOM = EH.NREVENTOM
                                                                 AND EHH.NRORG = EH.NRORG)
                 /*Natureza da Rubrica*/
                 JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
                WHERE IT.NRORG = ITC.NRORG
                  AND IT.NRVINCULOM = ITC.NRVINCULOM
                  AND IT.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                  AND IT.VREVENTOFOLHA > 0
                  AND ((IT.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
                  AND (SELECT NVL(MAX(INC.CDESOCIAL),'00')
                         FROM FPA_INCIDEVENTO IE
                         JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                                               AND INSTR(','||TI.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                         JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                        WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                          AND IE.NREVENTOM = IT.NREVENTOM
                          AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                     FROM FPA_GRPITEM 
                                                    WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)) NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) /*codIncIRRF*/)
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRCHAVE" => $nrvinculom,
            "P_DTRESCISAOVINC" => $dtrescisao,
            "P_NRESTRUTLEGAL" => $nrestrutlegal,
            "P_NRESTRUTGEREN" => $nrestrutgeren,
            "P_CDCATEGTRAB" => $cdcategtrab,
            "P_INIVALIDADEAMB" => $inivalidadeamb,
            "P_NRAGENTENOCIVO" => $nragentenocivo,
            "P_NRTIPOVINCULOM" => $nrtipovinculom,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS2399ideEstabLot($params) {
        try {
            $dados = $this->getDadosideEstabLot($params['NRORG'], $params['NRVINCULOM'], $params['NRCALCULOFOLHA'], $params['NRESTRUTLEGAL'], $params['NRESTRUTGEREN'], $params['CDCATEGTRAB'], $params['DTMESCOMPETENC'], $params['NRAGENTENOCIVO']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosideEstabLot($nrorg, $nrvinculom, $nrcalculofolha, $nrestrutlegal, $nrestrutgeren, $cdcategtrab, $dtmescompetenc, $nragentenocivo) {
        $sql = <<<SQL
/*getDadosS2399ideEstabLot*/
SELECT DISTINCT
       DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') AS tpInsc,
       REPLACE(REPLACE(REPLACE(PN.NRINSCRICAOPARC,'.',''),'-',''),'/','') nrInsc,
       DECODE(:P_CDCATEGTRAB, '901', EM.NRESTRUTURAM, NVL(EMSUP.NRESTRUTURAM, EM.NRESTRUTURAM)) AS codLotacao,
       DECODE(NVL(CTSUP.CDESOCIAL,CT.CDESOCIAL),'01','1','02','2','03','3','') AS indSimples,
       EM.NRORG, :P_NRVINCULOM NRVINCULOM, :P_NRCALCULOFOLHA NRCALCULOFOLHA,
       (SELECT DECODE(NVL(SUM(IC.VREVENTOFOLHA),0),0,0,1) IDDETOPER
          FROM FPA_ITECALCFOLHA IC
          JOIN FPA_EVENTOH EVH ON (EVH.NRORG = IC.NRORG OR EVH.NRORG = 0)
                              AND EVH.NREVENTOM = IC.NREVENTOM
          JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EVH.NRNATURUBR
         WHERE IC.NRORG = :P_NRORG
           AND IC.NRVINCULOM = :P_NRVINCULOM
           AND IC.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
           AND NR.CDESOCIAL = '9219') IDDETOPER /*existe desconto de assistencia medica*/,
           :P_DTMESCOMPETENC DTMESCOMPETENC
  FROM ESTRUTURAM EM
  LEFT JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC) FROM ESTRUTURAH EHH
                                              WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND EHH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND EHH.NRORG = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRORG = EM.NRORG
                     AND PN.NRPARCNEGOCIO = EM.NRPARCNEGOCIO
  LEFT JOIN CLASSTRIBUT CT ON CT.NRCLASSTRIBUT = EH.NRCLASSTRIBUT
  /*Tomador superior da estrutura gerencial*/
  LEFT JOIN TIPOHIERARQORG TH ON (TH.NRORG = EM.NRORG OR TH.NRORG = 0)
                             AND TH.NRTIPOESTRUTREL = :P_NRTIPOESTRUTGEREN
                             AND TH.NRTIPOESTRUTSUP = NVL(:P_NRTIPOESTRUTOMADOR, 7)
  LEFT JOIN HIERARQUIAORG HO ON HO.NRORG = EM.NRORG
                            AND HO.NRTIPOHIERARQORG = TH.NRTIPOHIERARQORG
                            AND HO.NRESTRUTURAMREL = :P_NRESTRUTGEREN
                            AND HO.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                            AND (HO.DTFIMVIGENCIA IS NULL OR HO.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                            AND HO.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA)
                                                      FROM HIERARQUIAORG HI
                                                     WHERE HI.NRORG = HO.NRORG
                                                       AND HI.NRESTRUTURAMREL = HO.NRESTRUTURAMREL
                                                       AND NRTIPOHIERARQORG = HO.NRTIPOHIERARQORG
                                                       AND HI.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                                                       AND (HI.DTFIMVIGENCIA IS NULL OR HI.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                                                       AND EM.DTINIVIGENCIA <= :P_DTMESCOMPETENC)
  LEFT JOIN ESTRUTURAM EMSUP ON EMSUP.NRESTRUTURAM = HO.NRESTRUTURAMSUP
                            AND EMSUP.NRORG = HO.NRORG
  LEFT JOIN ESTRUTURAH EHSUP ON EHSUP.NRESTRUTURAM = EMSUP.NRESTRUTURAM
                            AND EHSUP.NRORG = EMSUP.NRORG
                            AND EHSUP.DTMESCOMPETENC = (SELECT MAX(EHHSUP.DTMESCOMPETENC) FROM ESTRUTURAH EHHSUP
                                                         WHERE EHHSUP.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND EHHSUP.NRESTRUTURAM = EH.NRESTRUTURAM
                                                           AND EHHSUP.NRORG = EH.NRORG)
  LEFT JOIN PARCNEGOCIO PNSUP ON PNSUP.NRPARCNEGOCIO = EMSUP.NRPARCNEGOCIO
                             AND PNSUP.NRORG = EMSUP.NRORG
  LEFT JOIN CLASSTRIBUT CTSUP ON CTSUP.NRCLASSTRIBUT = EHSUP.NRCLASSTRIBUT
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRESTRUTLEGAL
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "P_NRTIPOESTRUTOMADOR" => $this->hcmParameters->getTipoEstruturaTomadorOrg(),
            "P_NRVINCULOM" => $nrvinculom,
            "P_NRCALCULOFOLHA" => $nrcalculofolha,
            "P_NRESTRUTLEGAL" => $nrestrutlegal,
            "P_NRESTRUTGEREN" => $nrestrutgeren,
            "P_CDCATEGTRAB" => $cdcategtrab,
            "P_NRAGENTENOCIVO" => $nragentenocivo,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS2399detVerbas($params) {
        try {
            $dados = $this->getDadosdetVerbas($params['NRORG'], $params['NRVINCULOM'], $params['NRCALCULOFOLHA'], $params['DTMESCOMPETENC']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosdetVerbas($nrorg, $nrvinculom, $nrcalculofolha, $dtmescompetenc) {
        $sql = <<<SQL
/*getDadosS2399detVerbas*/
SELECT ITC.NREVENTOM AS codRubr,
       CASE WHEN TO_NUMBER(TO_CHAR(CF.DTOCORRENCIA,'MM')) BETWEEN 1 AND 11 AND CF.NRTIPOMOVIMENT = 4 THEN 22 ELSE CF.NRTIPOMOVIMENT END AS ideTabrubr,
       ROUND(DECODE(ITC.VRREFFOLHA, 0, '', ITC.VRREFFOLHA),2) AS qtdRubr,
       DECODE(EH.VRPERCENTUALEVENTO, 0, '', ROUND(EH.VRPERCENTUALEVENTO,2)) AS fatorRubr,
       ROUND(ITC.VREVENTOFOLHA,2) AS vrRubr,
       '0' indApurIR,
       ITC.NRORG, ITC.NRVINCULOM, ITC.NRCALCULOFOLHA, :P_DTMESCOMPETENC DTMESCOMPETENC
  FROM FPA_ITECALCFOLHA ITC
  JOIN FPA_CALCULOFOLHA CF ON ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                          AND CF.NRORG = ITC.NRORG
  JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                     AND (EH.NRORG = :P_NRORG OR EH.NRORG = 0)
                     AND EH.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND EHH.NREVENTOM = EH.NREVENTOM
                                                  AND EHH.NRORG = EH.NRORG)
  /*Natureza da Rubrica*/
  JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
 WHERE ITC.NRORG = :P_NRORG
   AND ITC.NRVINCULOM = :P_NRCHAVE
   AND ITC.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
   AND ITC.VREVENTOFOLHA > 0
   AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
   AND (SELECT NVL(MAX(INC.CDESOCIAL),'00')
          FROM FPA_INCIDEVENTO IE
          JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                                AND INSTR(','||TI.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
          JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
         WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
           AND IE.NREVENTOM = ITC.NREVENTOM
           AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                      FROM FPA_GRPITEM 
                                     WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)) NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) /*codIncIRRF*/
 ORDER BY ITC.NREVENTOM
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRCHAVE" => $nrvinculom,
            "P_NRCALCULOFOLHA" => $nrcalculofolha
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS2399procJudTrab($params) {
        try {
            $dados = $this->getDadosprocJudTrab($params['NRORG'], $params['NRESTRUTURAM'], $params['NRPARCNEGOCIO']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
     public function getDadosprocJudTrab($nrorg, $nrestrutura, $nrparcnegocio) {
        $sql = <<<SQL
/*getDadosS2399procJudTrab*/
SELECT AD.CDESOCIAL AS tpTrib,
       PA.NRPROCESSADMJUD AS nrProcJud,
       IPA.NRSUSPEXIGITPROC AS codSusp
  FROM GPE_PROCESSADMJUD PA
  JOIN GPE_ITEMPROCADMJUD IPA ON PA.NRORG = IPA.NRORG
                             AND PA.NRPROCESSADMJUD = IPA.NRPROCESSADMJUD
  LEFT JOIN GPE_ABDECISAO AD ON (AD.NRORG = IPA.NRORG OR AD.NRORG = 0)
                            AND AD.NRABDECISAO = IPA.NRABDECISAO
 WHERE PA.NRORG = :P_NRORG
   AND PA.NRESTRUTURAM = :P_NRESTRUTURAM
   AND PA.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestrutura,
            "P_NRPARCNEGOCIO" => $nrparcnegocio,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS2399remunOutrEmpr($params) {
        try {
            if (!is_null($params['INDMV'])) {
                $dados = $this->getDadosremunOutrEmpr($params['NRORG'], $params['NRVINCULOM'], $params['NRPESSOA'], $params['DTMESCOMPETENC']);
            } else {
                $dados = array();
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosremunOutrEmpr($nrorg, $nrvinculom, $nrPessoa, $dtmescompetenc) {
        $sql = <<<SQL
/*getDadosS2399remunOutrEmpr*/
SELECT DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') AS tpInsc,
       PN.NRINSCRICAOPARC nrInsc,
       CE.CDESOCIAL AS codCateg,
       ITC.VREVENTOFOLHA AS vlrRemunOE,
       :P_DTMESCOMPETENC DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.NRORG = VM.NRORG
                      AND VH.DTMESCOMPETENC = (SELECT * FROM(SELECT GPE_VINCULOH.DTMESCOMPETENC
                                                 FROM GPE_VINCULOH
                                                WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND GPE_VINCULOH.NRVINCULOM = VH.NRVINCULOM
                                                  AND GPE_VINCULOH.NRORG = VH.NRORG
                                                  ORDER BY GPE_VINCULOH.DTMESCOMPETENC DESC)WHERE ROWNUM = 1)
  /*Outro Empregador*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VM.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM    = EM.NRESTRUTURAM
                    AND EH.NRORG          = EM.NRORG
                    AND EH.DTMESCOMPETENC =
                      (SELECT MAX(EHH.DTMESCOMPETENC)
                      FROM ESTRUTURAH EHH
                      WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                      AND EHH.NRESTRUTURAM      = EH.NRESTRUTURAM
                      AND EHH.NRORG             = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRORG             = EM.NRORG
                     AND PN.NRPARCNEGOCIO    = EM.NRPARCNEGOCIO
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Remuneração Outra Empresa*/
  JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, SUM(ITC.VREVENTOFOLHA) VREVENTOFOLHA
          FROM FPA_ITECALCFOLHA ITC
          JOIN FPA_CALCULOFOLHA CF ON CF.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                  AND CF.NRORG = ITC.NRORG
                                  AND CF.NRTIPOMOVIMENT = 1
                                  AND CF.NRTPMODALIDCAL = 1
                                  AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
         WHERE ITC.NRORG = :P_NRORG
           AND ITC.NREVENTOM = 3050
           AND ITC.VREVENTOFOLHA > 0
         GROUP BY ITC.NRORG, ITC.NRVINCULOM) ITC ON ITC.NRORG = VM.NRORG
                                                AND ITC.NRVINCULOM = VM.NRVINCULOM
 WHERE VM.NRPESSOA = :P_NRPESSOA
   AND VM.NRORG = :P_NRORG
   AND VM.NRVINCULOM != :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRCHAVE" => $nrvinculom,
            "P_NRPESSOA" => $nrPessoa
        );
        return $this->connection->fetchAll($sql, $params);
    }

}