<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;

class MonitEsocialRepository {

    protected  $connection;
    
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        
    }
    
    public function getMonitEsocial($filters, $params){
        
        $conditions = "";
        
        foreach ($filters as $filter) {
            if($filter["columnName"] != "NRORG" && $filter["columnName"] != "id"){
                if($filter["columnName"] == "DTHRINICIO" || $filter["columnName"] == "DTHRFIM"){
                    $inicioParameter = $filter['columnName'].'_INICIO';
                    $fimParameter = $filter['columnName'].'_FIM';
                    $conditions .= " AND A.{$filter['columnName']} BETWEEN :{$inicioParameter} AND :{$fimParameter} ";
                    
                    $inicio = $fim = "";
                    
                    if(is_array($filter["value"])) {
                        $inicio = $filter["value"][0]; 
                        $fim = $filter["value"][1];
                    } else {
                        $inicio = $filter["value"];
                    }
                    $params[$inicioParameter] = DateUtil::getDataDeString($inicio, DateUtil::FORMATO_BRASILEIRO, true)->format('d/m/Y H:i:s');
                    $params[$fimParameter] = empty($fim) ? DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($filter["value"]))->format('d/m/Y 23:59:59') : DateUtil::getDataDeString($fim)->format('d/m/Y 23:59:59');
                }else{
                    $columnName = $filter['columnName'];
                    $conditions .= " AND A.{$columnName} {$filter['operator']} :{$columnName}";
                    $params[$columnName] = $filter['value'];
                }
            }
        }
        
		$query = "
		SELECT * FROM(
    		SELECT 
                DECODE(NVL(CC.DSPIDPROCESSO,'X'), 'X', 'N', 'S') AS IDLOTE ,
                --Tempo Executando
                DECODE(CC.IDSITUACAO, 'ANDAMENTO', TO_CHAR(TRUNC(((SYSDATE - CC.DTHRINICIO) * 86400)/3600),'FM9900')
                || ':' || TO_CHAR(TRUNC(MOD(((SYSDATE - CC.DTHRINICIO) * 86400),3600)/60),'FM00')
                || ':' || TO_CHAR(MOD(((SYSDATE - CC.DTHRINICIO) * 86400),60),'FM00'), 
                --Tempo Total
                (TO_CHAR(TRUNC(((NVL(CC.DTHRFIM,CC.DTULTATU) - CC.DTHRINICIO) * 86400)/3600),'FM9900') 
                || ':' || TO_CHAR(TRUNC(MOD(((NVL(CC.DTHRFIM,CC.DTULTATU) - CC.DTHRINICIO) * 86400),3600)/60),'FM00') 
                || ':' || TO_CHAR(MOD(((NVL(CC.DTHRFIM,CC.DTULTATU) - CC.DTHRINICIO) * 86400),60),'FM00'))
                ) AS DTHREXEC,    
                -- Tempo estimado
                DECODE(CC.IDSITUACAO, 'ANDAMENTO', TO_CHAR(TRUNC(((((SYSDATE - CC.DTHRINICIO) * 86400 / DECODE(CC.NRTOTPROCESS,0,1,CC.NRTOTPROCESS)) * (CC.NRTOTENVIOS - CC.NRTOTPROCESS))/3600)),'FM9900')
                || ':' || TO_CHAR(TRUNC(MOD((((SYSDATE - CC.DTHRINICIO) * 86400 / DECODE(CC.NRTOTPROCESS,0,1,CC.NRTOTPROCESS)) * (CC.NRTOTENVIOS - CC.NRTOTPROCESS)),3600)/60),'FM00')
                || ':' || TO_CHAR(MOD((((SYSDATE - CC.DTHRINICIO) * 86400 / DECODE(CC.NRTOTPROCESS,0,1,CC.NRTOTPROCESS)) * (CC.NRTOTENVIOS - CC.NRTOTPROCESS)),60),'FM00'), NULL) AS DTHRESTIMADO,    
                -- Porcentagem do calculo
                ROUND(((CC.NRTOTPROCESS+NVL(CC.NRERRPROCESS,0)) / DECODE(CC.NRTOTENVIOS,0,1,CC.NRTOTENVIOS)) * 100, 2) || '%' AS PERCENTCON,    
                CC.*
            FROM ESO_CONSUMER CC
		) A WHERE A.NRORG = :P_NRORG
		
		".$conditions." ORDER BY A.NRCONSUMER DESC";
		
        $sql = $this->entityManager->getConnection()->prepare($query);
        $sql->execute($params);
        return $sql->fetchAll();
    }
} 
