<?php

namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;
use HCM\Util\HCMParameters;
use HCM\Util\DateUtil;

class ParametrosOrganizacaoRepository {
    
    protected $entityManager;
    protected $hcmParameters;
    protected $connection;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, Connection $connection) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->connection    = $connection;
    }
    
    
    
    public function getOrganizacao($nrorg){
        try {
        $query = <<<SQL
SELECT DSFSAPIKEY, CLIENT_SECRET 
    FROM ORGANIZACAO WHERE NRORG = :P_NRORG
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
        );
        $result = $this->connection->fetchAll($query, $params);
        return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function updateApiKey($nrorg,$apiKey){
        $sql = <<<SQL
UPDATE ORGANIZACAO
                      SET DSFSAPIKEY = :P_DSFSAPIKEY
                     WHERE NRORG = :P_NRORG
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DSFSAPIKEY" => $apiKey
        );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        

        return $std;
    }
    public function updateClientSecret($nrorg,$clientSecret){
        $sql = <<<SQL
UPDATE ORGANIZACAO
                      SET CLIENT_SECRET = :P_CLIENT_SECRET
                     WHERE NRORG = :P_NRORG
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_CLIENT_SECRET" => $clientSecret
        );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        

        return $std;
    }
}