<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\DateUtil;
use HCM\Util\Repositories;


class TipoAnotacaoRepository {

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function getTipoAnotacoes($nrorg,$ntipoanotacao) {
        $query = <<<SQL
        SELECT * 
        FROM GPE_ANOTACOESVINCULO 
        WHERE NRORG = :p_nrorg
        AND NRTIPOANOTACAO = :p_ntipoanotacao
SQL;
        $params = array(
            "p_nrorg" => $nrorg,
            "p_ntipoanotacao" => $ntipoanotacao
        );
        return $this->connection->fetchAll($query,$params);
    }

} 
