<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Geral\Controllers\EnviarMensagemController;
use HCM\Geral\Services\EnviarEmailService;
use HCM\Geral\Services\EnviarMensagemService;
use HCM\Util\Repositories;

class ComunicadoService {

 
    protected $entityManager;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, EnviarMensagemController $enviarMensagemController) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->EnviarMensagemController = $enviarMensagemController;
    }
    
    
    public function enviarComunicado ($row) {
        try{
            $mesCompetencia = $this->hcmParameters->getDtCompetencia();
            $nrorg = $this->hcmParameters->getNrorgTrabalho();
            $nrparcnegocios = array();
            if(!array_key_exists('DSTITULOMENSAGEM', $row))
                $row["DSTITULOMENSAGEM"] = $row["DSTITULOCOMUNICADO"];
            if(!array_key_exists('DSMENSAGEM', $row))
                $row["DSMENSAGEM"] = $row["DSCOMUNICADO"];

            if($row["NRVINCULOM"]){
                foreach ($row["NRVINCULOM"] as $nrvinculo) {
                    $vinculo = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->findOneBy(array("nrorg"=> $nrorg,"nrvinculom" => $nrvinculo));
                    $pessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> $nrorg,"nrpessoa" => $vinculo->getNrpessoa()));
                    array_push($nrparcnegocios, $pessoa->getNrparcnegocio());
                }
            }
            
            if($row["NRESTRUTLEGAL"]){
                foreach ($row["NRESTRUTLEGAL"] as $nrestrutlegal) {
                    $vinculos = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->retornaVinculosEstrutLegal($nrorg,  $nrestrutlegal, $mesCompetencia);
                    foreach ($vinculos as $vinculo) {
                        $pessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> $nrorg,"nrpessoa" => $vinculo->getNrpessoa()));
                        array_push($nrparcnegocios, $pessoa->getNrparcnegocio());
                    }
                }
            }
            
            if($row["NRESTRUTGEREN"]){
                foreach ($row["NRESTRUTGEREN"] as $nrestrutgeren) {
                    $vinculos = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->retornaVinculosEstrutGeren($nrorg,  $nrestrutgeren, $mesCompetencia);
                    foreach ($vinculos as $vinculo) {
                        $pessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> $nrorg,"nrpessoa" => $vinculo->getNrpessoa()));
                        array_push($nrparcnegocios, $pessoa->getNrparcnegocio());
                    }
                }
            }
            
            if($row["NRESTRUTSIND"]){
                foreach ($row["NRESTRUTSIND"] as $nrestrutsind) {
                    $vinculos = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->retornaVinculosEstrutSind($nrorg,  $nrestrutsind, $mesCompetencia);
                    foreach ($vinculos as $vinculo) {
                        $pessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> $nrorg,"nrpessoa" => $vinculo->getNrpessoa()));
                        array_push($nrparcnegocios, $pessoa->getNrparcnegocio());
                    }
                }
            }
            
            if(empty($nrparcnegocios)){
                $vinculos = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->retornaVinculosAtivos($nrorg, $mesCompetencia);
                foreach ($vinculos as $vinculo) {
                        $pessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> $nrorg,"nrpessoa" => $vinculo->getNrpessoa()));
                        array_push($nrparcnegocios, $pessoa->getNrparcnegocio());
                }
            }
            $nrparcnegocios = array_unique($nrparcnegocios);
            
            foreach ($nrparcnegocios as $nrparcnegocio) {
                $this->EnviarMensagemController->enviarEmail($row, $nrorg, $mesCompetencia, $nrparcnegocio);
            }
            
            
        } catch(\Exception $e) {
            throw new \Exception($e->getMessage(), $e->getCode());
        }
    }
 

}