<?php

namespace HCM\SST\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;
use HCM\SST\Services\RelatCustomFuncExamVencidosService;

class RelatCustomExamVencidosController extends Crud {

    
    public function __construct (Manager $dataSourceManager, RelatCustomFuncExamVencidosService $RelatCustomFuncExamVencidosService){
        $this->RelatCustomFuncExamVencidosService = $RelatCustomFuncExamVencidosService;
        parent::__construct($dataSourceManager);
    }
    
    public function getRelatCustomExamVencidos(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            set_time_limit(0);
            
            $filters = \HCM\Util\Util::removerCaracterePorcentagemString($request->getFilterCriteria()->getConditions());
            $result = $this->RelatCustomFuncExamVencidosService->getRelatCustomExamVencidos($filters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getRelatCustomExamVencidos', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

} 