<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\DateUtil;
use HCM\SST\Repository\AcaoRepository;
use HCM\Util\Repositories;

class AcaoService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, AcaoRepository $acaoRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->AcaoRepository = $acaoRepository;
    }
    
    public function validaDelete($nracao, $nrorg){
        return $this->AcaoRepository->validaDelete($nracao, $nrorg);
    }
    
    public function salvaHistorico($nrorg,$cdfilial,$acao,$dataatual,$cdoperador,$novadata){
        $logprevacao   = new \Teknisa\Model\Qualidade\Entities\Logprevacao();

        $this->entityManager->beginTransaction();

        try {
            $logprevacao->setCdfilial($cdfilial);
            $logprevacao->setCdoperador($cdoperador);
            $logprevacao->setCdoperinclusao($cdoperador);
            $logprevacao->setCdoperultatu($cdoperador);
            $logprevacao->setDtalprevacao(DateUtil::getDataDeString(substr($dataatual,0,10)));
            $logprevacao->setDtinclusao(DateUtil::getDataDeString(substr($dataatual,0,10)));
            $logprevacao->setDtnovaprevac(DateUtil::getDataDeString(substr($novadata,0,10)));
            $logprevacao->setDtultatu(DateUtil::getDataDeString(substr($dataatual,0,10)));
            $logprevacao->setIdativo("S");
            $logprevacao->setNracao($acao);
            $logprevacao->setNrorg($nrorg);
            $logprevacao->setNrorginclusao($nrorg);
            $logprevacao->setNrorgultatu($nrorg);
            

            $this->entityManager->persist($logprevacao);
            $this->entityManager->flush();
            $this->entityManager->commit();
        } catch(\Exception $e) {
            $this->entityManager->rollback();
            throw new \Exception($e->getMessage());
        }
    }
    
    public function getOperadorResponsavel($parameters, $conditions){
        return $this->AcaoRepository->getOperadorResponsavel($parameters, $conditions);
    }
    
    // public function setFaseTramitaAcao($nrorg, $nracao, $cdfatramacao){
    //     $acao = $this->AcaoRepository->setFaseTramitaAcao($nrorg, $nracao, $cdfatramacao);
    // }
}