<?php

namespace HCM\SST\Services;

use HCM\SST\Repository\RelatCustomFuncExamVencidosRepository;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;


class RelatCustomFuncExamVencidosService {
    /** @var EntityManager */
    protected $entityManager;

     /**
     * @var RelatCustomFuncExamVencidosRepository
     */
    protected $RelatCustomFuncExamVencidosRepository;

     /** @var HCMParameters */
     protected $hcmParameters;

    public function __construct(
        EntityManager $entityManager,
        RelatCustomFuncExamVencidosRepository $RelatCustomFuncExamVencidosRepository,
        HcmParameters   $hcmParameters
    ) {
        $this->entityManager = $entityManager;
        $this->RelatCustomFuncExamVencidosRepository = $RelatCustomFuncExamVencidosRepository;
        $this->hcmParameters = $hcmParameters;
    }

    public function getRelatCustomExamVencidos($filters) {
        $parameters = array(
            'P_NRORG'                   => '',
            'P_DTMESCOMPETENC'          => '',
            'P_NRESTRUTLEGAL'           => '',
            'P_NRESTRUTGEREN'           => '',
            'P_NRTIPOHIERARQORG'        => '',
            'P_NRESTRUTSUPERIOR'        => '',
            'P_NRVINCULOM'              => '',
            'P_DTINICIO'                => '',
            'P_DTFINAL'                 => '',
            );
           
            foreach ($filters as $filter) {
                switch($filter['columnName']){
                    case 'P_NRORG':                   $parameters['P_NRORG']                   = $filter['value']; break;
                    case 'P_DTMESCOMPETENC':          $parameters['P_DTMESCOMPETENC']          = $filter['value']; break;
                    case 'NRESTRUTLEGAL':             $parameters['P_NRESTRUTLEGAL']           = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                    case 'NRESTRUTGEREN':             $parameters['P_NRESTRUTGEREN']           = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                    case 'NRTIPOHIERARQORG':          $parameters['P_NRTIPOHIERARQORG']        = $filter['value']; break;
                    case 'NRESTRUTSUPERIOR':          $parameters['P_NRESTRUTSUPERIOR']        = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                    case 'NRVINCULOM':                $parameters['P_NRVINCULOM']              = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                    case 'DTINICIO':                  $parameters['P_DTINICIO']                = $filter['value']; break;
                    case 'DTFINAL':                   $parameters['P_DTFINAL']                 = $filter['value']; break;
                }
            }
        return $this->RelatCustomFuncExamVencidosRepository->getRelatCustomExamVencidos($parameters);
      }
      
  
}