<?php
namespace HCM\Util;

use Zeedhi\Framework\Session\Session;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\Repositories;
use HCM\Geral\Entity\GpeparamoperEntity;
use HCM\Util\Mail\Mail;
use HCM\Util\Mail\SMTP;

class HCMParameters {
    /**
     * @var Session
     */
    protected $session;
    protected $dtPagamento;
    protected $_parametrosOper;

    public function __construct(Session $session, $tempDirectory, $httpInterface, $projectVersion, $filesTempPath)
    {
        $this->session = $session;
        $this->set('tempDirectory', $tempDirectory);
        $this->set('httpInterface', $httpInterface);
        $this->set('projectVersion', $projectVersion);
        $this->set('filesTempPath', $filesTempPath);
    }

    public function set($param, $value) {
        $this->session->set($param, $value);
    }
    
    public function getSession(){
        return $this->session;
    }

    public function getCdoperador() {
        $value = $this->session->get('cdoperador');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('cdoperador');
            }
        }
        return $value;
    }
    
    public function getNmoperador() {
        $value = $this->session->get('nmoperador');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nmoperador');
            }
        }
        return $value; 
    }

    public function getNrorgPadrao() {
        $value = $this->session->get('nrorgpadrao');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrorgpadrao');
            }
        }
        return $value; 
    }

    public function getNrorg() {
        $value = $this->session->get('nrorg');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrorg');
            }
        }
        return $value; 
    }

    public function getNrorgTrabalho() {
        $value = $this->session->get('nrorgtrab');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrorgtrab');
            }
        }
        return $value;
    }

    public function getTipoEstruturaLegalOrg() {
        $value = $this->session->get('nrtipoestrutlegal');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrtipoestrutlegal');
            }
        }
        return $value;
    }

    public function getTipoEstruturaGerencialOrg() {
        $value = $this->session->get('nrtipoestrutgeren');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrtipoestrutgeren');
            }
        }
        return $value;
    }
    
    public function getTipoEstruturaTomadorOrg() {
        $value = $this->session->get('nrtipoestrutomador');
        if(!$value){
            $this->findParameters($this->session->all()["CDOPERADOR"]);
            $value = $this->session->get('nrtipoestrutomador');
        }
        return $value;
    }

    public function getIdtpcompetencia() {
        $value = $this->session->get('idtpcompetencia');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('idtpcompetencia');
            }
        }
        return $value;
    }

    public function getIdambientesal() {
        $value = $this->session->get('idambientesal');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('idambientesal');
            }
        }
        return $value;
    }

    public function getDtCompetencia() {
        $value = $this->session->get('dtmescompetenc');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('dtmescompetenc');
            }
        }
        return $value; 
    }

    public function getEstruturaTrabalho() {
        $value = $this->session->get('nrestruttrab');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrestruttrab');
            }
        }
        return $value;
    }

    public function getOcorrenciaCalculo() {
        $value = $this->session->get('nrocorrecal');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrocorrecal');
            }
        }
        return $value;
    }

    public function getNrModalidadeCalculo() {
        $value = $this->session->get('nrtpmodalidcal');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrtpmodalidcal');
            }
        }
        return $value;
    }

    public function getNrModalidadeSalario() {
        $value = $this->session->get('nrtpmodalidsal');
        if(!$value){
            if($this->session->all()["CDOPERADOR"]){
                $this->findParameters($this->session->all()["CDOPERADOR"]);
                $value = $this->session->get('nrtpmodalidsal');
            }
        }
        return $value;
    }
    
    public function setDtPagamento($dtPagamento){
        $this->dtPagamento = $dtPagamento;    
    }
    
    public function getDtPagamento(){
        return $this->dtPagamento;    
    }
    
    public function getUltimoDiaMes() {
        return DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($this->getDtCompetencia()))->format(DateUtil::FORMATO_BRASILEIRO);
    }

    public function getPrimeiroDiaDoMes() {
        return DateUtil::getPrimeiroDiaDoMes(DateUtil::getDataDeString($this->getDtCompetencia()))->format(DateUtil::FORMATO_BRASILEIRO);
    }

    public function getDtmescomptencDiaCorrente() {
        return DateUtil::getPrimeiroDiaDoMes(DateUtil::getDataAtual())->format(DateUtil::FORMATO_BRASILEIRO);
    }
    
    public function getDataAtual($truncate = true) {
        if ($truncate) {
            return DateUtil::getDataAtual($truncate)->format(DateUtil::FORMATO_BRASILEIRO);
        } else {
            return DateUtil::getDataAtual($truncate)->format(DateUtil::FORMATO_BRASILEIRO_DATAHORA);
        }
    }

    public function getPrimeiroDiaDoAno() {
        $anoAtual = DateUtil::getDataDeString($this->getDtCompetencia())->format("Y");
        // Captura o primeiro dia do ano.
        $dataReturn = date(DateUtil::FORMATO_DATA, mktime(0, 0, 0, 1, 1, $anoAtual));
        return DateUtil::getDataDeString($dataReturn)->format(DateUtil::FORMATO_BRASILEIRO);
    }
    
    public function getDtCompAnterior(){
        return DateUtil::getDataDeString($this->getDtCompetencia())->sub(new \DateInterval('P1M'))->format(DateUtil::FORMATO_BRASILEIRO);
    }

    public function getDtCompPosterior(){
        return DateUtil::getDataDeString($this->getDtCompetencia())->add(new \DateInterval('P1M'))->format(DateUtil::FORMATO_BRASILEIRO);
    }
    
    

    public function determinaNrCalculoFolha($tipoMovimento, $mesCompetencia=null, $nrOcorrenciaCalc=null) {
        $mesCompetencia = is_null($mesCompetencia) ? $this->getDtCompetencia() : $mesCompetencia;
        $nrOrgTrabalho = $this->getNrorgTrabalho();
        $nrTpModalidadeCalc = $this->getNrModalidadeCalculo();
        $nrOcorrenciaCalc = is_null($nrOcorrenciaCalc) ? $this->getOcorrenciaCalculo() : $nrOcorrenciaCalc;
        $cdOperador = $this->getCdoperador();

        $dtocorrencia = DateUtil::getDataDeString($mesCompetencia, DateUtil::FORMATO_BRASILEIRO, true);
        $calculoFolha = \Folha\Entities\FpaCalculofolha::retornaCalculoFolha($nrOrgTrabalho, $tipoMovimento, $dtocorrencia, $nrTpModalidadeCalc, $nrOcorrenciaCalc, $cdOperador);
        $calcFolha = current($calculoFolha);

        if(is_object($calcFolha)){
            return $calcFolha->getNrcalculofolha();
        }
        else{
            throw new \Exception('algum parâmetro do operador faltando.<br /> NRORG:'.$nrOrgTrabalho.'<BR />Tipo Movimento:'.$tipoMovimento.'<br />Mês comp.:'.$mesCompetencia.'<br />Tipo modalidade calc:'.$nrTpModalidadeCalc.'<br />Num. Ocorrêcia:'.$nrOcorrenciaCalc);
        }
    }

    public function getApuracoesFrequencia() {
        return $this->session->get('apuracoesFrequencia');
    }

    public function getDadosSimulacao() {
        return $this->session->get('dadosSimulacao');
    }

    public function getTempDirectory() {
        return $this->session->get('tempDirectory');
    }
    
    public function getFileServerDirectory() {
        return $this->session->get('httpInterface');
    }
    
    public function getFileServerTempPath() {
        return $this->session->get('filesTempPath');
    }
    
    public function getProjectVersion() {
        return $this->session->get('projectVersion');
    }

    public function getTipoModalidadeCalculo(){
        if(!$this->_parametrosOper){
            $this->setParamsOperador();
        }
        return $this->_parametrosOper->retornaTipoModalidadeCalculo();
    }
    
    public function getNrOcorrenciaCalculo(){
        if(!$this->_parametrosOper){
            $this->setParamsOperador();
        }
        return $this->_parametrosOper->retornaNrOcorrenciaCalculo();
    }
    
    public function getIdDebug() {
        if(!$this->_parametrosOper){
            $this->setParamsOperador();
        }
        return $this->_parametrosOper->retornaIdDebug();
    }

    public function ambienteSalarioOperador() {
        if(!$this->_parametrosOper){
            $this->setParamsOperador();
        }
        return $this->_parametrosOper->retornaAmbienteSalarioOperador();
    }
    
    public function getTipoModalidadeSalario() {
        if(!$this->_parametrosOper){
            $this->setParamsOperador();
        }
        return $this->_parametrosOper->retornaTipoModalidadeSalario();
    }
    
    public function setParamsOperador(){
        $this->_parametrosOper = new GpeparamoperEntity();
        $this->_parametrosOper->retornaParametrosOperador(self::getNrorgTrabalho(), self::getCdoperador());
    }
    
    /*public function getUrlJenkinsCalculoConsumer($hora) {
        $nrorgHora = $this->getNrorgTrabalho().$hora;
        return 'http://jenkins.teknisa.com:8081/job/Pebbian%20-%20hcmCalculoConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }

    public function getUrlJenkinsOneConsumer($hora) {
        $nrorgHora = $this->getNrorgTrabalho().$hora;
        return 'http://jenkins.teknisa.com:8081/job/Pebbian%20-%20HcmOneConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }*/
    
    //PHP 5
    /*public function getUrlJenkinsMobileCalculoConsumer($hora) {
        $nrorgHora = $this->getNrorgTrabalho().$hora;
        return 'https://ci-pebbian.teknisa.cloud/job/Pebbian%20-%20MobileHcmCalculoConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }
    
    public function getUrlJenkinsMobileOneConsumer($hora) {
        $nrorgHora = $this->getNrorgTrabalho().$hora;
        return 'https://ci-pebbian.teknisa.cloud/job//Pebbian%20-%20MobileHcmOneConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }*/
    
    public function getUrlJenkinsMobileCalculoConsumer($hora) {
        $nrorgHora = $this->getNrorgTrabalho().$hora;
        return 'http://jenkins.teknisa.com:8082/job/Pebbian%20-%20MobileHcmOneConsumer%20Novo%20PHP7/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }
    
/*    public function getUrlJenkinsMobileOneConsumer($hora) {
        $nrorgHora = $this->getNrorgTrabalho().$hora;
        return 'http://jenkins.teknisa.com:8081/job/Pebbian%20-%20MobileHcmOneConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }
    */
    public function getEsoIniValidCadIniProducao() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_INIVALID_PRODUCAO');
        if (empty($result)) {
            return '01/07/2018';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function getEsoIniValidNaoPerProducao() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_ININPERI_PRODUCAO');
        if (empty($result)) {
            return '01/10/2018';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function getEsoIniValidPeriodProducao() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_INIPERIO_PRODUCAO');
        if (empty($result)) {
            return '01/11/2018';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function getEsoIniValidCadIniProdRest() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_INIVALID_PRODREST');
        if (empty($result)) {
            return '01/01/2017';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function getEsoIniValidNaoPerProdRest() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_ININPERI_PRODREST');
        if (empty($result)) {
            return '01/03/2017';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function getEsoIniValidPeriodProdRest() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_INIPERIO_PRODREST');
        if (empty($result)) {
            return '01/05/2017';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function getEsoIniValidCadIniNacioSimples() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_INIVALID_NACIOSIMPLES');
        if (empty($result)) {
            return '10/01/2019';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function getEsoIniValidNaoPerNacioSimples() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_ININPERI_NACIOSIMPLES');
        if (empty($result)) {
            return '10/04/2019';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function getEsoIniValidPeriodNacioSimples() {
        $result = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)->
            retornaValorReferencia($this->getNrorgTrabalho(), $this->getNrorgPadrao(), $this->getDtCompetencia(), 'ESOCIAL_INIPERIO_NACIOSIMPLES');
        if (empty($result)) {
            return '10/06/2019';
        } else {
            return $result[0]->getDtinivigencia()->format('d/m/Y');
        }
    }
    
    public function returnParamsSmtp($lote = false){
        
        $userName = null;
        $passWord = null;
        $host = null;
        $port = null;
        $SMTPSecure = null;
        
        $paramOrg = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMORG)->retornaParamOrg($this->getNrorgTrabalho());
        
        if($paramOrg[0]){
           $paramOrg = $paramOrg[0];
           $userName = $paramOrg["DSEMAILSMTP"] ? $paramOrg["DSEMAILSMTP"] : $userName;
           $passWord = $paramOrg["DSSENHASMTP"] ? $paramOrg["DSSENHASMTP"] : $passWord;
           $host = $paramOrg["DSHOSTSMTP"] ? $paramOrg["DSHOSTSMTP"] : $host;
           $port = $paramOrg["DSPORTASMTP"] ? $paramOrg["DSPORTASMTP"] : $port;
           $SMTPSecure = $paramOrg["IDSMTPSECURE"] ? $paramOrg["IDSMTPSECURE"] : $SMTPSecure;
        }
        
        if(!$userName || !$passWord || !$host || !$port){
            if($lote){	 
                return false;	 
            }
            throw new \Exception("Favor parametrizar as configurações de envio de email na tela de parâmetros de organização");
        }
        
        $params = array('host' => $host, 'username' => $userName, 'password' => $passWord, 'port' => $port, 
        'from' => $userName, 'SMTPSecure' => $SMTPSecure);
        
        $smtp = new SMTP($params);
        $mail = new Mail($smtp);
        
        return $mail;    
    }
    
    public function findParameters($cdoperador) {
        if ($this->session->get('cdoperador') != 1) {
            $operador = $this->retornaOperador($cdoperador);
            /** @var $paramgeral \Geral\Entities\Paramgeral */
            $paramgeral  = $this->retornaParametrosGerais($operador);
            /** @var $paramoper \Geral\Entities\GpeParamoper */
            $paramoper   = $this->retornaParametrosOperador($operador);
            /** @var $organizacao \Geral\Entities\Organizacao */
            $organizacao = $this->retornaOrganizacao($operador);
            /** @var $paramorg \Folha\Entities\GpeParamorg */
            $paramorg = $this->retornaParametrosOrganizacao($operador);
            
            $parameters = array(
                "cdoperador"        => $operador->getCdoperador(),
                "CDOPERADOR"        => $operador->getCdoperador(),
                "nmoperador"        => $operador->getNmoperador(),
                "nrestruttrab"      => $operador->getNrestruttrab(),
                "nrorgpadrao"       => strval($paramorg->getNrorgpadrao()),
                "nrorg"             => strval($operador->getNrorg()),
                "nrorgtrab"         => strval($operador->getNrorgtrab()),
                "nmorganizacaotrab" => $organizacao->getNmorganizacao(),
                "dtmescompetenc"    => $paramoper->getDtmescompetenc()->format('d/m/Y'),
                "dtmescompetencdiacorrente" => $this->getDtmescomptencDiaCorrente(),
                "nrtipoestrutlegal" => $paramorg->getNrtpestrutlegal(),
                "idrealizacontab" => $paramorg->getIdrealizacontab(),
                "idrealizadespesa" => $paramorg->getIdrealizadespesa(),
                "nrtipoestrutgeren" => $paramorg->getNrtpestrutgeren(),
                "idtpcompetencia"   => $paramoper->getIdtpdtcompete(),
                "idambientesal"     => $paramoper->getIdambientesal(),
                "nrocorrecal"       => $paramoper->getNrocorrecal(),
                "nrtpmodalidcal"    => $paramoper->getNrtpmodalidcal(),
                "nrtpmodalidsal"    => $paramoper->getNrtpmodalidsal(),
                "cdpictcctb" => isset($paramgeral) ? $paramgeral->getCdpictcctb() : null,
                "idademincpfdep"    => $this->getIdadeMinCpf($paramoper, $paramorg)
            );
            
            foreach ($parameters as $key => $value) {
                $this->set($key, $value);
            }
        }
    }
    
    public function getIdadeMinCpf($paramoper, $paramorg) {
        return \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_VALORREFERENCIAM)
            ->buscavalor($paramorg->getNrorg(), $paramorg->getNrorgpadrao(), $paramoper->getDtmescompetenc()->format('d/m/Y'), "IDADE_MIN_CPF_DEP");
    }
    
    public function operadorEstaEmOrganizacaoPadrao() {
        return $this->getNrorgTrabalho() == $this->getNrorgPadrao();
    }
    
    public function operadorEstaEmOrganizacaoCliente() {
        return $this->getNrorgTrabalho() != $this->getNrorgPadrao();
    }
    
    private function retornaParametrosOperador($operador) {
        return \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMOPER)
            ->findOneBy(array("cdoperador" => $operador->getCdoperador(), "nrorg" => $operador->getNrorg()));
    }

    private function retornaParametrosGerais($operador) {
        return \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::PARAMGERAL)
            ->findOneBy(array("nrorg" => $operador->getNrorgtrab()));
    }

    private function retornaOrganizacao($operador){
        return \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::ORGANIZACAO)
            ->findOneBy(array("nrorg" => $operador->getNrorgtrab()));
    }

    private function retornaParametrosOrganizacao($operador){
        return \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMORG)
            ->findOneBy(array("nrorg" => $operador->getNrorgtrab()));
    }
    
    private function retornaOperador($cdoperador) {
        if (is_numeric($cdoperador)) {
            $cdoperador = str_pad($cdoperador, 12, "0", STR_PAD_LEFT);
            $operador = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::OPERADOR)
                ->findOneBy(array('cdoperador' => $cdoperador));
        }
        
        if (!isset($operador) || !$operador) {
            throw new \Exception("Operador não está cadastrado.");
        }

        return $this->operador = $operador;
    }
} 