<?php

namespace HCM\Util;

class MsgProcesso {

    private static $instance = null;

    private $nrorg;
    private $cdoper;
    private $id;
    
    private $process;
    private $messages;

    const ERROR = 'E';
    const WARNING = 'W';
    const MESSAGE = 'M';

    private function __construct($nrorg=null, $cdoper=null, $id=null) {
        $this->nrorg = $nrorg;
        $this->cdoper = $cdoper;
        $this->id = $id;
        
        $this->messages = array();
    }

    public static function getInstance($nrorg=null, $cdoper=null, $id=null) {
        if (self::$instance === null) {
            self::$instance = new self($nrorg, $cdoper, $id);
        }

        return self::$instance;
    }

    public function clear()
    {
        self::$instance = null;
    }

    public function addMessage($message, $type = self::MESSAGE)
    {
        $this->messages[] = array(
            'MSG' => $message,
            'TYPE' => $type,
        );
    }
    
    public function addError($message)
    {
        $this->addMessage($message, self::ERROR);
    }
    
    public function addWarning($message)
    {
        $this->addMessage($message, self::WARNING);
    }

    public function setMessage($index, $message = null, $type = null)
    {
        if (!is_null($message)) {
            $this->messages[$index]['MSG'] = $message;
        }
        
        if (!is_null($type)) {
            $this->messages[$index]['TYPE'] = $type;
        }
    }

    public function getMessages($type = null)
    {
        $result = array();

        if ($type === null) {
            $result = $this->messages;
        }
        else {
            foreach ($this->messages as $index => $msg) {
                if ($msg['TYPE'] === $type) {
                    $result[] = $this->messages[$index];
                }
            }
        }

        return $result;
    }
    
}