-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     14/04/2023  13:10                        
--   Issue:          421081   
-- ============================================================

-- ============================================================
--   Table: VAB_PARAMVALEM                                    
-- ============================================================

CREATE TABLE VAB_PARAMVALEM (
    NRORG           NUMBER          NOT NULL,
    NRPARAMVALEM    NUMBER          NOT NULL,
    NRORGINCLUSAO   NUMBER          DEFAULT 1 NULL ,
    DTINCLUSAO      DATE            NOT NULL ,
    CDOPERINCLUSAO  VARCHAR2(12)    DEFAULT '1' NULL ,
    NRORGULTATU     NUMBER          DEFAULT 1 NULL ,
    DTULTATU        DATE            NULL ,
    CDOPERULTATU    VARCHAR2(12)    DEFAULT '1' NULL ,
    CONSTRAINT PK_VAB_PARAMVALEM PRIMARY KEY (NRORG, NRPARAMVALEM)
)
-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     14/04/2023  13:10                        
--   Issue:          421081   
-- ============================================================

-- ============================================================
--   Table: VAB_PARAMVALEH                                    
-- ============================================================

CREATE TABLE VAB_PARAMVALEH2 (
    NRORG               NUMBER      NOT NULL,
    NRPARAMVALEH        NUMBER      NOT NULL,
    NRPARAMVALEM        NUMBER      NOT NULL,
	DTMESCOMPETENC		DATE	    NOT NULL,
    IDCONSFALTAVALE     VARCHAR2(1) DEFAULT 'S' NOT NULL
        CONSTRAINT CKC_IDCONSFALTAVALE CHECK (IDCONSFALTAVALE IN ('N','S')),
    QTMESESFALTAVALE    FLOAT       DEFAULT 0,
    IDCONSATESTVALE     VARCHAR2(1) DEFAULT 'S' NOT NULL
        CONSTRAINT CKC_IDCONSATESTVALE CHECK (IDCONSATESTVALE IN ('N','S')),
    QTMESESATESTVALE    FLOAT       DEFAULT 0,
    IDCONSAFASTVALE     VARCHAR2(1) DEFAULT 'S' NOT NULL
        CONSTRAINT CKC_IDCONSAFASTVALE CHECK (IDCONSAFASTVALE IN ('N','S')),
    QTMESESAFASTVALE    FLOAT       DEFAULT 0,
    IDCONSFERIASVALE    VARCHAR2(1) DEFAULT 'S'NOT NULL
        CONSTRAINT CKC_IDCONSFERIASVALE CHECK (IDCONSFERIASVALE IN ('N','S')),
    QTMESESFERIASVALE   FLOAT       DEFAULT 0,
    IDCONSFERIADOVALE   VARCHAR2(1) DEFAULT 'S'NOT NULL
        CONSTRAINT CKC_IDCONSFERIADOVALE CHECK (IDCONSFERIADOVALE IN ('N','S')),
    QTMESESFERIADOVALE  FLOAT       DEFAULT 0,
    IDCONSDSRVALE       VARCHAR2(1) DEFAULT 'S' NOT NULL
        CONSTRAINT CKC_IDCONSDSRVALE CHECK (IDCONSDSRVALE IN ('N','S')),
    QTMESESDSRVALE      FLOAT       DEFAULT 0,
    IDORIGVALEFALTA     NUMBER      DEFAULT 1 NULL
        CONSTRAINT CKC_IDORIGVALEFALTA CHECK (IDORIGVALEFALTA IN (1,2,3)),
    NRORGINCLUSAO       NUMBER      DEFAULT 1 NULL ,
    DTINCLUSAO          DATE        NOT NULL ,
    CDOPERINCLUSAO      VARCHAR2(12) DEFAULT '1' NULL ,
    NRORGULTATU         NUMBER      DEFAULT 1 NULL ,
    DTULTATU            DATE        NULL ,
    CDOPERULTATU        VARCHAR2(12) DEFAULT '1' NULL ,
    CONSTRAINT PK_VAB_PARAMVALEH PRIMARY KEY (NRORG, NRPARAMVALEH),
    CONSTRAINT FK_VAB_PARAMVALEM FOREIGN KEY (NRORG, NRPARAMVALEM)
        REFERENCES VAB_PARAMVALEM (NRORG, NRPARAMVALEM))

-- ============================================================