-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     04/07/2023  12:00                        
--   Issue:           431256 - Pré-Fechamento - DCTFWEB - Tabelas e Rotina de Consulta

-- ============================================================
-- Table: ESO_NAOPERRETCP
-- ============================================================

CREATE TABLE ESO_NAOPERRETCP
(
    NRORG                 NUMBER          NOT NULL,
    NRNAOPERRETCP         NUMBER          NOT NULL,
    NRENVIO               NUMBER          NOT NULL,
    CDMATRICULA           VARCHAR2(30)    NULL,
    CDCATEGTRAB           VARCHAR2(12)    NULL,
    VRBASEMENSAL          FLOAT(126)      NULL,
    VRBASE13              FLOAT(126)      NULL,
    VRVALORMENSAL         FLOAT(126)      NULL,
    VRVALOR13             FLOAT(126)      NULL,
    VRVALORMATERMENSAL    FLOAT(126)      NULL,
    VRVALORMATER13        FLOAT(126)      NULL,
    VRSALFAMILIA          FLOAT(126)      NULL,
    VRSALFAMILIA13        FLOAT(126)      NULL,
    VRCALCULADO           FLOAT(126)      NULL,
    VRDESCONTADO          FLOAT(126)      NULL,
    NRESTRUTLOTACAO       NUMBER          NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_NPRETCP CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_ESO_NAOPERRETCP PRIMARY KEY (NRORG, NRNAOPERRETCP),
    CONSTRAINT FK_ESO_NAOPERRETCP FOREIGN KEY (NRORG, NRENVIO)  REFERENCES ESO_NAOPERIODICO (NRORG, NRENVIO)
)