--------------------------------------------------------
--   Table SST_GHERISCO
--------------------------------------------------------

  CREATE TABLE "SST_GHERISCO" 
   (	"NRORG" NUMBER NOT NULL, 
	"NRGHERISCO" NUMBER NOT NULL, 
	"NRFATORRISCO" NUMBER NOT NULL,
    "NROCUPACAOM"   NUMBER NOT NULL, 
	"NRESTRUTURAM" NUMBER NOT NULL, 
	"DTINIVIGENCIA" DATE NOT NULL, 
	"DTFIMVIGENCIA" DATE, 
    "NRSITUGERADORA" NUMBER,
    "NRSETOR" NUMBER,
    "DSMEDIDASCTRADM" VARCHAR2(4000),
    "DSMEDIDASCTREPI" VARCHAR2(4000),
    "DTMEDICAO" DATE,
    "DSMEDICACAO"  VARCHAR2(150),
    "NRCLASSRISCO" NUMBER,
    "NRFREQUENCIA" NUMBER,
    "NRNIVELACAO" NUMBER,
    "NRCLASSEFEITO" NUMBER,
	"IDATIVO" VARCHAR2(1 BYTE) DEFAULT 'S', 
	"NRORGINCLUSAO" NUMBER DEFAULT 1, 
	"DTINCLUSAO" DATE NOT NULL, 
	"CDOPERINCLUSAO" VARCHAR2(12 BYTE) DEFAULT '1', 
	"NRORGULTATU" NUMBER DEFAULT 1, 
	"DTULTATU" DATE, 
	"CDOPERULTATU" VARCHAR2(12 BYTE) DEFAULT '1'
   );
--------------------------------------------------------
--   Index SST00200_FK
--------------------------------------------------------

  CREATE INDEX "SST00200_FK" ON "SST_GHERISCO" ("NRORG", "NRFATORRISCO");
--------------------------------------------------------
--   Index SST00201_FK
--------------------------------------------------------

  CREATE INDEX "SST00201_FK" ON "FOLHA"."SST_GHERISCO" ("NRORG", "NRESTRUTURAM");
--------------------------------------------------------
--   Index PK_SST_GHERISCO
--------------------------------------------------------

  CREATE UNIQUE INDEX "FOLHA"."PK_SST_GHERISCO" ON "FOLHA"."SST_GHERISCO" ("NRORG", "NRGHERISCO");
--------------------------------------------------------
--  Constraints for Table SST_GHERISCO
--------------------------------------------------------

  ALTER TABLE "SST_GHERISCO" ADD CONSTRAINT "CKC_IDATIVO_SST_GHERISCO" CHECK (
            IDATIVO is null or (IDATIVO in ('S','N'))) ENABLE;
  ALTER TABLE "SST_GHERISCO" ADD CONSTRAINT "PK_SST_GHERISCO" PRIMARY KEY ("NRORG", "NRGHERISCO");
--------------------------------------------------------
--  Ref Constraints for Table SST_GHERISCO
--------------------------------------------------------

  ALTER TABLE "SST_GHERISCO" ADD CONSTRAINT "FKGHE_FATO" FOREIGN KEY ("NRORG", "NRFATORRISCO")
	  REFERENCES "SST_FATORRISCO" ("NRORG", "NRFATORRISCO") ENABLE;
  ALTER TABLE "SST_GHERISCO" ADD CONSTRAINT "FKSST00201ESTRUTUR" FOREIGN KEY ("NRESTRUTURAM", "NRORG")
	  REFERENCES "ESTRUTURAM" ("NRESTRUTURAM", "NRORG") ENABLE;
  ALTER TABLE "SST_GHERISCO" ADD CONSTRAINT "FKSST00201OCUPACAO" FOREIGN KEY ("NROCUPACAOM", "NRORG")
	  REFERENCES  "GPE_OCUPACAOM" ("NROCUPACAOM", "NRORG") ENABLE;
      
      COMMIT;
