-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     09/05/2024  10:00                   
--   Issue:          SPRT [20] - 479233 - [HCM] - Criação do cadastro de Instrumentos para Avaliação dos Riscos

-- ============================================================
-- Table: SST_MARCAINSTRUMENTO
-- ============================================================



CREATE TABLE SST_INSTRUMENTO
(
    NRORG                 NUMBER          NOT NULL,
    NRINSTRUMENTO         NUMBER          NOT NULL,
    NMINSTRUMENTO         VARCHAR2(200)   NOT NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_SST_INSTRUMENTO CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,   
    CONSTRAINT PK_NRINSTRUMENTO PRIMARY KEY (NRINSTRUMENTO)
);

INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 1, 'Anemômetros', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 2, 'Calibradores de bombas', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 3, 'Bomba para amostragem de gases e poeiras', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 4, 'Detectores de gás', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 5, 'Medidor de Nível de Pressão Sonora', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 6, 'Dosímetro', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 7, 'Higrômetro', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 8, 'Luxímetro', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_INSTRUMENTO (NRORG, NRINSTRUMENTO, NMINSTRUMENTO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (0, 9, 'Explosímetro', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;