-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     03/05/2024  09:00                   
--   Issue:          SPRT [20] - 479233 - [HCM] - Conferir novos atributos do cadastro de GHE - Risco

-- ============================================================
-- Table: SST_CLASSFREQUENCIA
-- ============================================================

CREATE TABLE SST_CLASSFREQUENCIA
(
    NRORG                 NUMBER          NOT NULL,
    NRFREQUENCIA          NUMBER          NOT NULL,
    DSSIGNIFICADO         VARCHAR2(200)       NULL,
    DSDESCRICAO           VARCHAR2(200)       NULL,
    NRPESO                NUMBER              NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_CLASSFREQUENCIA CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_SST_NRFREQUENCIA PRIMARY KEY (NRFREQUENCIA)
);

INSERT INTO SST_CLASSFREQUENCIA (NRORG, NRFREQUENCIA, DSSIGNIFICADO, DSDESCRICAO, NRPESO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 1, 'Não há exposição','Nenhum contato com o agente ou contato improvável', 0, 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSFREQUENCIA (NRORG, NRFREQUENCIA, DSSIGNIFICADO, DSDESCRICAO, NRPESO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 2, 'Exposição a níveis baixos','Contatos não frequentes com o agente', 1, 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSFREQUENCIA (NRORG, NRFREQUENCIA, DSSIGNIFICADO, DSDESCRICAO, NRPESO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 3, 'Exposição moderada','Contato frequente com o agente a baixas concentrações ou não frequentes a altas concentrações', 2, 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSFREQUENCIA (NRORG, NRFREQUENCIA, DSSIGNIFICADO, DSDESCRICAO, NRPESO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 4, 'Exposição elevada','Contato frequente com o agente a altas concentrações', 3, 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSFREQUENCIA (NRORG, NRFREQUENCIA, DSSIGNIFICADO, DSDESCRICAO, NRPESO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 5, 'Exposição elevadíssima','Contato frequente com o agente a concentrações elevadíssimas', 4, 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;