-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     03/05/2024  12::00                   
--   Issue:          SPRT [20] - 479233 - [HCM] - Conferir novos atributos do cadastro de GHE - Risco

-- ============================================================
-- Table: SST_CLASSRISCO
-- ============================================================

CREATE TABLE SST_CLASSRISCO
(
    NRORG                 NUMBER          NOT NULL,
    NRCLASSRISCO           NUMBER          NOT NULL,
    DSCLASSRISCO          VARCHAR2(200)       NULL,
    DSSIGNCLASSRISCO      VARCHAR2(400)       NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_SST_CLASSRISCO CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_SST_NRCLASSRISCO PRIMARY KEY (NRCLASSRISCO)
);

INSERT INTO SST_CLASSRISCO (NRORG, NRCLASSRISCO, DSCLASSRISCO,DSSIGNCLASSRISCO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 1, 'Irrelevante', 'Não prioritário.Ações dentro do princípio de melhoria contínua. Pode ser necessária avaliação quantitativa do
Setor/GHE para confirmação da categoria, a critério do profissional de Higiene Ocupacional', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSRISCO (NRORG, NRCLASSRISCO, DSCLASSRISCO,DSSIGNCLASSRISCO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 2, 'De Atenção', 'Prioridade básica.Iniciar processo de avaliação quantitativa do Setor/GHE para confirmação da categoria e
monitoramento periódico.','S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSRISCO (NRORG, NRCLASSRISCO, DSCLASSRISCO,DSSIGNCLASSRISCO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 3, 'Crítica','Prioridade preferencial.Adotar medidas de controle para redução da exposição e iniciar processo de avaliação
quantitativa do Setor/GHE.', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSRISCO (NRORG, NRCLASSRISCO, DSCLASSRISCO, DSSIGNCLASSRISCO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 4, 'Não tolerável','Prioridade máxima.Adotar medidas imediatas de controle. Quando não, a continuidade da operação só poderá ocorrer
com ciência e aprovação do gerente geral da unidade ou instalação. Iniciar processo de avaliação quantitativa do
Setor/GHE para verificação do rebaixamento da categoria de risco.','S', SYSDATE, 0, '1', 1, '1');
COMMIT;