/**********************************************************************************************************************/
/**** PROJETO GRUPO CBO 2022                                                                                     **/
/**** IMPLANTAÇÃO DOS PENSIONISTAS                                                                                    **/
/**** SCRITP DE PREPARAÇÃO DA MIGRAÇÃO                                                                               **/
/**** ESSE SCRIPT GERA LAYOUT (TB_AUX_PENSIONISTA)                                                                   **/
/**********************************************************************************************************************/

--------------------------------------------------------
-- CRIAÇÃO LAYOUT DE PENSIONISTA
--------------------------------------------------------
SELECT DISTINCT

'00110' AS "01_Código do leiaute",
'' AS "02_Pessoa ID  - colaborador",
FN_RETORNA_EMPRESA(PENSIONI.RQ_FILIAL, PENSIONI.CODEMP) AS "03_Empresa do contrato",
LGM.MATRICULA_LG  AS "04_Matrícula do colaborador",
ROW_NUMBER() OVER(PARTITION BY PENSIONI.CodEmp, PENSIONI.RA_MAT ORDER BY PENSIONI.RQ_NOME) AS "0005 Sequencial representa",
CASE 
WHEN TRIM(PENSIONI.RQ_CIC) = '' THEN '' 
ELSE REPLACE(REPLACE(REPLACE(PENSIONI.RQ_CIC, ' ', '0'), '.',''), '-','')
END AS "06_CPF",
'' AS "07_Pessoa ID - Pensionista",
'' AS "08_Código do Pensionista",
CASE 
WHEN PENSIONI.RQ_NASC = '' THEN  SUBSTR(FUNC.RA_ADMISSA,7,2)|| SUBSTR(FUNC.RA_ADMISSA,5,2)||SUBSTR(FUNC.RA_ADMISSA,1,4) 
WHEN PENSIONI.RQ_NASC <= FUNC.RA_ADMISSA
THEN SUBSTR(FUNC.RA_ADMISSA,7,2)|| SUBSTR(FUNC.RA_ADMISSA,5,2)||SUBSTR(FUNC.RA_ADMISSA,1,4)
ELSE  SUBSTR(PENSIONI.RQ_NASC,7,2)|| SUBSTR(PENSIONI.RQ_NASC,5,2)||SUBSTR(PENSIONI.RQ_NASC,1,4)  
END AS "09_Data de ativaco do Pensionista",
'' AS "10_Data fim de ativacao do Pensionista",
UPPER(TRIM(PENSIONI.RQ_NOME)) AS "11_Nome",
CASE 
WHEN PENSIONI.RQ_NASC = ' ' THEN  '01011970'
ELSE SUBSTR(PENSIONI.RQ_NASC,7,2)|| SUBSTR(PENSIONI.RQ_NASC,5,2)||SUBSTR(PENSIONI.RQ_NASC,1,4) END AS "12_Data de nascimento",
'' AS "13_Sexo",
	-----------------------------------------------------------------------------------------------
	REPLACE(PENSIONI.RQ_PERCENT,',','.') AS "14_Percentual do Pensionista",

    -----------------------------------------------------------------------------------------------
	'95588000' AS "15_CEP do endereço", 
	'39' AS "16_Tipo do logradouro",
	'Sem Informacao' AS "17_Logradouro",
'' AS "18_Número",
'' AS "19_Complemento",
	'Sem Informacao' AS "20_Bairro",
	'22' AS "21_Estado",
	'4323804' AS "22_Município",
'' AS "23_Caixa postal",
'' AS "24_CEP da caixa postal",
'' AS "25_DDD/DDI - fixo",
'' AS "26_Número do telefone - fixo",
'' AS "27_Ramal",
'' AS "28_DDD/DDI - celular",
'' AS "29_Número do telefone - celular",
'' AS "30_E-mail corporativo",
'' AS "31_E-mail particular",
'' AS "32_Linkedin",
'' AS "33_Facebook",
'' AS "34_Twitter",
'' AS "35_Beneficiário para emissão no comprovante de rendimento",
'' AS "36_GENERO"


FROM 
TB_AUX_PENSIONISTA PENSIONI
LEFT JOIN TB_AUX_FUNCIONARIOS FUNC ON (FUNC.CODEMP = PENSIONI.CodEmp AND FUNC.RA_MAT = PENSIONI.RA_MAT AND FUNC.RA_FILIAL = PENSIONI.RQ_FILIAL)
--INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS on FUNC.CODEMP = TB_AUX_FUNCIONARIOS_MIGRADOS.CODEMP 
--AND FUNC.RA_MAT = TB_AUX_FUNCIONARIOS_MIGRADOS.RA_MAT

LEFT JOIN LG_DEPARA_MATRICULA LGM
	ON LGM.FILIAL_PROTHEUS = FUNC.RA_FILIAL AND LGM.MATRICULA_PROTHEUS = FUNC.RA_MAT 
    AND LGM.EMPESA_PROTHEUS = FUNC.CODEMP
    
WHERE RQ_NOME <> ' '

ORDER BY 3,4