/**********************************************************************************************************************/
/**** PROJETO GRUPO CICOPAL 2022                                                                                     **/
/**** IMPLANTAO DOS DEPENDENTES                                                                                    **/
/**** SCRITP DE PREPARAO DA MIGRAO                                                                               **/
/**** ESSE SCRIPT GERA UMA TABELA AUXILIAR (TB_AUX_PENSIONISTA)                                                      **/
/**********************************************************************************************************************/

--------------------------------------------------------
-- CRIAO DA TABELA AUXILIAR DE PENSIONISTA
--------------------------------------------------------

create table TB_AUX_PENSIONISTA AS ( 

SELECT 
	'01' AS CodEmp,	/* Cdigo Empresa */
	BEF.RQ_FILIAL,	/* Filial */
	F.RA_MAT,		/* Matrcula do Colaborador */
	BEF.RQ_CIC,		/* CPF */
	BEF.RQ_DTINI,	/* Data Inicial */
	BEF.RQ_DTFIM,	/* Data fim */
	BEF.RQ_NOME,	/* Nome do Pensionista */
	BEF.RQ_NASC,	/* Data de Nascimento */
	BEF.RQ_PERCENT,	/* PercentoBeneficio */
	BEF.RQ_VALFIXO,	/* ValorFixo */
	BEF.RQ_BCDEPBE,	/* Banco/Agncia */
	BEF.RQ_CTDEPBE	/* Conta */
--select *
FROM 
	SIGAP12.SRQ010 BEF
	INNER JOIN SIGAP12.SRA010 F ON BEF.RQ_FILIAL = F.RA_FILIAL AND BEF.RQ_MAT = F.RA_MAT
WHERE
	BEF.D_E_L_E_T_ <> '*'

UNION ALL

SELECT 
	'06' AS CodEmp,	/* Cdigo Empresa */
	BEF.RQ_FILIAL,	/* Filial */
	F.RA_MAT,		/* Matrcula do Colaborador */
	BEF.RQ_CIC,		/* CPF */
	BEF.RQ_DTINI,	/* Data Inicial */
	BEF.RQ_DTFIM,	/* Data fim */
	BEF.RQ_NOME,	/* Nome do Pensionista */
	BEF.RQ_NASC,	/* Data de Nascimento */
	BEF.RQ_PERCENT,	/* PercentoBeneficio */
	BEF.RQ_VALFIXO,	/* ValorFixo */
	BEF.RQ_BCDEPBE,	/* Banco/Agncia */
	BEF.RQ_CTDEPBE	/* Conta */
FROM 
	SIGAP12.SRQ060 BEF
	INNER JOIN SIGAP12.SRA060 F ON BEF.RQ_FILIAL = F.RA_FILIAL AND BEF.RQ_MAT = F.RA_MAT
WHERE
	BEF.D_E_L_E_T_ <> '*'
    );

