/**********************************************************************************************************************/
/**** PROJETO GRUPO CICOPAL 2022                                                                                     **/
/**** IMPLANTAO DOS DEPENDENTES                                                                                  **/
/**** SCRITP DE PREPARAO DA MIGRAO                                                                               **/
/**** ESSE SCRIPT GERA LAYOUT DEPENDENTES (TB_AUX_DEPENDENTES)                                                      **/
/**********************************************************************************************************************/

--------------------------------------------------------
-- GERAO LAYOUT DE DEPENDENTES
--------------------------------------------------------
SELECT DISTINCT
    '00100' AS "01 Codigo do leiaute",
	''      AS "02 Pessoa ID - Colaborador",
	-----------------------------------------------------------------------------------------------
    FN_RETORNA_EMPRESA(F.RA_FILIAL, F.CODEMP) AS "03 Empresa do Contrato",
	-----------------------------------------------------------------------------------------------
     ----LGM.MATRICULA_LG
     FN_RETORNA_MATRICULA_LG(F.RA_FILIAL, F.RA_MAT) 
     AS "04 maticula do Colaborador",
	-----------------------------------------------------------------------------------------------
	TRIM(DP.RB_COD) AS "05 Sequencial unico que o dependente",
	-----------------------------------------------------------------------------------------------
 
 --   CASE 
--		WHEN  TRIM(DP.RB_CIC) IS NULL OR TRIM(DP.RB_CIC) = '0' THEN SUBSTR(RA_CIC,1,8) || SUBSTR(RA_MAT,1,3)
--		ELSE TRIM(DP.RB_CIC)
--	END 
    CASE 
            WHEN 
                    TRIM(DP.RB_CIC) = TRIM(F.RA_CIC) THEN '' --CPF DO DEPENDENTE IGUAL AO DO COLABORADOR
            WHEN 
                    TRIM(DP.RB_CIC) IN ('80866565515','05320077513','02526584507','82067040510','02037536585','09815413139','02164551117','78382642153')  THEN ''   --CPF INVLIDO OU J EXISTENTE
            ELSE  
                    TRIM(DP.RB_CIC)
    END    
AS "06 CPF",
	-----------------------------------------------------------------------------------------------
	''   AS "07 Pessoa ID Dependente",
	-----------------------------------------------------------------------------------------------

	CASE 
		WHEN RTRIM(DP.RB_DTNASC) >= RTRIM(F.RA_ADMISSA) THEN SUBSTR(RB_DTNASC,7,2)|| SUBSTR(RB_DTNASC,5,2)||SUBSTR(RB_DTNASC,1,4)
		ELSE SUBSTR(RA_ADMISSA,7,2)|| SUBSTR(RA_ADMISSA,5,2)||SUBSTR(RA_ADMISSA,1,4)
	END AS "08 Data de ativacao do Dependente",
	-----------------------------------------------------------------------------------------------
	'' AS "09 Data fim de ativacao do Dependente",
	'' AS "10 Motivo da inativacao do Dependente",
	-----------------------------------------------------------------------------------------------
	TRIM(DP.RB_NOME) AS "11 Nome",
	-----------------------------------------------------------------------------------------------
    --SUBSTR(RB_DTNASC,7,2)||'/'|| SUBSTR(RB_DTNASC,5,2)||'/'||SUBSTR(RB_DTNASC,1,4) AS "12 Data de nascimento",
	SUBSTR(RB_DTNASC,7,2)|| SUBSTR(RB_DTNASC,5,2)||SUBSTR(RB_DTNASC,1,4) AS "12 Data de nascimento",
    -----------------------------------------------------------------------------------------------
	RTRIM(DP.RB_SEXO) AS "13 Sexo",
	-----------------------------------------------------------------------------------------------
	--RB_TPDEP,
	--TRIM(DP.RB_GRAUPAR),
    CASE 
        WHEN TRIM(DP.RB_GRAUPAR) = 'P' AND TRIM(DP.RB_SEXO) = 'M' THEN '0'  -- Pai
        WHEN TRIM(DP.RB_GRAUPAR) = 'P' AND TRIM(DP.RB_SEXO) = 'F' THEN '1'   -- Mae
        WHEN TRIM(DP.RB_GRAUPAR) = 'C' THEN '4'   -- CONJUGUE
        WHEN TRIM(DP.RB_GRAUPAR) = 'E' THEN '3'   -- ENTEADO
        WHEN TRIM(DP.RB_GRAUPAR) = 'F' THEN '2'   -- FILHO
        WHEN TRIM(DP.RB_GRAUPAR) = 'O' THEN '11'  -- OUTROS
        WHEN TRIM(DP.RB_GRAUPAR) IS NULL THEN '11'  -- OUTROS
        WHEN TRIM(DP.RB_GRAUPAR) = '0' THEN '11'  -- OUTROS
        WHEN TRIM(DP.RB_GRAUPAR) = '1' THEN '2'   -- FILHO
        WHEN TRIM(DP.RB_GRAUPAR) = '3' THEN '4'   -- CONJUGUE
        WHEN TRIM(DP.RB_GRAUPAR) = '4' THEN '3'   -- ENTEADO
        WHEN TRIM(DP.RB_GRAUPAR) = '5' THEN '10'   -- COMPANHEIRO
        WHEN TRIM(DP.RB_GRAUPAR) IN ('6','7')AND TRIM(DP.RB_SEXO) = 'M' THEN '0'  -- Pai
        WHEN TRIM(DP.RB_GRAUPAR) IN ('6','7')AND TRIM(DP.RB_SEXO) = 'F' THEN '1'  -- MAE
        WHEN DP.RB_TIPSF IN ('1','2') AND TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2))<15 THEN '2'
        ELSE '11'
        
        
	END AS "14 Parentesco",
	-----------------------------------------------------------------------------------------------
	CASE 
		WHEN RTRIM(DP.RB_GRAUPAR) = 'C' AND RTRIM(DP.RB_TPDEP) IN ('01', '02')				THEN RTRIM(DP.RB_TPDEP)
		WHEN RTRIM(DP.RB_GRAUPAR) = 'E' AND RTRIM(DP.RB_TPDEP) IN ('03', '04', '05')		THEN RTRIM(DP.RB_TPDEP)
		WHEN RTRIM(DP.RB_GRAUPAR) = 'F' AND RTRIM(DP.RB_TPDEP) IN ('03', '04', '05')		THEN RTRIM(DP.RB_TPDEP)
		WHEN RTRIM(DP.RB_GRAUPAR) = 'P' AND RTRIM(DP.RB_TPDEP) IN ('09')					THEN RTRIM(DP.RB_TPDEP)
		WHEN RTRIM(DP.RB_GRAUPAR) = 'O'														THEN '99'
        WHEN TRIM(DP.RB_GRAUPAR) = '0' THEN '99' 
        WHEN TRIM(DP.RB_GRAUPAR) = '1' AND RTRIM(DP.RB_TPDEP) IN ('03', '04', '05')		THEN RTRIM(DP.RB_TPDEP)
        WHEN TRIM(DP.RB_GRAUPAR) = '3' AND TRIM(DP.RB_TPDEP) IN ('01', '02')				THEN RTRIM(DP.RB_TPDEP)
        WHEN TRIM(DP.RB_GRAUPAR) = '4' AND RTRIM(DP.RB_TPDEP) IN ('03', '04', '05')		THEN RTRIM(DP.RB_TPDEP)
        WHEN TRIM(DP.RB_GRAUPAR) = '5' AND TRIM(DP.RB_TPDEP) IN ('01', '02')				THEN RTRIM(DP.RB_TPDEP)
        WHEN TRIM(DP.RB_GRAUPAR) IN ('6','7')AND RTRIM(DP.RB_TPDEP) IN ('09')					THEN RTRIM(DP.RB_TPDEP)

		ELSE''
	END AS "15 Relacao de dependencia",
	-----------------------------------------------------------------------------------------------
	--TO_NUMBER(DP.RB_DTNASC),
    --TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2)),

    CASE
		WHEN RTRIM(DP.RB_GRAUPAR) = 'F' 
			AND TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2)) >= 21
			AND TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2)) <= 24  THEN '8'
		ELSE '1' 
	END AS "16 Grau de instrucao", 
	-----------------------------------------------------------------------------------------------
	CASE 
            WHEN 
                        TRIM(DP.RB_GRAUPAR) = 'C' THEN '2' 
            ELSE '1'
    END  AS "17 Estado Civil",
	-----------------------------------------------------------------------------------------------
	'' AS "18 Data do casamento",
	'' AS "19 Uniao estavel",
	'' AS "20 Data da uniao estavel",
	-----------------------------------------------------------------------------------------------
	CASE 
		WHEN TRIM(F.RA_MAE) IS NOT NULL THEN '2'
		WHEN RTRIM(DP.RB_GRAUPAR) = 'F' THEN  -- FILHO 
											CASE 
												WHEN RTRIM(F.RA_SEXO) = 'F' THEN '2' -- MAE 
												ELSE '1'							 -- PAI
											END
 		ELSE '2' --MAE
	END AS "21 Tipo da filiacaao 1",
	-----------------------------------------------------------------------------------------------
	CASE 
		WHEN TRIM(F.RA_MAE) IS NOT NULL THEN LTRIM(RTRIM(F.RA_MAE))					-- MAE
		WHEN RTRIM(DP.RB_GRAUPAR) = 'F' THEN RTRIM(F.RA_NOME)						-- PAI OU MAE
		ELSE 'NAO INFORMADO'
	END  AS "22 Nome da filiacao 1",
	-----------------------------------------------------------------------------------------------
	CASE
		WHEN RTRIM(DP.RB_GRAUPAR) = 'F' AND TRIM(F.RA_MAE) IS NOT NULL AND TRIM(F.RA_SEXO) <> 'F' THEN '1' -- Caso seja filho, tenha mae cadastrada na ficha do benef e seja pai o funcion?rio
		ELSE''																	
	END AS "23 Tipo da filiacao 2",
	-----------------------------------------------------------------------------------------------
	CASE
		WHEN RTRIM(DP.RB_GRAUPAR) = 'F' AND TRIM(F.RA_MAE) IS NOT NULL AND TRIM(F.RA_SEXO) <> 'F' THEN LTRIM(RTRIM(F.RA_NOME)) -- Caso seja filho, tenha mae cadastrada na ficha do benef e seja pai o funcion?rio
		ELSE''																	
	END AS "24 Nome da filiacao 2",
	-----------------------------------------------------------------------------------------------
	CASE 
		WHEN RTRIM(F.RA_MAE) IS NOT NULL THEN''																-- MAE
		WHEN RTRIM(DP.RB_GRAUPAR) = 'F' AND RTRIM(F.RA_MAE) IS NULL AND RTRIM(F.RA_SEXO) <> 'F' THEN '0' -- PAI
		ELSE''																							-- MAE
	END AS "25 Responsavel legal considerado na",
	-----------------------------------------------------------------------------------------------
	'N' AS "26 Incluir no arquivo Susep",
	-----------------------------------------------------------------------------------------------
	''  AS "27 Numero da Identidade",
	''  AS "28 Orgao emissor da Identidade",
	''  AS "29 Data da emissao da Identidade",
	''  AS "30 Estado da Identidade",
	-----------------------------------------------------------------------------------------------
	''  AS "31 Numero do RIC",
	''  AS "32 Serie do RIC",
	''  AS "33 Data de emissao do RIC",
	''  AS "34 Data de validade do RIC",
	''  AS "35 Orgao emissor do RIC",
	''  AS "36 Estado do RIC",
	''  AS "37 Numero do CNS",
	''  AS "38 Via do CNS",
	-----------------------------------------------------------------------------------------------
	--RB_NREGCAR,            -- No. Registro Cartorio
    --DP.RB_GRAUPAR,
	CASE 
		WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL  AND RTRIM(DP.RB_GRAUPAR) = 'C' THEN '2'  -- C?NJUGUE - CASAMENTO
		WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL  AND RTRIM(DP.RB_GRAUPAR) = 'F' THEN '1'  -- FILHO      NASCIMENTO
        WHEN  TRIM(DP.RB_NREGCAR) IS NOT NULL AND TRIM(DP.RB_GRAUPAR) = 'P' AND TRIM(DP.RB_SEXO) = 'M' THEN '1'  -- Pai
        WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL AND TRIM(DP.RB_GRAUPAR) = 'P' AND TRIM(DP.RB_SEXO) = 'F' THEN '1'   -- Mae
             WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL  AND RTRIM(DP.RB_GRAUPAR) = 'O' THEN '1' 
		ELSE''
	END AS "39_Tipo da Certidao",
	-----------------------------------------------------------------------------------------------
	CASE 
		WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL THEN TRIM(DP.RB_NREGCAR)
		ELSE''
	END AS "40_Matr?cula da Certidao",
	-----------------------------------------------------------------------------------------------
	/*CASE 
		WHEN REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(RTRIM(DP.RB_NREGCAR),'.',''),'-V',''),'REG',''),'CIV',''),'I','') <>'' THEN REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(RTRIM(DP.RB_NREGCAR),'.',''),'-V',''),'REG',''),'CIV',''),'I','')
		ELSE''
	END*/
   '' AS "41 N?mero da Certidao",
	-----------------------------------------------------------------------------------------------
	CASE 
		WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL  THEN
                                                CASE 
                                                    WHEN TRIM(DP.RB_NUMLIVR) IS NOT NULL THEN REPLACE(TRIM(DP.RB_NUMLIVR),'-','')
                                                    ELSE''
                                                END
		ELSE''
	END AS "42 Livro da Certid?o",
	-----------------------------------------------------------------------------------------------
    
	CASE 
		WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL  THEN 
                                            CASE 
                                                 WHEN 
                                                        REPLACE(REPLACE(REPLACE(TRIM(DP.RB_NUMFOLH),'',''),'-',''),'/','') = '295296' THEN '295'
                                                WHEN 
                                                        TRIM(DP.RB_NUMFOLH) IS NOT NULL THEN REPLACE(REPLACE(REPLACE(TRIM(DP.RB_NUMFOLH),'',''),'-',''),'/','')
                                                ELSE''
                                            END
		ELSE''
	END AS "43 Folha da Certid?o",
	-----------------------------------------------------------------------------------------------
	CASE 
		WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL  THEN
                                                CASE 
                                                    WHEN TRIM(DP.RB_CARTORI) IS NOT NULL THEN TRIM(DP.RB_CARTORI)
                                                    ELSE''
                                                END
		ELSE''
	END AS "44 Cartorio da Certidao",
	-----------------------------------------------------------------------------------------------
	/*CASE 
		WHEN REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(RTRIM(DP.RB_NREGCAR),'.',''),'-V',''),'REG',''),'CIV',''),'I','') IS NOT NULL THEN''
		ELSE''
	END*/
   '' AS "45 Estado da Certidao",
	-----------------------------------------------------------------------------------------------
	/*CASE 
		WHEN REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(RTRIM(DP.RB_NREGCAR),'.',''),'-V',''),'REG',''),'CIV',''),'I','')IS NOT NULL THEN''
		ELSE''
	END*/
   '' AS "46 Munic?pio da Certidao",
	-----------------------------------------------------------------------------------------------
	/*CASE 
		WHEN REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(RTRIM(DP.RB_NREGCAR),'.',''),'-V',''),'REG',''),'CIV',''),'I','') IS NOT NULL THEN''
		ELSE''
	END*/
   '' AS "47 Data de emiss?o da Certidao",
	-----------------------------------------------------------------------------------------------
	/*CASE 
		WHEN REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(RTRIM(DP.RB_NREGCAR),'.',''),'-V',''),'REG',''),'CIV',''),'I','') IS NOT NULL THEN''
		ELSE''
	END*/
   '' AS "48 N?mero da DNV da Certid?o",
	-----------------------------------------------------------------------------------------------
	CASE 
		WHEN TRIM(DP.RB_NREGCAR) IS NOT NULL THEN
                                                CASE 
                                                    WHEN RTRIM(DP.RB_DTENTRA) IS NOT NULL THEN SUBSTR(DP.RB_DTENTRA,7,2)|| SUBSTR(DP.RB_DTENTRA,5,2)||SUBSTR(DP.RB_DTENTRA,1,4)
                                                    ELSE''
                                                END
		ELSE''
	END AS "49 Data de entrega da certid?o",
	-----------------------------------------------------------------------------------------------
	'' AS "50 Data da ?ltima vacina??o",
	-----------------------------------------------------------------------------------------------
	'' AS "51 Data de Vencimento da Carteira vacinacao",
	'' AS "52 Data da entrega da Carteira de Vacinacao",
	'' AS "53 Instituicao Escolar",
	'' AS "54 Serie/Ano Escolar",
	'' AS "55 Data da entrega da Frequencia",
	'' AS "56 Data de vencimento da Frequencia",
	-----------------------------------------------------------------------------------------------
/* ATIVAO IR ERIC
	CASE
        WHEN DP.RB_TIPIR IN ('1','2','3')
        THEN 
            CASE 
                WHEN TRIM(DP.RB_DTNASC)< TRIM(F.RA_ADMISSA)
                THEN SUBSTR(F.RA_ADMISSA,7,2)|| SUBSTR(F.RA_ADMISSA,5,2)||SUBSTR(F.RA_ADMISSA,1,4)
                ELSE SUBSTR(DP.RB_DTNASC,7,2)|| SUBSTR(DP.RB_DTNASC,5,2)||SUBSTR(DP.RB_DTNASC,1,4)
            END  
        ELSE''
    END AS "57 Data de ativacao do IRRF",
*/
--TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2)) AS "IDADE",
CASE -- EM 13/08 PASSEI A USAR ATIVAAO DO CARLOS
            WHEN DP.RB_TIPIR IN ('1','2','3') --1=s/Lim.Idade;2=Ate 21 Anos;3=Ate 24 Anos;4=Nao e Dep.
           -- AND DATEDIFF(YEAR,RB_DTNASC,GETDATE()) <=24 THEN  SQL SERVER
          AND TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2)) <= 24 THEN
         
                    CASE 
                            WHEN TRIM(DP.RB_DTNASC)< TRIM(F.RA_ADMISSA)
                        --   THEN REPLACE(CONVERT(CHAR, CONVERT(DATETIME, STR (F.RA_ADMISSA)),103),'/','') SQL SERVER
                       --    ELSE REPLACE(CONVERT(CHAR, CONVERT(DATETIME, STR (DP.RB_DTNASC)),103),'/','') SQL SERVER
                       THEN SUBSTR(F.RA_ADMISSA,7,2)|| SUBSTR(F.RA_ADMISSA,5,2)||SUBSTR(F.RA_ADMISSA,1,4)
                       ELSE SUBSTR(DP.RB_DTNASC,7,2)|| SUBSTR(DP.RB_DTNASC,5,2)||SUBSTR(DP.RB_DTNASC,1,4)
                    END  
            ELSE ''
            END AS "57 DATA DE ATIVACAO DO IRRF",
    /* J ESTAVA COMENTADO
    CASE 
		WHEN DP.RB_TIPIR = '1' THEN 
									CASE
										WHEN (RTRIM(DP.RB_GRAUPAR) = 'F' AND TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2)) > 24 AND RTRIM(RB_INCT) = '2')
											 OR (RTRIM(DP.RB_GRAUPAR) = 'F' AND (TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2)) < 24)
											 OR (RTRIM(DP.RB_GRAUPAR) <> 'F') THEN 
																					CASE 
																						WHEN CAST(DP.RB_DTNASC AS DATE) > GETDATE() THEN SUBSTR(RA_ADMISSA,7,2)|| SUBSTR(RA_ADMISSA,5,2)||SUBSTR(RA_ADMISSA,1,4)
																						WHEN RTRIM(DP.RB_DTNASC) < RTRIM(F.RA_ADMISSA) THEN REPLACE(CONVERT(VARCHAR, CAST(F.RA_ADMISSA AS DATE), 103), '/','')
																						ELSE REPLACE(CONVERT(VARCHAR, CAST(DP.RB_DTNASC AS DATE), 103), '/','')
																					END
										ELSE''
									END

		WHEN DP.RB_TIPIR = '2' AND RTRIM(DP.RB_GRAUPAR) = 'F' 
			AND TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2)) <= 21 THEN		
																														CASE 
																															WHEN RTRIM(DP.RB_DTNASC) < RTRIM(F.RA_ADMISSA) THEN REPLACE(CONVERT(VARCHAR, CAST(F.RA_ADMISSA AS DATE), 103), '/','')
																															ELSE REPLACE(CONVERT(VARCHAR, CAST(DP.RB_DTNASC AS DATE), 103), '/','')
																														END
		WHEN DP.RB_TIPIR = '3' AND RTRIM(DP.RB_GRAUPAR) = 'F' 
			AND TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2))) <= 24 THEN 
																														CASE 
																															WHEN RTRIM(DP.RB_DTNASC) < RTRIM(F.RA_ADMISSA) THEN REPLACE(CONVERT(VARCHAR, CAST(F.RA_ADMISSA AS DATE), 103), '/','')
																															ELSE REPLACE(CONVERT(VARCHAR, CAST(DP.RB_DTNASC AS DATE), 103), '/','')
																														END
		WHEN DP.RB_TIPIR = '4' THEN''
		ELSE''
	END AS "57 Data de ativacao do IRRF",*/
	---------------------------------------------------------------------------------------------
	''  AS "58 Data fim de ativacao do IRRF",
	---------------------------------------------------------------------------------------------
	
    CASE
        WHEN DP.RB_TIPSF IN ('1','2') AND TO_NUMBER(SUBSTR((TO_NUMBER(TO_CHAR(sysdate, 'YYYYMMDD')) - TO_NUMBER(DP.RB_DTNASC)),1,2))<15
        THEN 
            CASE 
                WHEN TRIM(DP.RB_DTNASC)< TRIM(F.RA_ADMISSA)
                THEN SUBSTR(F.RA_ADMISSA,7,2)|| SUBSTR(F.RA_ADMISSA,5,2)||SUBSTR(F.RA_ADMISSA,1,4)
                ELSE SUBSTR(DP.RB_DTNASC,7,2)|| SUBSTR(DP.RB_DTNASC,5,2)||SUBSTR(DP.RB_DTNASC,1,4)
            END  
        ELSE''
    END "59 Data de ativacao do Salario Familia",
    
    --RB_INCT,   -- Dep. Incapacitado
	--RB_TIPSF,
	/*
    CASE 
		WHEN RTRIM(DP.RB_TIPSF) = '1' AND RTRIM(DP.RB_GRAUPAR) = 'F' AND RTRIM(DP.RB_INCT) = '2' THEN 
																								CASE 
																									WHEN RTRIM(DP.RB_DTNASC) < RTRIM(F.RA_ADMISSA) THEN REPLACE(CONVERT(VARCHAR, CAST(F.RA_ADMISSA AS DATE), 103), '/','')
																									ELSE REPLACE(CONVERT(VARCHAR, CAST(DP.RB_DTNASC AS DATE), 103), '/','')
																								END
		WHEN RTRIM(DP.RB_TIPSF) = '2' AND RTRIM(DP.RB_GRAUPAR) = 'F' 
			AND (DATEDIFF(DAY,CONVERT(VARCHAR,RTRIM(DP.RB_DTNASC),112), CONVERT(VARCHAR,GETDATE(),112)) / 365.25) <= 14 THEN 
																														CASE 
																															WHEN RTRIM(DP.RB_DTNASC) < RTRIM(F.RA_ADMISSA) THEN REPLACE(CONVERT(VARCHAR, CAST(F.RA_ADMISSA AS DATE), 103), '/','')
																															ELSE REPLACE(CONVERT(VARCHAR, CAST(DP.RB_DTNASC AS DATE), 103), '/','')
																														END
		WHEN RTRIM(DP.RB_TIPSF) = '3' THEN''
		ELSE''
	END	AS "59 Data de ativacao do Salario Familia",*/
	---------------------------------------------------------------------------------------------
	''  AS "60 Data fim de ativacao do Salario Familia",
	---------------------------------------------------------------------------------------------

	'' AS "61 Permanente",
	---------------------------------------------------------------------------------------------
	'' AS "62 CEP do endereco",
	---------------------------------------------------------------------------------------------
	'' AS "63 Tipo do logradouro",
	---------------------------------------------------------------------------------------------
	'' AS "64 Logradouro",
	---------------------------------------------------------------------------------------------
	'' AS "65 Numero",
	---------------------------------------------------------------------------------------------
	'' AS "66 Complemento",
	---------------------------------------------------------------------------------------------
	'' AS "67 Bairro",
	---------------------------------------------------------------------------------------------
	''  AS "68 Estado",
	---------------------------------------------------------------------------------------------
	'' AS "69 Municipio",
	---------------------------------------------------------------------------------------------
	''  AS "70 Caixa postal",
	''  AS "71 CEP da caixa postal",
	--DP.RB_COD  
   '' AS "72 Codigo do Dependente",
    '' AS "Genero"

--SELECT *
FROM 
	TB_AUX_DEPENDENTES DP
	LEFT JOIN TB_AUX_FUNCIONARIOS F 
        ON DP.CODEMP = F.CODEMP AND F.RA_FILIAL = DP.RB_FILIAL AND F.RA_MAT = DP.RB_MAT
 /* 
  
        where not exists (select 1 from TB_AUX_MOTIVOS_RESCISAO
WHERE X5_CHAVE = F.RA_RESCRAI AND X5_FILIAL = F.RA_FILIAL AND X5_CHAVE IN (30, 31))--31-TRANSFERENCIA SEM ONUS PARA A CEDENTE/30-TRANSFERENCIA COM ONUS PARA A CEDENTE 
AND F.RA_MAT = '000030'
AND F.RA_FILIAL = '010105'



/*
AND TRIM(F.RA_FILIAL || F.RA_MAT) NOT IN ('010102002639','010101004104','060102000031','060101000032','060102000033') --5 MATRICULAS DE TRANF ENTRE EMPRESA
    AND  DP.RB_FILIAL || DP.RB_CIC NOT IN ( --DEPENDENTES REPETIDOS POR FILIAL E CPF
'01020318733373612',
'01010509191444109',
'01010509191444209',
'08010100405322160',
'08010107565505137',
'08010108058743135',
'08010108775963108',
'08010110318548194',
'06010162464374350',
'06010162366756356',
'06010163304248301',
'06010163304238301',
'01020103959420281',
'01020103959421281',
'07010107552719125',
'07010108697298105',
'07010108671282163',
'07010108671282863',
'07010108671360148',
'07010108671319180',
'07010108737115138',
'01020102449746242',
'01020102449746442',
'06010160201655314',
'07010102217045156',
'07010104039646100',
'07010109300818112',
'07010106154415133',
'07010110019113188'
)
 ORDER BY to_number( FN_RETORNA_EMPRESA(F.RA_FILIAL, F.CODEMP)), to_number(FN_RETORNA_MATRICULA_LG(F.RA_FILIAL, F.RA_MAT) ), to_number(TRIM(DP.RB_COD))
   
*/
