/*
	Historico de Rescisoes
	Base Protheus*/

SELECT DISTINCT

LGM.MATRICULA_LG AS "01_Matricula",                 
FN_RETORNA_EMPRESA(F.RA_FILIAL, F.CODEMP) AS "02_Codigo da Empresa",
TO_CHAR (TO_DATE (res.RG_DATADEM, 'YYYYMMDD'), 'YYYY/MM/DD') AS "03_Data da ocorrencia",
'' AS "04_Data (Publicacao)",
'' AS "05_Situacao (Publicacao)",
TO_CHAR (TO_DATE (res.RG_DTGERAR, 'YYYYMMDD'), 'YYYY/MM/DD') AS "06_Data do pagamento",
CASE   
WHEN TRIM(res.RA_RESCRAI) = 10 THEN '35' -- RESCISAO COM JUSTA CAUSA INICIATIVA DO EMPREGADOR      
WHEN TRIM(res.RA_RESCRAI) = 11 THEN '36' -- RESCISAO SEM JUSTA CAUSA INICIATIVA DO EMPREGADOR      
WHEN TRIM(res.RA_RESCRAI) = 12 AND res.RA_CATFUNC NOT IN('E') THEN '41' -- EXTINCAO DO CONTRATO DE TRABALHO INICIATIVA EMPREGADOR 
WHEN TRIM(res.RA_RESCRAI) = 12 AND res.RA_CATFUNC IN('E') THEN '42' -- EXTINCAO DO CONTRATO DE TRABALHO INICIATIVA EMPREGADOR 
WHEN TRIM(res.RA_RESCRAI) = 21 THEN '38' -- RESCISAO SEM JUSTA CAUSA INICIATIVA EMPREGADO          
WHEN TRIM(res.RA_RESCRAI) = 60 THEN '43' -- FALECIMENTO                                            
WHEN TRIM(res.RA_RESCRAI) = 75 THEN '52' -- APOSENTADORIA COMPULSORIA                              
ELSE '' END AS "07_Tipo da rescisao (Rais)",                                 

CASE 
WHEN res.RA_CATFUNC IN('P','E') THEN '' 
WHEN TRIM(res.RA_RESCRAI) = 10 THEN '1' -- RESCISAO COM JUSTA CAUSA INICIATIVA DO EMPREGADOR      
WHEN TRIM(res.RA_RESCRAI) = 11 THEN '2' -- RESCISAO SEM JUSTA CAUSA INICIATIVA DO EMPREGADOR      
WHEN TRIM(res.RA_RESCRAI) = 12 THEN '6' -- EXTINCAO DO CONTRATO DE TRABALHO INICIATIVA EMPREGADOR 
WHEN TRIM(res.RA_RESCRAI) = 21 THEN '4' -- RESCISAO SEM JUSTA CAUSA INICIATIVA EMPREGADO          
WHEN TRIM(res.RA_RESCRAI) = 60 THEN '10' -- FALECIMENTO                                            
WHEN TRIM(res.RA_RESCRAI) = 75 THEN '18' -- APOSENTADORIA COMPULSORIA  
ELSE ''           
END AS "08_Motivo legal do desligamento", /* Colaborador com vinculo */
CASE WHEN res.RA_CATFUNC = 'P' THEN '1' ELSE '' END AS "09_Motivo legal do desligamento", /* Colaborador sem vinculo */
'' AS "10_Codigo (Motivo do desligamento)",

CASE TRIM(res.RA_RESCRAI)
WHEN '11' THEN '1'
WHEN '12' THEN '4'
WHEN '60' THEN '23'
WHEN '75' THEN '5'
ELSE '0' END AS "11_Codigo do Saque",

CASE
WHEN TRIM(res.RG_DTAVISO) <> '' THEN TO_CHAR (TO_DATE (res.RG_DTAVISO, 'YYYYMMDD'), 'YYYY/MM/DD') 
WHEN TRIM(res.RA_RESCRAI) = '11' THEN TO_CHAR (TO_DATE (res.RG_DATADEM, 'YYYYMMDD'), 'YYYY/MM/DD')  
WHEN TRIM(res.RA_RESCRAI) = '21' THEN TO_CHAR (TO_DATE (res.RG_DATADEM, 'YYYYMMDD'), 'YYYY/MM/DD')
ELSE '' END AS "12_Inicio do aviso previo",
CASE
WHEN RG_DTPROAV ='        ' THEN ''
ELSE TO_CHAR (TO_DATE (res.RG_DTPROAV, 'YYYYMMDD'), 'YYYY/MM/DD') END AS "13_Projecao do Aviso previo",
'' AS "14_Processo trabalhista",
'' AS "15_Processo judicial com suspensao",
RTRIM(LTRIM(res.RG_OBITO)) AS "16_Atestado de obito",
CASE
WHEN RTRIM(res.RA_RESCRAI) = '10' THEN '57'
WHEN RTRIM(res.RA_RESCRAI) = '11' AND TRIM(res.RG_DTPROAV) > TRIM(res.RG_DATADEM) 
THEN '52' --RESCISAO DEMISSAO S/ JC AVISO INDENIZADO
WHEN RTRIM(res.RA_RESCRAI) = '11' AND (TRIM(res.RG_DTPROAV) <= TRIM(res.RG_DATADEM) OR res.RG_DTPROAV = '        ')
THEN '53' --RESCISAO DEMISSAO S/ JC AVISO TRAB
WHEN RTRIM(res.RA_RESCRAI) = '12' THEN '60' -- RESC ESTAGIARIO
WHEN RTRIM(res.RA_RESCRAI) = '21' AND TRIM(res.RG_DTPROAV) > TRIM(res.RG_DATADEM) THEN '55' --RESC PEDIDO DEMISS AVISO IND
WHEN RTRIM(res.RA_RESCRAI) = '21' AND (TRIM(res.RG_DTPROAV) <= TRIM(res.RG_DATADEM) OR res.RG_DTPROAV = '        ') THEN '56' --RESC PEDIDO DEMISS AVISO TRAB
WHEN RTRIM(res.RA_RESCRAI) = '60' THEN '61' -- FALECIMENTO                                            
WHEN RTRIM(res.RA_RESCRAI) = '75' THEN '65' -- APOSENTADORIA COMPULSORIA 
ELSE 'VERIFICAR' END AS "17_Codigo (Nova situacao)",  
CASE 	
WHEN res.RA_CATFUNC = 'E' THEN 12 -- ESTAGIARIO / ESTAGIARIO
WHEN res.RA_CATFUNC = 'P' THEN 81 -- PROLABORE / PROLABORE 
ELSE 5 END AS "18_Codigo (Folha de Pagamento)",
CASE WHEN LENGTH(res.RG_DATAHOM) = 8 THEN 'S' ELSE 'N' END AS "19_Homologacao",
CASE WHEN LENGTH(res.RG_DATAHOM) <> 8 THEN 'S' ELSE 'N' END AS "20_Quitacao",
CASE 
WHEN TRIM(NVL(res.RG_DATAHOM,'')) = '' THEN ''
ELSE TO_CHAR (TO_DATE (res.RG_DATAHOM, 'YYYYMMDD'), 'YYYY/MM/DD') END AS "21_Data da Homologacao",
'' AS "22_Informacoes a Caixa",
CASE TRIM(res.RG_COMPRAV)
WHEN '1' THEN 'S'
WHEN '2' THEN 'N' ELSE '' END AS "23_Colaborador comprovou ter novo e",
'' AS "24_Efetivar a rescisao e manter pro",
'' AS "25_Em caso de exclusao manter ocorr",
'' AS "26_Transferencia por motivo de suce",
'' AS "27_Preencher dados do empregador su",
'' AS "28_CNPJ",
'' AS "29_Razao Social",
'' AS "30_Efetivar rescisao mesmo quando a",
'' AS "31_Efetivar a rescisao somente se o",
'' AS "32_Impedir alteracao do gestor da u",
'' AS "33_Lancar saldo devedor de emprestimos",
'' AS "34_Efetivar a rescisao caso nao exi",
'' AS "35_Exclusao de valores calculados p",
'0' AS "36_Tipo de rescisao",
'' AS "37_Quarentena Trabalhista",
'' AS "38_Data fim da quarentena",
CASE 
WHEN TRIM(res.RG_DTPROAV) > TRIM(res.RG_DATADEM) AND TRIM(res.RA_RESCRAI) = '11'
THEN 'S' ELSE '' END AS "39_Aviso previo indenizado",
CASE 
WHEN TRIM(NVL(res.RG_INDAV,'')) = '' THEN '4'
ELSE TRIM(res.RG_INDAV) END AS "40_Cumprimento do aviso previo",
'' AS "41_Credito Consignado com Garantia de",
'S' AS "42_Mesmo que o colaborador possua o",
'S' AS "43_Mesmo quando a data da rescisao",
'S' AS "44_O colaborador esteja em periodo",
'S' AS "45_E estornar ocorrencias programad",
'' AS "46_Efetivar o estorno da rescisao m",
'S' AS "47_E estornar ocorrencias programad",
'S' AS "48_E estornar ocorrencias programad"

FROM
HISTORICO_RESCISAO res

LEFT JOIN TB_AUX_FUNCIONARIOS F ON F.RA_FILIAL = res.RG_FILIAL AND F.RA_MAT = res.RA_MAT 
AND F.CODEMP = res.CODEMP

INNER JOIN LG_DEPARA_MATRICULA LGM
	ON (LGM.FILIAL_PROTHEUS = F.RA_FILIAL AND LGM.MATRICULA_PROTHEUS = F.RA_MAT AND LGM.EMPESA_PROTHEUS = F.CODEMP)
	
WHERE res.RA_CATFUNC <> 'A'

AND 
        res.RG_DTGERAR = (
						SELECT 
							MIN(sub.RG_DTGERAR)
						FROM
							HISTORICO_RESCISAO sub
						WHERE	
							sub.RG_FILIAL = res.RG_FILIAL
							AND sub.RA_MAT = res.RA_MAT
							AND res.CodEmp = sub.CodEmp
                            )


ORDER BY 2,1


--SELECT * FROM SIGAP12.SRG010
--WHERE RG_FILIAL = '010101' AND RG_MAT = '003529'