/*
	!! ATENO !!
	1 - O Protheus trabalha com os 2 conceitos de cargos e funo, que podem ser ou no iguais,
	no caso da Cicopal, o cliente informou que o CBO devemos para olhar somente para a funo.

	2 - Tomar muito cuidado e verificar se existe na base o cenrio bizarro:
	Ao movimentar um colaborador, l no sistema deles eles selecionam a funo mas podem modificar 
	a descrio da funo (cargo). Isso ir impactar porque no movimentamos para cargos iguais. Ento se existe esse caso
	usar o cdigo da funo ou cargo (item 1) pode estar errado. Alinhe com o cliente!

	Abs.

	Histrico de Cargo do Funcionrio
	Tabela: SR7, SRJ

	SELECT * FROM SIGAP12.SR7010 WHERE R7_MAT = '000069'
	SELECT * FROM SIGAP12.SRJ010
	DROP TABLE TB_AUX_HistoricoCargo
    SELECT * FROM TB_AUX_HistoricoCargo
*/
CREATE TABLE tb_aux_historicocargo
    AS
        SELECT
            '01' AS codemp,	/* Cdigo da Empresa */
            mov.r7_filial,		/* Cdigo da Filial */
            mov.r7_mat,			/* Matrcula do Colaborador */
            mov.r7_data,		/* Data da Movimentao */
            mov.r7_tipo,		/* Tipo da Movimentao */
            mov.r7_funcao,		/* Cdigo da Funo */
            mov.r7_descfun,		/* Descrio da Funo Informada */
            mov.r7_seq --SEQUENCIA DE MOVIMENTAO NA MESMA DATA
        FROM
            sigap12.sr7010 mov
               INNER JOIN tb_aux_funcionarios_migrados fm ON mov.r7_filial = fm.ra_filial
                                                          AND mov.r7_mat =fm.ra_mat
        WHERE
            mov.d_e_l_e_t_ <> '*'
            AND FM.CODEMP='01'
        UNION ALL
        SELECT
            '06' AS codemp,
            mov.r7_filial,
            mov.r7_mat,
            mov.r7_data,
            mov.r7_tipo,
            mov.r7_funcao,		/* Cdigo da Funo */
            mov.r7_descfun,		/* Descrio da Funo Informada */
            mov.r7_seq --SEQUENCIA DE MOVIMENTAO NA MESMA DATA
        FROM
                 sigap12.sr7060 mov
            INNER JOIN tb_aux_funcionarios_migrados fm ON mov.r7_filial = fm.ra_filial
                                                          AND mov.r7_mat =fm.ra_mat
        WHERE
            mov.d_e_l_e_t_ <> '*'
            AND FM.CODEMP='06';
    
    
    SELECT * FROM SR7010 WHERE R7_MAT = '000069'
