/**********************************************************************************************************************/
/**** PROJETO GRUPO CICOPAL 2022                                                                                     **/
/**** IMPLANTAO DOS FUNCIONARIOS                                                                                  **/
/**** SCRITP DE PREPARAO DA MIGRAO                                                                               **/
/**** ESSE SCRIPT GERA TABELA HISTORICO SALARIO (TB_AUX_HISTORICOSALARIO)                                                      **/
/**********************************************************************************************************************/

--------------------------------------------------------
-- GERAO DA TABELA 
--------------------------------------------------------

create table TB_AUX_HISTORICOSALARIO AS (

	SELECT
		'01' AS CodEmp,	/* Cod Empresa */
		mov.R3_FILIAL,		/* Cod Filial */
		mov.R3_MAT,			/* Matricula */
		fun.RA_ADMISSA,		/* Data de Admissao */
		mov.R3_DATA,		/* Data da Movimentacao */
		mov.R3_DTCDISS,		/* Data Dissidio */
		mov.R3_TIPO,		/* Tipo Movimentacao */
		mov.R3_PD,			/* Cod ProventoDesconto */
		mov.R3_DESCPD,		/* Descricao Provento Desconto */
		mov.R3_VALOR,		/* Valor */
		mov.R3_SEQ			/* Sequencial */
	FROM 
		SIGAP12.SR3010 mov
		INNER JOIN SIGAP12.SRA010 fun ON mov.R3_MAT = fun.RA_MAT AND mov.R3_FILIAL = fun.RA_FILIAL
	WHERE 
		mov.D_E_L_E_T_ <> '*'

	UNION ALL

	SELECT
		'06' AS CodEmp,
		mov.R3_FILIAL,		/* Cod Filial */
		mov.R3_MAT,			/* Matr?cula */
		fun.RA_ADMISSA,		/* Data de Admiss?o */
		mov.R3_DATA,		/* Data da Movimenta??o */
		mov.R3_DTCDISS,		/* Data Dissidio */
		mov.R3_TIPO,		/* Tipo Movimenta??o */
		mov.R3_PD,			/* Cod ProventoDesconto */
		mov.R3_DESCPD,		/* Descri??o Provento Desconto */
		mov.R3_VALOR,		/* Valor */
		mov.R3_SEQ			/* Sequencial */
	FROM 
		SIGAP12.SR3060 mov
		INNER JOIN SIGAP12.SRA060 fun ON mov.R3_MAT = fun.RA_MAT AND mov.R3_FILIAL = fun.RA_FILIAL
	WHERE 
		mov.D_E_L_E_T_ <> '*'
);