/*
	Tabelas: RFX e CUR

SELECT * FROM SIGAP12.RFX010
SELECT * FROM SIGAP12.CUR010

*/

CREATE TABLE TB_AUX_MOVIMENTACAO_ESTABILIDADE AS

SELECT
	'01' AS CodEmp,                         /* Empresa */
	est.RFX_FILIAL,                         /* Filial */
	est.RFX_MAT,                            /* Matricula */
	est.RFX_DATAI,                          /* Data de Inicio */
	est.RFX_DATAF,                          /* Data Fim */
    TRIM(est.RFX_OBSEST) AS RFX_OBSEST,     /* Observações */
	esttip.CUR_CODIGO,                      /* Cod Tipo */
	TRIM(esttip.CUR_DESCRI) AS CUR_DESCRI,   /* Desc Tipo */
	est.RFX_TPESTB MOT_LOGIN
FROM
	SIGAP12.RFX010 est
	LEFT JOIN SIGAP12.CUR010 esttip ON RTRIM(est.RFX_TPESTB) = ('S' || RTRIM(esttip.CUR_CODIGO))
WHERE
	est.D_E_L_E_T_ <> '*'
    
    
   union all  SELECT
	'06' AS CodEmp,                         /* Empresa */
	est.RFX_FILIAL,                         /* Filial */
	est.RFX_MAT,                            /* Matricula */
	est.RFX_DATAI,                          /* Data de Inicio */
	est.RFX_DATAF,                          /* Data Fim */
    TRIM(est.RFX_OBSEST) AS RFX_OBSEST,     /* Observações */
	esttip.CUR_CODIGO,                      /* Cod Tipo */
	TRIM(esttip.CUR_DESCRI) AS CUR_DESCRI,   /* Desc Tipo */
	est.RFX_TPESTB MOT_LOGIN
FROM
	SIGAP12.RFX060 est
	LEFT JOIN SIGAP12.CUR060 esttip ON RTRIM(est.RFX_TPESTB) = ('S' || RTRIM(esttip.CUR_CODIGO))
WHERE
	est.D_E_L_E_T_ <> '*'