/*
LAYOUT APOSENTADORIA

017	Aposentadoria por Invalidez  
*/

SELECT

LGM.MATRICULA_LG AS "1 Matricula", 
FN_RETORNA_EMPRESA(TB_AUX_FUNCIONARIOS.RA_FILIAL, TB_AUX_FUNCIONARIOS.CODEMP) AS "2 Codigo da Empresa",
    -----------------------------------------------
    CASE
		WHEN afast.R8_DATAINI IS NOT NULL THEN 
		TO_CHAR (TO_DATE (R8_DATAINI, 'YYYYMMDD'), 'YYYY/MM/DD') 
		ELSE ''	END AS "3 Data da ocorrencia", 
    '' AS "4 Data (Publicacao)",                       
    '' AS "5 Situação (Publicacao)",  
    CASE
        WHEN TRIM(afast.R8_DATAFIM) IS NOT NULL THEN 
		SUBSTR(afast.R8_DATAFIM,7,2) ||'/' || SUBSTR(afast.R8_DATAFIM, 5, 2) || '/' || SUBSTR(afast.R8_DATAFIM,1, 4) 
		ELSE '' END AS "6 Data de retorno",      
   CASE
		WHEN RTRIM(LTRIM(afast.R8_TIPOAFA)) = '017'  THEN '76'
        ELSE '' END AS "7 Tipo de aposentadoria (Rais)",                
   CASE
        WHEN RTRIM(LTRIM(afast.R8_TIPOAFA)) = '017'  THEN '35'
        ELSE '' END AS "8 Código (Situacao)",   
    '' AS "9 Data do laudo",       
    -----------------------------------------------
    'N' AS "10 Alteracao de Motivo de Afastamento",
    -----------------------------------------------
    '' AS "11 Data",                
    '' AS "12 Matrícula (Afastamento anterior ...[02]",                    
    '' AS "13 Código da Empresa (Afastamento a...[03]",
    '' AS "14 Data da ocorrência (Afastamento ...[04]", 
    '' AS "15 Efeito retroativo",                   
    '' AS "16 Observacoes",              
    '' AS "17 Origem da alteracao",                  
    '' AS "18 Numero do processo"            

FROM 
	TB_AUX_HISTORICOAFASTAMENTO afast
	
LEFT JOIN TB_AUX_FUNCIONARIOS ON RA_FILIAL = afast.R8_FILIAL AND RA_MAT = afast.R8_MAT 
AND TB_AUX_FUNCIONARIOS.CODEMP = afast.CODEMP
INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS F ON afast.CODEMP = F.CODEMP
                                                 AND afast.R8_FILIAL = F.RA_FILIAL
                                                AND afast.R8_MAT = F.RA_MAT
												
LEFT JOIN LG_DEPARA_MATRICULA LGM
ON LGM.FILIAL_PROTHEUS = TB_AUX_FUNCIONARIOS.RA_FILIAL AND LGM.MATRICULA_PROTHEUS = TB_AUX_FUNCIONARIOS.RA_MAT 
AND LGM.EMPESA_PROTHEUS = TB_AUX_FUNCIONARIOS.CODEMP
	
AND TB_AUX_FUNCIONARIOS.CODEMP = afast.CODEMP
INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS F ON afast.CODEMP = F.CODEMP
AND afast.R8_FILIAL = F.RA_FILIAL AND afast.R8_MAT = F.RA_MAT
												
										
WHERE
	afast.R8_TIPOAFA = '017' /* Aposentadoria */
    
	
	
ORDER BY
	afast.CodEmp,
	afast.R8_FILIAL,
	afast.R8_MAT,
	afast.R8_DATAINI
