/**********************************************************************************************************************/
/********** PROJETO GRUPO CICOPAL 2022 ********************************************************************************/
/********** IMPLANTAO DOS FUNCIONARIOS ******************************************************************************/
/********** CRIAO DEPARA DE MUNICIPIO :  ****************************************************************************/
/**********************************************************************************************************************/
/**********************************************************************************************************************/


/*
    
    Tabela - TB_AUX_MUNICIPIOS
    SELECT * FROM TB_AUX_MUNICIPIOS
    DROP TABLE TB_AUX_MUNICIPIOS
    
*/
CREATE TABLE TB_AUX_MUNICIPIOS (
        CDMUNICIPIO	NUMBER(7,0),
        NMMUNICIPIO	VARCHAR2(100 BYTE),
        CDESTADO	NUMBER(5,0),
        CDPAIS	NUMBER(5,0),
        SGESTADO	VARCHAR2(5 BYTE),
        NMPAIS	VARCHAR2(100 BYTE)
);



/*

    Tabela - TB_AUX_MUNICIPIOS_UNIFICADOS
    SELECT * FROM TB_AUX_MUNICIPIOS_UNIFICADOS;
    DROP TABLE TB_AUX_MUNICIPIOS_UNIFICADOS;
    
*/
CREATE TABLE TB_AUX_MUNICIPIOS_UNIFICADOS (
    conceito   VARCHAR2(100),
    municipio  VARCHAR2(100),
    uf         VARCHAR2(10)
    
);

INSERT INTO TB_AUX_MUNICIPIOS_UNIFICADOS (CONCEITO, MUNICIPIO, UF) 
(SELECT DISTINCT
	 'BANCOS' AS CONCEITO,TRIM(A6_MUN) AS MUNICIPIO,TRIM(A6_EST) AS UF --,'' AS COD_MUN
FROM  
	  SIGAP12.SA6010 SA6 -- TABELA COM TODOS BANCOS EMPRESA 10
WHERE 
      SA6.D_E_L_E_T_ <> '*'
UNION 
      SELECT DISTINCT
	 'BANCOS' AS CONCEITO,TRIM(A6_MUN) AS MUNICIPIO,TRIM(A6_EST) AS UF --,'' AS COD_MUN
FROM  
	  SIGAP12.SA6060 SA6 -- TABELA COM TODOS BANCOS EMPRESA 10
WHERE 
      SA6.D_E_L_E_T_ <> '*'



UNION 
SELECT DISTINCT
     'SINDICATOS' AS CONCEITO,TRIM(RCE_MUNIC) AS MUNICIPIO ,TRIM(RCE_UF) AS UF--,'' AS COD_MUN
FROM  
	  SIGAP12.RCE010 RCE -- TABELA COM TODOS SINDICATOS EMPRESA 10
WHERE       
      RCE.D_E_L_E_T_ <> '*'
UNION
      SELECT DISTINCT
     'SINDICATOS' AS CONCEITO,TRIM(RCE_MUNIC) AS MUNICIPIO ,TRIM(RCE_UF) AS UF--,'' AS COD_MUN
FROM  
	  SIGAP12.RCE060 RCE -- TABELA COM TODOS SINDICATOS EMPRESA 10
WHERE       
      RCE.D_E_L_E_T_ <> '*'



UNION
      SELECT DISTINCT	
     'INSTICUICOES DE ENSINO' AS CONCEITO,TRIM(ra0.ra0_cidade)  AS MUNICIPIO,TRIM(ra0.ra0_estado) AS UF--,'' AS COD_MUN
FROM  
	  SIGAP12.RA0010 RA0 -- TABELA COM TODOS INSTITUICAO DE ENSINO EMPRESA 10
WHERE       
      RA0.D_E_L_E_T_ <> '*'
UNION
      SELECT DISTINCT	
     'INSTICUICOES DE ENSINO' AS CONCEITO,TRIM(ra0.ra0_cidade)  AS MUNICIPIO,TRIM(ra0.ra0_estado) AS UF--,'' AS COD_MUN
FROM  
	  SIGAP12.RA0060 RA0 -- TABELA COM TODOS INSTITUICAO DE ENSINO EMPRESA 10
WHERE       
      RA0.D_E_L_E_T_ <> '*'
      



UNION
SELECT DISTINCT
 'COLABORADORES - NATURALIDADE' AS CONCEITO, TRIM(RA_MUNNASC) AS MUNICIPIO,TRIM(RA_NATURAL) AS UF--,RA_CODMUNN AS COD_MUN
FROM  
	  SIGAP12.SRA010 SRA -- TABELA COM TODOS FUNCIONARIOS EMPRESA 10
WHERE  
      SRA.D_E_L_E_T_ <> '*'
UNION
SELECT DISTINCT
 'COLABORADORES - NATURALIDADE' AS CONCEITO, TRIM(RA_MUNNASC) AS MUNICIPIO,TRIM(RA_NATURAL) AS UF--,RA_CODMUNN AS COD_MUN
FROM  
	  SIGAP12.SRA060 SRA -- TABELA COM TODOS FUNCIONARIOS EMPRESA 60
WHERE  
      SRA.D_E_L_E_T_ <> '*'      
      



UNION
SELECT DISTINCT
 'COLABORADORES - ENDEREO' AS CONCEITO, TRIM(RA_MUNICIP) AS MUNICIPIO,TRIM(RA_ESTADO) AS UF--,RA_CODMUN AS COD_MUN
FROM  
	  SIGAP12.SRA010 SRA -- TABELA COM TODOS FUNCIONARIOS EMPRESA 10
WHERE  
      SRA.D_E_L_E_T_ <> '*'
UNION
SELECT DISTINCT
 'COLABORADORES - ENDEREO' AS CONCEITO, TRIM(RA_MUNICIP) AS MUNICIPIO,TRIM(RA_ESTADO) AS UF--,RA_CODMUN AS COD_MUN
FROM  
	  SIGAP12.SRA060 SRA -- TABELA COM TODOS FUNCIONARIOS EMPRESA 60
WHERE  
      SRA.D_E_L_E_T_ <> '*'      
      



UNION
SELECT DISTINCT
'COLABORADORES - CERTIDO' AS CONCEITO ,TRIM(RA_MUNICIP) AS MUNICIPIO,TRIM(RA_UFCERT) AS UF--,RA_CDMUCER AS COD_MUN
FROM  
	  SIGAP12.SRA010 SRA -- TABELA COM TODOS FUNCIONARIOS EMPRESA 10
WHERE  
      SRA.D_E_L_E_T_ <> '*'
UNION
SELECT DISTINCT
'COLABORADORES - CERTIDO' AS CONCEITO ,TRIM(RA_MUNICIP) AS MUNICIPIO,TRIM(RA_UFCERT) AS UF--,RA_CDMUCER AS COD_MUN
FROM  
	  SIGAP12.SRA060 SRA -- TABELA COM TODOS FUNCIONARIOS EMPRESA 60
WHERE  
      SRA.D_E_L_E_T_ <> '*'      
      



UNION
SELECT DISTINCT
 'R.I.C.' AS CONCEITO, /*RA_MUNIRIC*/ ''  AS MUNICIPIO, TRIM(RA_UFRIC) AS UF--,RA_CDMURIC AS COD_MUN
FROM  
	  SIGAP12.SRA010 SRA -- TABELA COM TODOS FUNCIONARIOS EMPRESA 10
WHERE  
      SRA.D_E_L_E_T_ <> '*'
UNION
SELECT DISTINCT
 'R.I.C.' AS CONCEITO, /*RA_MUNIRIC*/ ''  AS MUNICIPIO, TRIM(RA_UFRIC) AS UF--,RA_CDMURIC AS COD_MUN
FROM  
	  SIGAP12.SRA060 SRA -- TABELA COM TODOS FUNCIONARIOS EMPRESA 60
WHERE  
      SRA.D_E_L_E_T_ <> '*'     )      ;


/*

    Tabela - TB_AUX_MUNICIPIOS_DEPARA
    SELECT * FROM TB_AUX_MUNICIPIOS_DEPARA;
    DROP TABLE TB_AUX_MUNICIPIOS_DEPARA;
    
*/

CREATE TABLE tb_aux_municipios_depara
    AS
        SELECT
            cp.*,
            lg.*
        FROM
            tb_aux_municipios_unificados cp
            LEFT JOIN tb_aux_municipios            lg ON cp.municipio = lg.nmmunicipio
                                              AND cp.uf = lg.sgestado
        ORDER BY
            lg.cdmunicipio,cp.conceito,cp.municipio,cp.uf;