<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 31/07/14
 * Time: 14:20
 */

namespace Folha\Logic\ValesBeneficios\CalculoValeTransporte;

use \Folha\Entities\FpaItecalcfolha;

use Folha\Entities\FpaTipoassoceve;
use Folha\Entities\FpaTipomoviment;
use \Folha\Entities\GpeVinculom;

use \Folha\Entities\GpeVinculoh;

use \Folha\Entities\VabHistvalevinc;

use Folha\Entities\VabIntegtransph;

use \Folha\Entities\VabLinhavinc;

use Folha\Logic\FPATeste;
use \Geral\Util\Ambiente;

use \HCM\Util\DateUtil;

use \Geral\Util\NovoCodigo;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;


class Calculo {

    /**Definição de variáveis de instância
     * @var GpeVinculom $vinculos
     */
    private $nrorg;
    private $vinculos;
    private $dataPagamento;
    private $dataInicio;
    private $dataFinal;
    private $competencia;
    private $nrtipolinhavinc;
    private $hcmParameters;
    private $qtdiasvalefixo;
    private $idcalccomplementar;
    private $idcalccredindev;
    private $dtiniciocredindev;
    private $dtfinalcredindev;

    protected $response;
    protected $idMemoria;
    protected $row;

    /**
     * @param String $vincInicial
     * @param String $vincFinal
     * @param String $dataInicio
     * @param String $dataFinal
     * @param String $dataPagamento
     * @param int $nrorg
     * @param String $dtmescompetencia
     * @param String $ordem
     * @param int $nrtipolinhavinc
     * @throws \Exception
     */
    function __construct(&$response, $idMemoria, $vincInicial, $vincFinal, $dataInicio, $dataFinal, $dataPagamento, $nrorg, $dtmescompetencia, $ordem, $nrtipolinhavinc, $hcmParameters, $row)
    {
        $this->response = $response;
        $this->idMemoria = $idMemoria;
        $this->dataInicio = DateUtil::getDataDeString(substr($dataInicio, 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        $this->dataFinal = DateUtil::getDataDeString(substr($dataFinal, 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        $this->dataPagamento = DateUtil::getDataDeString(substr($dataPagamento, 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        $this->nrorg = $nrorg;
        $this->competencia = $dtmescompetencia;
        $this->nrtipolinhavinc = $nrtipolinhavinc;
        $this->hcmParameters = $hcmParameters;
        $this->row = $row;
        $this->vinculos = $this->buscaVinculo($vincInicial, $vincFinal, $dtmescompetencia, $ordem);
        $this->qtdiasvalefixo = $this->row['QTDIASVALE'];
        $this->idcalccomplementar = $this->row['IDCALCCOMPLEMENTAR'];
        $this->idcalccredindev = $this->row['IDCALCCREDINDEV'];
        $this->dtiniciocredindev = $this->row['DTINICIOCREDINDEV'];
        $this->dtfinalcredindev = $this->row['DTFINALCREDINDEV'];
     }
     
     private function retornaHistoricoPgto($vinculo, $competencia, $dtPagamento){
         try{
            $competencia = DateUtil::getDataDeString($competencia)->format('d/m/Y');
            $dtPagamento = DateUtil::getDataDeString($dtPagamento)->format('d/m/Y');
            $vinculo = $vinculo->getNrvinculom();
            $dtinicioForm = DateUtil::getDataDeString($this->row['DTINICIOVALE'])->format('d/m/Y');
            $dtfimForm = DateUtil::getDataDeString($this->row['DTFINALVALE'])->format('d/m/Y');
            $nrtipolinhavincParam = null;
            
            if(is_null($this->nrtipolinhavinc)){
                $nrtipolinhavincParam = 'A';
            }
            $param = array('P_NRORG' => $this->nrorg);
            
            $historicos = VabHistvalevinc::getObjectsByWhere(
                "NRORG = $this->nrorg AND
                DTMESCOMPAPVALE = '$competencia' AND 
                DTPGTOVALE = '$dtPagamento' AND
                (NRTIPOLINHAVINC = '$this->nrtipolinhavinc' OR '$nrtipolinhavincParam' = 'A') AND
                NRVINCULOM IN ($vinculo)", $param
            );
            
            if($historicos){
                return $historicos;
            } else {
                return array();
            }
         } catch (\Exception $e) {
            throw $e;
        }
     }
     
     private function retornaHistoricoValeEntrePeriodos($vinculo, $competencia){
         try{
            $competencia = DateUtil::getDataDeString($competencia)->format('d/m/Y');
            $vinculo = $vinculo->getNrvinculom();
            $dtinicioForm = DateUtil::getDataDeString($this->row['DTINICIOVALE'])->format('d/m/Y');
            $dtfimForm = DateUtil::getDataDeString($this->row['DTFINALVALE'])->format('d/m/Y');
            $nrtipolinhavincParam = null;
            
            if(is_null($this->nrtipolinhavinc)){
                $nrtipolinhavincParam = 'A';
            }
            $param = array('P_NRORG' => $this->nrorg);
            
            $historicos = VabHistvalevinc::getObjectsByWhere(
                "NRORG = $this->nrorg AND
                DTMESCOMPAPVALE = '$competencia' AND 
                DTINIAPURVALE <= '$dtfimForm' AND 
                DTFINAPURVALE >= '$dtinicioForm' AND
                (NRTIPOLINHAVINC = '$this->nrtipolinhavinc' OR '$nrtipolinhavincParam' = 'A') AND
                NRVINCULOM IN ($vinculo)", $param
            );
            
            if($historicos){
                return $historicos;
            } else {
                return array();
            }
         } catch (\Exception $e) {
            throw $e;
        }
     }

    /**
     * Busca os vínculos que serão calculados
     * @param String $inicial
     * @param String $final
     * @param String $competencia
     * @param String $ordem
     * @return mixed
     * @throws \Exception
     */
    private function buscaVinculo($inicial, $final, $competencia, $ordem)
    {
        try {

            if($competencia instanceof \DateTime){
                $dtmescompetencia = $competencia;
            }else{
                $dtmescompetencia = DateUtil::getDataDeString($competencia, DateUtil::FORMATO_BRASILEIRO, true);
            }

            //18/09/20 alteração para olhar vínculos ativos na competência do operador e não na competência + 1 mês ($dtiniperiodo) como era feito
            $inicompetencia = $dtmescompetencia->format('d/m/Y');
            $fimcompetencia = $dtmescompetencia->format('t/m/Y');

            $dtmescompetencia->add(new \DateInterval('P1M'));
            $dtiniperiodo = $dtmescompetencia->format('d/m/Y');
            $dtfinalvale = $this->dataFinal->format('d/m/Y');
            $dtinicialvale = $this->dataInicio->format('d/m/Y');
            
            // Filtra somente vínculos que possuam histórico
            $vinculosComHistorico = " AND EXISTS (SELECT 1 FROM GPE_VINCULOH WHERE NRVINCULOM = e.NRVINCULOM AND NRORG = e.NRORG and DTMESCOMPETENC <> '01/01/3000') ";
            
            // Filtra somente vínculos que não estejam em situação funcional de afastamento (exceto atestado médico)
            $cond_afastados =
                " AND EXISTS (SELECT * FROM VAB_LINHAVINC VLV 
                                    WHERE VLV.NRVINCULOM = e.NRVINCULOM 
                                    AND VLV.NRORG = e.NRORG
                                    AND VLV.DTINILINHAVINC <= '$dtfinalvale'
                                    AND (VLV.DTFIMLINHAVINC >='$dtinicialvale' OR VLV.DTFIMLINHAVINC IS NULL)
                                ) 
                AND NOT EXISTS (SELECT * FROM GPE_ALTESITUFUNC
                                   WHERE NRORG         = e.NRORG
                                     AND NRVINCULOM    = e.NRVINCULOM
                                     AND NRSITUFUNCM IN (SELECT GPE_SITUFUNCH.NRSITUFUNCM
                                                           FROM GPE_SITUFUNCH
                                                          WHERE GPE_SITUFUNCH.IDGERVALETRANSP = 'N'
                                                            AND GPE_SITUFUNCH.NRSITUFUNCM NOT IN (12, 15, 16, 13)
                                                            AND GPE_SITUFUNCH.DTEFETIVA = ( SELECT * FROM 
                                                                                                ( SELECT DTEFETIVA DTEFETIVA
                                                                                                    FROM GPE_SITUFUNCH MAX_SITUFUNCH
                                                                                                    WHERE MAX_SITUFUNCH.DTEFETIVA <= TO_DATE('$dtfinalvale','DD/MM/YYYY')
                                                                                                    AND MAX_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCH.NRSITUFUNCM
                                                                                                ORDER BY DTEFETIVA DESC
                                                                                                )
                                                                                            WHERE ROWNUM = 1))
                                     AND DTINISITUFUNC = ( SELECT * FROM 
                                                            ( SELECT DTINISITUFUNC
                                                                FROM GPE_ALTESITUFUNC B
                                                                WHERE B.NRORG= e.NRORG 
                                                                AND B.NRVINCULOM= e.NRVINCULOM 
                                                                AND DTINISITUFUNC <= TO_DATE('$dtinicialvale','DD/MM/YYYY')
                                                            ORDER BY DTINISITUFUNC DESC
                                                            )
                                                        WHERE ROWNUM = 1)
                                     AND (DTFIMSITUFUNC > TO_DATE('$dtfinalvale','DD/MM/YYYY') OR DTFIMSITUFUNC IS NULL))";
            switch($ordem)
            {
                case 'ALFABETICA':
                {
                    $param = array(':P_INICIO' => $inicial,
                        ':P_FIM' => $final,
                        ':P_NRORG' => $this->nrorg);

                    //Nome Inicial
                    $whereinivinculo = "NRORG = :P_NRORG AND NRVINCULOM = :P_INICIO"; /** @var GpeVinculom $objinivinculo */
                    $objinivinculo = \Folha\Entities\GpeVinculom::getObjectByWhere($whereinivinculo, $param);

                    //Nome Final
                    $wherefimvinculo = "NRORG = :P_NRORG AND NRVINCULOM = :P_FIM"; /** @var GpeVinculom $objfimvinculo */
                    $objfimvinculo = \Folha\Entities\GpeVinculom::getObjectByWhere($wherefimvinculo, $param);

                    $nomeInicio = $objinivinculo->getNmvinculom();
                    $nomeFinal = $objfimvinculo->getNmvinculom();

                    if($nomeFinal<$nomeInicio){
                        $aux = $nomeFinal;
                        $nomeFinal = $nomeInicio;
                        $nomeInicio = $aux;
                    }

                    $param = array( ':P_INICIO' => $nomeInicio,
                                    ':P_FIM' => $nomeFinal,
                                    ':P_NRORG' => $this->nrorg);
                    //$where = "(DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NMVINCULOM BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $where = "(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NMVINCULOM BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $msgerro = 'Não foram encontrados vínculos para os nomes informados';
                    break;
                }
                case 'MATRICULA':{
                    $param = array(
                        'P_INICIO' => $inicial,
                        'P_FIM' => $final,
                        'P_NRORG' => $this->nrorg);
					//$where = "(DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND CDMATRICULA BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
					$where = "(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND CDMATRICULA BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $msgerro = 'Não foram encontrados vínculos para as matrículas informadas';
                    break;
                }
                case 'DATA_ADMISSAO':{
                    $param = array(':P_NRORG' => $this->nrorg);
                    //$where = "(DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    $where = "(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    $msgerro = 'Não foram encontrados vínculos para as datas informadas';
                    break;
                }
                case 'ESTRUTURA':{
                    $param = array( 'P_NRORG' => $this->nrorg,
                                    'P_NRESTRUTLEGAL' =>$inicial,
                                    'P_NRESTRUTGEREN' =>$final);
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND (NRESTRUTGEREN = :P_NRESTRUTGEREN OR :P_NRESTRUTGEREN IS NULL) AND NRESTRUTLEGAL = :P_NRESTRUTLEGAL AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND (NRESTRUTGEREN = :P_NRESTRUTGEREN OR :P_NRESTRUTGEREN IS NULL) AND NRESTRUTLEGAL = :P_NRESTRUTLEGAL AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                }
                case 'LISTA_VINCULO':
                    $param = array('P_NRORG' => $this->nrorg);
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ($inicial)";
                    $listaVinculo = isset($this->row['NRVINCULOM_LIST']) && is_array($this->row['NRVINCULOM_LIST']) && count($this->row['NRVINCULOM_LIST']) ? implode(",", $this->row['NRVINCULOM_LIST']) : null;
                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ($listaVinculo)";
                    $msgerro = 'Não foram encontrados vínculos para a lista informada';
                    break;
                case 'LISTA_ESTRUTURA':
                    $listaEstrutLegal = isset($this->row['LIST_NRESTRUTLEGAL']) && is_array($this->row['LIST_NRESTRUTLEGAL']) && count($this->row['LIST_NRESTRUTLEGAL']) ? implode(",", $this->row['LIST_NRESTRUTLEGAL']) : null;
                    $listaEstrutGeren = isset($this->row['LIST_NRESTRUTGEREN']) && is_array($this->row['LIST_NRESTRUTGEREN']) && count($this->row['LIST_NRESTRUTGEREN']) ? implode(",", $this->row['LIST_NRESTRUTGEREN']) : 1;
                    
                    
                    
                    $inicial = !empty($this->row['DSINICIOVALE1']) ? $this->row['DSINICIOVALE1'] : null;
                    $final = !empty($this->row['DSFIMVALE1']) ? $this->row['DSFIMVALE1'] : null;
                    
                    $param = array( 'P_NRORG' => $this->nrorg);
                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    } else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial'AND NRORG = :P_NRORG";
                    } else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    } else{
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1))";
                    }                
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                case 'LISTA_NRESTRUTSIND':
                    $estrutLegal = isset($this->row['DSINICIOVALE']) && !empty($this->row['DSINICIOVALE']) ? $this->row['DSINICIOVALE'] : null;
                    $listaEstrutSind = isset($this->row['LIST_NRESTRUTSIND']) && is_array($this->row['LIST_NRESTRUTSIND']) && count($this->row['LIST_NRESTRUTSIND']) ? implode(",", $this->row['LIST_NRESTRUTSIND']) : 1;
                    
                    $inicial = !empty($this->row['DSINICIOVALE1']) ? $this->row['DSINICIOVALE1'] : null;
                    $final = !empty($this->row['DSFIMVALE1']) ? $this->row['DSFIMVALE1'] : null;
                    
                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL IN ($estrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    } else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL IN ($estrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";   
                    } else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL IN ($estrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    } else{
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL IN ($estrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1))";
                    }
                    $param = array( 'P_NRORG' => $this->nrorg);
                                    
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL = $estrutLegal AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                    
                case 'LISTA_TOMADOR':
                    $listaEstrutSup = isset($this->row['LIST_NRESTRUTURAMSUP']) && is_array($this->row['LIST_NRESTRUTURAMSUP']) && count($this->row['LIST_NRESTRUTURAMSUP']) ? implode(",", $this->row['LIST_NRESTRUTURAMSUP']) : null;
                    $listaEstrutGeren = isset($this->row['LIST_NRESTRUTGEREN']) && is_array($this->row['LIST_NRESTRUTGEREN']) && count($this->row['LIST_NRESTRUTGEREN']) ? implode(",", $this->row['LIST_NRESTRUTGEREN']) : 1;
                    
                    $inicial = !empty($this->row['DSINICIOVALE1']) ? $this->row['DSINICIOVALE1'] : null;
                    $final = !empty($this->row['DSFIMVALE1']) ? $this->row['DSFIMVALE1'] : null;
                    $param = array( 'P_NRORG' => $this->nrorg);
                    
                    if(isset($listaEstrutSup) && (isset($listaEstrutGeren) && $listaEstrutGeren != 1)){
                        if(isset($inicial) && isset($final)){
                            $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                        } else if(isset($inicial) && !isset($final)){
                            $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";
                        } else if(!isset($inicial) && isset($final)){
                           $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG"; 
                        } else {
                            $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND NRORG = :P_NRORG";
                        }
                    } else{
                        if(isset($inicial) && isset($final)){
                            $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                        } else if(isset($inicial) && !isset($final)){
                            $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";
                        } else if(!isset($inicial) && isset($final)){
                            $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                        } else {
                            $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND NRORG = :P_NRORG";
                        }
                    }
                    
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                case 'LISTA_LOTE':
                    $param = array('P_NRORG' => $this->nrorg);
                    $listaLote = isset($this->row['NRLOTEVINC_LIST']) && is_array($this->row['NRLOTEVINC_LIST']) && count($this->row['NRLOTEVINC_LIST']) ? implode(",", $this->row['NRLOTEVINC_LIST']) : null;

                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN (SELECT NRVINCULOM FROM FPA_ITEMLOTEVINC WHERE NRORG = :P_NRORG AND NRLOTEVINC IN($listaLote))";
                    $msgerro = 'Não foram encontrados vínculos para a lista informada';
                    break;
                case 'LISTA_HIERARQUIA':
                    $param = array('P_NRORG' => $this->nrorg);
                    
                    $tipoHierarquia = isset($this->row['DSINICIOVALE']) && !empty($this->row['DSINICIOVALE']) ? $this->row['DSINICIOVALE'] : null;
                    $listaEstrutSup = isset($this->row['NRESTRUTURAMSUP']) && is_array($this->row['NRESTRUTURAMSUP']) && count($this->row['NRESTRUTURAMSUP']) ? implode(",", $this->row['NRESTRUTURAMSUP']) : 1;
                    
                    if(empty($tipoHierarquia)){
                        isset($this->row['NRTIPOHIERARQORG']) && !empty($this->row['NRTIPOHIERARQORG']) ? $this->row['NRTIPOHIERARQORG'] : null;
                    }
                    
                    $inicial = !empty($this->row['DSINICIOVALE1']) ? $this->row['DSINICIOVALE1'] : null;
                    $final = !empty($this->row['DSFIMVALE1']) ? $this->row['DSFIMVALE1'] : null;
                    
                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    }
                    else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";
                    }
                    else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    }
                    else {
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND NRORG = :P_NRORG";
                    }
                    
                    $msgerro = 'Não foram encontrados vínculos para as estruturas superiores informadas';
                    break;
                default: {
                    return null;
                }
            }
            
            $where .= $vinculosComHistorico . $cond_afastados;
            
            $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
            
            if ($result) {
                return $result;
            } else {
                throw new \Exception($msgerro, Messages::ERROR_MESSAGE_CODE);
            }

        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    private function getParametroValeTransporte($nrorg, $dtmescompecencia){
        $params = array(
            "P_NRORG"          => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompecencia);

$sql = "SELECT
    PARAMVALEH.*
FROM
         VAB_PARAMVALEM PARAMVALEM
    JOIN VAB_PARAMVALEH PARAMVALEH ON PARAMVALEH.NRORG = PARAMVALEM.NRORG
                                      AND PARAMVALEH.NRPARAMVALEM = PARAMVALEM.NRPARAMVALEM
                                      AND PARAMVALEH.DTMESCOMPETENC = (
        SELECT
            MAX(PH.DTMESCOMPETENC)
        FROM
            VAB_PARAMVALEH PH
        WHERE
                PH.NRORG = PARAMVALEH.NRORG
            AND PH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
    )
WHERE
    PARAMVALEM.NRORG = :P_NRORG
ORDER BY PARAMVALEH.DTMESCOMPETENC DESC";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        return $retorno;
    }

    /**
     * Inicia o Calculo
     *
     * @throws \Exception
     */
    public function calculo()
    {
        try {
            $paramVale = $this->getParametroValeTransporte($this->nrorg, $this->competencia);
            
            $row = array();
            $messages = array();
            
            /**
             * @var \Folha\Entities\GpeVinculom $vinculo
             */
            foreach ($this->vinculos as $vinculo) {
                set_time_limit(0);
                
                $historicosPgto = $this->retornaHistoricoPgto($vinculo, $this->competencia, $this->dataPagamento);
                $historicos = $this->retornaHistoricoValeEntrePeriodos($vinculo, $this->competencia);
                
                if($this->idcalccomplementar == 'N'){
                    //So deve verificar os historicos entre periodos se o flag calcComplementar não estiver marcado
                    if($historicos){
                        $row[] = [
                          "NRMSGCALC"   => 0,
                          "DSDESCRICAO" => "Vínculo: ".$historicos[0]->getNrvinculom()." possui calculo de vale transporte na competência!! periodo Inicial: ".$historicos[0]->getDtiniapurvale()->format('d/m/Y')." periodo final: ".$historicos[0]->getDtfinapurvale()->format('d/m/Y')." e com data de pagamento em: ".$historicos[0]->getDtpgtovale()->format('d/m/Y').".", 
                          "IDTIPOMSG"   => 'Alerta',
                          "DTINCLUSAO"  => $historicos[0]->getDtinclusao()->format('d/m/Y'),
                        ];
                        continue;
                    }
                } elseif($this->idcalccomplementar == 'S') {
                    //So deve verificar os historicos com pagamento igual se o flag calcComplementar estiver marcado
                    if($historicosPgto){
                        $row[] = [
                          "NRMSGCALC"   => 0,
                          "DSDESCRICAO" => "Vínculo: ".$historicosPgto[0]->getNrvinculom()." possui calculo de vale transporte com mesma data de Pagamento!! Data de pagamento em: ".$historicosPgto[0]->getDtpgtovale()->format('d/m/Y').".", 
                          "IDTIPOMSG"   => 'Alerta',
                          "DTINCLUSAO"  => $historicosPgto[0]->getDtinclusao()->format('d/m/Y'),
                        ];
                        continue;
                    }
                }

                MemoriaVT::getInstance()->inicializarDados($vinculo, $this->hcmParameters, $this->dataInicio, $this->dataFinal, $this->dataPagamento);
                
                if(!empty($paramVale)){ 
                    $params = new ValeVinculo($vinculo, $this->nrorg, $this->dataInicio, $this->dataFinal, $this->nrtipolinhavinc, $this->hcmParameters, $paramVale[0], $this->qtdiasvalefixo, $this->idcalccomplementar, $this->idcalccredindev, $this->dtiniciocredindev, $this->dtfinalcredindev);
                } else {
                    $params = new ValeVinculo($vinculo, $this->nrorg, $this->dataInicio, $this->dataFinal, $this->nrtipolinhavinc, $this->hcmParameters, null, $this->qtdiasvalefixo, $this->idcalccomplementar, $this->idcalccredindev, $this->dtiniciocredindev, $this->dtfinalcredindev);
                }
                
                $infos = $params->getValeTransporte();

                if (!empty($infos)) {
                    foreach ($infos as $info) {
                        $params->addHistorico($info, $vinculo->getNrvinculom(), $this->dataPagamento);
                    }
                }
                
                if($params->getMessages()){
                    $messages[] = $params->getMessages();
                }
    
                MemoriaVT::getInstance()->concatenarMensagemVinc();
            }

            if(count($messages) > 0){
                foreach($messages as $message){
                    foreach($message as $messages){
                        $row[] = [
                          "NRMSGCALC"   => 0,
                          "DSDESCRICAO" => $messages, 
                          "IDTIPOMSG"   => 'Alerta/Erro',
                          "DTINCLUSAO"  => DateUtil::getDataAtual()->format('d/m/Y'),
                        ];
                    }
                }
            }
            
            MemoriaVT::getInstance()->salvarMsgArquivo();

            if($this->idMemoria == 'S') $this->response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('memoriaCalculo', array(MemoriaVT::getInstance()->getCaminhoArquivo())) );

            \Setforms2\Shared\Registry::getEntityManager()->flush();
            
            $this->response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('calculoValeTransporte', $row));
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * Insere os Vinculos no Itecalcfolha
     */
    private function insereItemCalculo($info, $vinculo)
    {

        /**
         * @var FpaItecalcfolha $item
         */
        $item = new FpaItecalcfolha();

        $item->setNritemcalcfolha(NovoCodigo::geraCodigo($this->nrorg, 'FPA_ITECALCFOLHA', 1, 22, true));
        $item->setCdoperinclusao(Ambiente::getCdOperador());
        $item->setCdoperultatu(Ambiente::getCdOperador());
        $item->setDtinclusao(DateUtil::getDataAtual());
        $item->setDtocorrencia(DateUtil::getDataDeString($this->competencia, DateUtil::FORMATO_BRASILEIRO, true));
        $item->setDtultatu(DateUtil::getDataAtual());
        $item->setIdevendemoncalc('N');
        $item->setIdrefevalorcalc('NORMAL');
        $item->setNrcalculofolha(tk_get_env_var('NRCALCULO_VAB'));
        $item->setNreventom(480);
        $item->setNrorg(Ambiente::getNrorgTrabalho());
        $item->setNrorginclusao(Ambiente::getNrorgTrabalho());
        $item->setNrorgultatu(Ambiente::getNrorgTrabalho());
        $item->setNrvinculom($vinculo);
        $item->setQtocorproxperi(1);
        $item->setVreventofolha((float)$info['VALOR']);
        $item->setVrreffolha((int)$info['REFERENCIA']);

        $item->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();

    }

    /**
     * Retrocede, apagando todos os históricos gerados.
     * @param $movimento
     * @param $competencia
     * @param $nrorg
     * @param $inicial
     * @param $final
     * @param $ordem
     * @param $nrtipolinhavinc
     * @throws \Exception
     */
    public static function retroceder($movimento, $competencia, $nrorg, $inicial, $final, $ordem, $nrtipolinhavinc, $row)
    {
        try {
            $dtmescompetencia = DateUtil::getDataDeString($competencia, DateUtil::FORMATO_BRASILEIRO, true);
            
            //18/09/20 alteração para olhar vínculos ativos na competência do operador e não na competência + 1 mês ($dtiniperiodo) como era feito
            $inicompetencia = $dtmescompetencia->format('d/m/Y');
            $fimcompetencia = $dtmescompetencia->format('t/m/Y');
            
            $dtmescompetencia->add(new \DateInterval('P1M'));
            $dtiniperiodo = $dtmescompetencia->format('d/m/Y');
            $nrtipomoviment = FpaTipomoviment::TP_MOV_VALE_TRANSPORTE;

            $param = array( 'P_INICIO'       => $inicial,
                            'P_FIM'          => $final,
                            'P_NRORG'        => $nrorg,
                            //'P_DTINIPERIODO' => $dtiniperiodo);
                            'P_INICOMPETENCIA' => $inicompetencia,
                            'P_FIMCOMPETENCIA' => $fimcompetencia);
                            
            

            switch($ordem)
            {
                case 'ALFABETICA':
                {
                    //$result = \Folha\Entities\GpeVinculom::getObjectsByWhere("(TO_CHAR(DTRESCISAOVINC, 'DD/MM/YYYY') > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND TO_CHAR(DTADMISSAOVINC, 'DD/MM/YYYY') <= :P_DTINIPERIODO AND NRVINCULOM BETWEEN :P_INICIO AND :P_FIM", $param);
                    //$where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_DTINIPERIODO AND NRVINCULOM BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $where = "(DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_FIMCOMPETENCIA AND NRVINCULOM BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'MATRICULA':{
                    //$where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND TO_CHAR(DTADMISSAOVINC, 'DD/MM/YYYY') <= :P_DTINIPERIODO AND CDMATRICULA BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $where = "(DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND TO_CHAR(DTADMISSAOVINC, 'DD/MM/YYYY') <= :P_FIMCOMPETENCIA AND CDMATRICULA BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'DATA_ADMISSAO':{
                    //$where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $where = "(DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'ESTRUTURA':{
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_DTINIPERIODO AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ((NRESTRUTGEREN = :P_FIM) OR (:P_FIM IS NULL)) AND NRESTRUTLEGAL = :P_INICIO AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND DTMESCOMPETENC <= :P_DTINIPERIODO))";
                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_FIMCOMPETENCIA AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ((NRESTRUTGEREN = :P_FIM) OR (:P_FIM IS NULL)) AND NRESTRUTLEGAL = :P_INICIO AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND DTMESCOMPETENC <= :P_FIMCOMPETENCIA))";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'LISTA_VINCULO':
                    $param = array(
                        'P_NRORG' => $nrorg,
                        'P_INICOMPETENCIA' => $inicompetencia,
                        'P_FIMCOMPETENCIA' => $fimcompetencia,
                    );
                    
                    if(is_array($row['NRVINCULOM_LIST'])){
                        $inicial = implode(",", $row['NRVINCULOM_LIST']);
                    }else{
                        $inicial = $row['NRVINCULOM_LIST'];
                    }
                    
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ($inicial)";
                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_FIMCOMPETENCIA AND NRVINCULOM IN ($inicial)";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                case 'LISTA_ESTRUTURA':
                    $listaEstrutLegal = isset($row['LIST_NRESTRUTLEGAL']) && is_array($row['LIST_NRESTRUTLEGAL']) && count($row['LIST_NRESTRUTLEGAL']) ? implode(",", $row['LIST_NRESTRUTLEGAL']) : null;
                    $listaEstrutGeren = isset($row['LIST_NRESTRUTGEREN']) && is_array($row['LIST_NRESTRUTGEREN']) && count($row['LIST_NRESTRUTGEREN']) ? implode(",", $row['LIST_NRESTRUTGEREN']) : 1;
                    
                    $inicial = !empty($row['DSINICIOVALE1']) ? $row['DSINICIOVALE1'] : null;
                    $final = !empty($row['DSFIMVALE1']) ? $row['DSFIMVALE1'] : null;
                    
                    $param = array( 'P_NRORG' => $nrorg);
                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    } else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial'AND NRORG = :P_NRORG";
                    } else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    } else{
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1))";
                    }                
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                case 'LISTA_NRESTRUTSIND':
                    $estrutLegal = isset($row['DSINICIOVALE']) && !empty($row['DSINICIOVALE']) ? $row['DSINICIOVALE'] : null;
                    $listaEstrutSind = isset($row['LIST_NRESTRUTSIND']) && is_array($row['LIST_NRESTRUTSIND']) && count($row['LIST_NRESTRUTSIND']) ? implode(",", $row['LIST_NRESTRUTSIND']) : 1;
                    
                    $inicial = !empty($row['DSINICIOVALE1']) ? $row['DSINICIOVALE1'] : null;
                    $final = !empty($row['DSFIMVALE1']) ? $row['DSFIMVALE1'] : null;
                    
                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL IN ($estrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    } else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL IN ($estrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";   
                    } else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL IN ($estrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    } else{
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL IN ($estrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1))";
                    }
                    $param = array( 'P_NRORG' => $nrorg);
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL = $estrutLegal AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                case 'LISTA_TOMADOR':
                    $listaEstrutSup = isset($row['LIST_NRESTRUTURAMSUP']) && is_array($row['LIST_NRESTRUTURAMSUP']) && count($row['LIST_NRESTRUTURAMSUP']) ? implode(",", $row['LIST_NRESTRUTURAMSUP']) : null;
                    $listaEstrutGeren = isset($row['LIST_NRESTRUTGEREN']) && is_array($row['LIST_NRESTRUTGEREN']) && count($row['LIST_NRESTRUTGEREN']) ? implode(",", $row['LIST_NRESTRUTGEREN']) : 1;
                    
                    $inicial = !empty($row['DSINICIOVALE1']) ? $row['DSINICIOVALE1'] : null;
                    $final = !empty($row['DSFIMVALE1']) ? $row['DSFIMVALE1'] : null;
                    
                    $param = array( 'P_NRORG' => $nrorg);
                    if(isset($listaEstrutSup) && (isset($listaEstrutGeren) && $listaEstrutGeren != 1)){
                        if(isset($inicial) && isset($final)){
                            $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                        } else if(isset($inicial) && !isset($final)){
                            $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";
                        } else if(!isset($inicial) && isset($final)){
                           $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG"; 
                        } else {
                            $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND NRORG = :P_NRORG";
                        }
                    } else{
                        if(isset($inicial) && isset($final)){
                            $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                        } else if(isset($inicial) && !isset($final)){
                            $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";
                        } else if(!isset($inicial) && isset($final)){
                            $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                        } else {
                            $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND NRORG = :P_NRORG";
                        }
                    }
                    
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                case 'LISTA_LOTE':
                    $param = array( 'P_NRORG' => $nrorg);
                    $listaLote = isset($row['NRLOTEVINC_LIST']) && is_array($row['NRLOTEVINC_LIST']) && count($row['NRLOTEVINC_LIST']) ? implode(",", $row['NRLOTEVINC_LIST']) : null;

                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN (SELECT NRVINCULOM FROM FPA_ITEMLOTEVINC WHERE NRORG = :P_NRORG AND NRLOTEVINC IN($listaLote))";
                    
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    $msgerro = 'Não foram encontrados vínculos para a lista informada';
                    break;
                case 'LISTA_HIERARQUIA':
                    $param = array('P_NRORG' => $nrorg);
                    
                    $tipoHierarquia = isset($row['DSINICIOVALE']) && !empty($row['DSINICIOVALE']) ? $row['DSINICIOVALE'] : null;

                    $listaEstrutSup = isset($row['NRESTRUTURAMSUP']) && is_array($row['NRESTRUTURAMSUP']) && count($row['NRESTRUTURAMSUP']) ? implode(",", $row['NRESTRUTURAMSUP']) : 1;
                    
                    $inicial = !empty($row['DSINICIOVALE1']) ? $row['DSINICIOVALE1'] : null;
                    $final = !empty($row['DSFIMVALE1']) ? $row['DSFIMVALE1'] : null;
                    
                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC) WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    }
                    else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC) WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";
                    }
                    else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC) WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    }
                    else {
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC) WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND NRORG = :P_NRORG";
                    }
                    
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    
                    $msgerro = 'Não foram encontrados vínculos para as estruturas superiores informadas';
                    break;
            }

            /**
             * @var \Folha\Entities\GpeVinculom $reg
             * @var VabHistvalevinc $hist
             */
            if($result){
                $itens = array();

                $dtpagamentoVale = DateUtil::getDataDeString($row['DTPAGAMENTOVALE'], DateUtil::FORMATO_BRASILEIRO, true);
                $dtpagamentoVale = $dtpagamentoVale->format('d/m/Y');

                $hists = VabHistvalevinc::getObjectsByWhere(
                    "NRORG = $nrorg AND
                     TRUNC(DTMESCOMPAPVALE, 'DD') = '$competencia' AND
                     DTPGTOVALE = '$dtpagamentoVale' AND
                     NRCALCULOFOLHA  = (SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA WHERE NRCALCULOFOLHA = $movimento AND NRORG = $nrorg AND NRTIPOMOVIMENT = $nrtipomoviment) AND
                     NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE $where) AND
                     (NRTIPOLINHAVINC = '$nrtipolinhavinc' OR '$nrtipolinhavinc' IS NULL) AND (IDAJUSTEMANUAL = 'N' OR IDAJUSTEMANUAL IS NULL)", $param);
                
                $dtpagamentoForm = DateUtil::getDataDeString($row['DTPAGAMENTOVALE'], DateUtil::FORMATO_BRASILEIRO, true)->format('d/m/Y');
                
                $itensCalc = FpaItecalcfolha::getObjectsByWhere(
                    "NRORG = $nrorg AND
                     NRCALCULOFOLHA  = (SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA WHERE NRCALCULOFOLHA = $movimento AND NRORG = $nrorg AND NRTIPOMOVIMENT = $nrtipomoviment AND DTOCORRENCIA = '$dtpagamentoForm') AND
                     NREVENTOM IN (3030, 3040, 480) AND
                     NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE $where)", $param);
                
                $message = array();
                $vinculos = [];
                
                //Guarda os vinculos que possuem itens de calculo no array $vinculos
                if($itensCalc){
                    foreach($itensCalc as $itemCalc){
                        if(!in_array($itemCalc->getNrvinculom(), $vinculos)){
                            $vinculos[] = $itemCalc->getNrvinculom();
                        }
                    }
                }
                
                /*
                if(count($hists) > 300){
                    throw new \Exception('Não é possivel fazer o retrocesso de mais de 300 lançamentos.', Messages::ERROR_MESSAGE_CODE);
                }*/
                
                if($itens || $hists){
                    foreach ($itens as $itemcalc) {
                        $itemcalc->delete();
                    }
                    foreach($hists as $hist){
                        //Verifica se no historico de vale o numero do vinculo esta dentro do $vinculos que possuem itens de calculo e nao serão retrocedidos.
                        if(!in_array($hist->getNrvinculom(), $vinculos)){
                            $hist->delete();
                        }
                    }
                    \Setforms2\Shared\Registry::getEntityManager()->flush();
                } else {
                    throw new \Exception('Não foram encontrados lançamentos para retroceder.', Messages::ERROR_MESSAGE_CODE);
                }

            } else {
                throw new \Exception('Não foram encontrados vínculos para o critério de seleção.', Messages::ERROR_MESSAGE_CODE);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    /**
     * Retrocede, apagando todos os históricos gerados.
     * @param $movimento
     * @param $competencia
     * @param $nrorg
     * @param $inicial
     * @param $final
     * @param $ordem
     * @param $nrtipolinhavinc
     * @throws \Exception
     */
    public static function verificaQtdRetrocesso($movimento, $competencia, $nrorg, $inicial, $final, $ordem, $nrtipolinhavinc, $row)
    {
        try {
            $dtmescompetencia = DateUtil::getDataDeString($competencia, DateUtil::FORMATO_BRASILEIRO, true);
            
            //18/09/20 alteração para olhar vínculos ativos na competência do operador e não na competência + 1 mês ($dtiniperiodo) como era feito
            $inicompetencia = $dtmescompetencia->format('d/m/Y');
            $fimcompetencia = $dtmescompetencia->format('t/m/Y');
            
            $dtmescompetencia->add(new \DateInterval('P1M'));
            $dtiniperiodo = $dtmescompetencia->format('d/m/Y');
            $nrtipomoviment = FpaTipomoviment::TP_MOV_VALE_TRANSPORTE;

            $param = array( 'P_INICIO'       => $inicial,
                            'P_FIM'          => $final,
                            'P_NRORG'        => $nrorg,
                            //'P_DTINIPERIODO' => $dtiniperiodo);
                            'P_INICOMPETENCIA' => $inicompetencia,
                            'P_FIMCOMPETENCIA' => $fimcompetencia);
                            
            
            switch($ordem)
            {
                case 'ALFABETICA':
                {
                    //$result = \Folha\Entities\GpeVinculom::getObjectsByWhere("(TO_CHAR(DTRESCISAOVINC, 'DD/MM/YYYY') > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND TO_CHAR(DTADMISSAOVINC, 'DD/MM/YYYY') <= :P_DTINIPERIODO AND NRVINCULOM BETWEEN :P_INICIO AND :P_FIM", $param);
                    //$where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_DTINIPERIODO AND NRVINCULOM BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $where = "(DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_FIMCOMPETENCIA AND NRVINCULOM BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'MATRICULA':{
                    //$where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND TO_CHAR(DTADMISSAOVINC, 'DD/MM/YYYY') <= :P_DTINIPERIODO AND CDMATRICULA BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $where = "(DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND TO_CHAR(DTADMISSAOVINC, 'DD/MM/YYYY') <= :P_FIMCOMPETENCIA AND CDMATRICULA BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'DATA_ADMISSAO':{
                    //$where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $where = "(DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'ESTRUTURA':{
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_DTINIPERIODO AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ((NRESTRUTGEREN = :P_FIM) OR (:P_FIM IS NULL)) AND NRESTRUTLEGAL = :P_INICIO AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND DTMESCOMPETENC <= :P_DTINIPERIODO))";
                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_FIMCOMPETENCIA AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ((NRESTRUTGEREN = :P_FIM) OR (:P_FIM IS NULL)) AND NRESTRUTLEGAL = :P_INICIO AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND DTMESCOMPETENC <= :P_FIMCOMPETENCIA))";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'LISTA_VINCULO':
                    $param = array(
                        'P_NRORG' => $nrorg,
                        'P_INICOMPETENCIA' => $inicompetencia,
                        'P_FIMCOMPETENCIA' => $fimcompetencia,
                    );
                    
                    if(is_array($row['NRVINCULOM_LIST'])){
                        $inicial = implode(",", $row['NRVINCULOM_LIST']);
                    }else{
                        $inicial = $row['NRVINCULOM_LIST'];
                    }
                    
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ($inicial)";
                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= :P_INICOMPETENCIA OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_FIMCOMPETENCIA AND NRVINCULOM IN ($inicial)";

                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                case 'LISTA_ESTRUTURA':
                    $listaEstrutLegal = isset($row['LIST_NRESTRUTLEGAL']) && is_array($row['LIST_NRESTRUTLEGAL']) && count($row['LIST_NRESTRUTLEGAL']) ? implode(",", $row['LIST_NRESTRUTLEGAL']) : null;
                    $listaEstrutGeren = isset($row['LIST_NRESTRUTGEREN']) && is_array($row['LIST_NRESTRUTGEREN']) && count($row['LIST_NRESTRUTGEREN']) ? implode(",", $row['LIST_NRESTRUTGEREN']) : 1;
                    
                    $inicial = !empty($row['DSINICIOVALE1']) ? $row['DSINICIOVALE1'] : null;
                    $final = !empty($row['DSFIMVALE1']) ? $row['DSFIMVALE1'] : null;
                    
                    $param = array( 'P_NRORG' => $nrorg);
                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    } else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial'AND NRORG = :P_NRORG";
                    } else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    } else{
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1))";
                    }                
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren) OR  1 IN($listaEstrutGeren)  ) AND NRESTRUTLEGAL IN($listaEstrutLegal) AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                case 'LISTA_NRESTRUTSIND':
                    $estrutLegal = isset($row['DSINICIOVALE']) && !empty($row['DSINICIOVALE']) ? $row['DSINICIOVALE'] : null;
                    $listaEstrutSind = isset($row['LIST_NRESTRUTSIND']) && is_array($row['LIST_NRESTRUTSIND']) && count($row['LIST_NRESTRUTSIND']) ? implode(",", $row['LIST_NRESTRUTSIND']) : 1;
                    
                    $inicial = !empty($row['DSINICIOVALE1']) ? $row['DSINICIOVALE1'] : null;
                    $final = !empty($row['DSFIMVALE1']) ? $row['DSFIMVALE1'] : null;
                    
                    
                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL = $estrutLegal AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    } else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL = $estrutLegal AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";   
                    } else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL = $estrutLegal AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    } else{
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL = $estrutLegal AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1))";
                    }
                    $param = array( 'P_NRORG' => $nrorg);
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    //$where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTSIND IN($listaEstrutSind) ) AND NRESTRUTLEGAL = $estrutLegal AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                case 'LISTA_TOMADOR':
                    $listaEstrutSup = isset($row['LIST_NRESTRUTURAMSUP']) && is_array($row['LIST_NRESTRUTURAMSUP']) && count($row['LIST_NRESTRUTURAMSUP']) ? implode(",", $row['LIST_NRESTRUTURAMSUP']) : null;
                    $listaEstrutGeren = isset($row['LIST_NRESTRUTGEREN']) && is_array($row['LIST_NRESTRUTGEREN']) && count($row['LIST_NRESTRUTGEREN']) ? implode(",", $row['LIST_NRESTRUTGEREN']) : 1;
                    
                    $param = array( 'P_NRORG' => $nrorg);
                    if(isset($listaEstrutSup) && (isset($listaEstrutGeren) && $listaEstrutGeren != 1)){
                        $where = "NRORG = :P_NRORG AND(DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ( NRESTRUTGEREN IN($listaEstrutGeren)) AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND NRORG = :P_NRORG";
                    } else{
                        $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS (SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = (SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = (SELECT NRTIPOHIERARQORG FROM TIPOHIERARQORG WHERE NRORG IN (0, :P_NRORG) AND NRTIPOESTRUTSUP = (SELECT NVL(NRTPESTRUTOMADOR, 7) FROM GPE_PARAMORG WHERE NRORG = :P_NRORG) AND NRTIPOESTRUTREL = (SELECT NRTPESTRUTGEREN FROM GPE_PARAMORG WHERE NRORG = :P_NRORG)) AND H.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG)))) AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND NRORG = :P_NRORG";
                    }
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    $msgerro = 'Não foram encontrados vínculos para as estruturas informadas';
                    break;
                case 'LISTA_LOTE':
                    $param = array( 'P_NRORG' => $nrorg);
                    $listaLote = isset($row['NRLOTEVINC_LIST']) && is_array($row['NRLOTEVINC_LIST']) && count($row['NRLOTEVINC_LIST']) ? implode(",", $row['NRLOTEVINC_LIST']) : null;

                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN (SELECT NRVINCULOM FROM FPA_ITEMLOTEVINC WHERE NRORG = :P_NRORG AND NRLOTEVINC IN($listaLote))";
                    
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    $msgerro = 'Não foram encontrados vínculos para a lista informada';
                    break;
                case 'LISTA_HIERARQUIA':
                    $param = array('P_NRORG' => $nrorg);
                    
                    //$tipoHierarquia = isset($row['NRTIPOHIERARQORG']) && !empty($row['NRTIPOHIERARQORG']) ? $row['NRTIPOHIERARQORG'] : null;
                    $tipoHierarquia = isset($row['DSINICIOVALE']) && !empty($row['DSINICIOVALE']) ? $row['DSINICIOVALE'] : null;

                    $listaEstrutSup = isset($row['NRESTRUTURAMSUP']) && is_array($row['NRESTRUTURAMSUP']) && count($row['NRESTRUTURAMSUP']) ? implode(",", $row['NRESTRUTURAMSUP']) : 1;
                    
                    $inicial = !empty($row['DSINICIOVALE1']) ? $row['DSINICIOVALE1'] : null;
                    $final = !empty($row['DSFIMVALE1']) ? $row['DSFIMVALE1'] : null;

                    if(isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC BETWEEN '$inicial' AND '$final' AND NRORG = :P_NRORG";
                    }
                    else if(isset($inicial) && !isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC >= '$inicial' AND NRORG = :P_NRORG";
                    }
                    else if(!isset($inicial) && isset($final)){
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$final' AND NRORG = :P_NRORG";
                    }
                    else {
                        $where = "NRORG = :P_NRORG AND( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND DTADMISSAOVINC <= '$fimcompetencia' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND DTMESCOMPETENC = ( SELECT * FROM ( SELECT DTMESCOMPETENC DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1) AND EXISTS ( SELECT 1 FROM ESTRUTURAM EMA WHERE EMA.NRORG = :P_NRORG AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H WHERE H.NRORG = :P_NRORG AND H.NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND H.NRESTRUTURAMSUP IN ($listaEstrutSup) AND H.NRTIPOHIERARQORG = '$tipoHierarquia' AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= '$fimcompetencia' AND NRORG = :P_NRORG AND NRESTRUTURAMREL = GPE_VINCULOH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) ) ) ) AND ( DTRESCISAOVINC >= '$inicompetencia' OR DTRESCISAOVINC IS NULL ) AND NRORG = :P_NRORG";
                    }
                    
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    
                    $msgerro = 'Não foram encontrados vínculos para as estruturas superiores informadas';
                    break;
            }

            /**
             * @var \Folha\Entities\GpeVinculom $reg
             * @var VabHistvalevinc $hist
             */

            $dtpagamentoVale = DateUtil::getDataDeString($row['DTPAGAMENTOVALE'], DateUtil::FORMATO_BRASILEIRO, true);
            $dtpagamentoVale = $dtpagamentoVale->format('d/m/Y');

            if($result){
                $itens = array();
                
                $hists = VabHistvalevinc::getObjectsByWhere(
                    "NRORG = $nrorg AND
                     TRUNC(DTMESCOMPAPVALE, 'DD') = '$competencia' AND
                     DTPGTOVALE = '$dtpagamentoVale' AND
                     NRCALCULOFOLHA  = (SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA WHERE NRCALCULOFOLHA = $movimento AND NRORG = $nrorg AND NRTIPOMOVIMENT = $nrtipomoviment) AND
                     NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE $where) AND
                     (NRTIPOLINHAVINC = '$nrtipolinhavinc' OR '$nrtipolinhavinc' IS NULL) AND (IDAJUSTEMANUAL = 'N' OR IDAJUSTEMANUAL IS NULL)", $param);
                
                $dtpagamentoForm = DateUtil::getDataDeString($row['DTPAGAMENTOVALE'], DateUtil::FORMATO_BRASILEIRO, true)->format('d/m/Y');
                
                $itensCalc = FpaItecalcfolha::getObjectsByWhere(
                    "NRORG = $nrorg AND
                     NRCALCULOFOLHA  = (SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA WHERE NRCALCULOFOLHA = $movimento AND NRORG = $nrorg AND NRTIPOMOVIMENT = $nrtipomoviment AND DTOCORRENCIA = '$dtpagamentoForm') AND
                     NREVENTOM IN (3030, 3040, 480) AND
                     NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE $where)", $param);
                
                $vinculos = [];
                
                //Guarda os vinculos que possuem itens de calculo
                if($itensCalc){
                    foreach($itensCalc as $itemCalc){
                        if(!in_array($itemCalc->getNrvinculom(), $vinculos)){
                            $vinculos[] = $itemCalc->getNrvinculom();
                        }
                    }
                }
                
                /*
                if(count($hists) > 300){
                    throw new \Exception('Não é possivel fazer o retrocesso de mais de 300 lançamentos de uma só vez.', Messages::ERROR_MESSAGE_CODE);
                }*/
                
                $index = 0;
                if($hists){
                    foreach($hists as $hist){
                        //Verifica se o vinculo tem item de calculo é não conta este vinculo para mostrar a qntd de vinculos que serao retrocedidos.
                        if(!in_array($hist->getNrvinculom(), $vinculos)){
                            $index++;
                        }
                    }
                    
                    if($index == 0){
                        return 'Não é possível retroceder os lançamentos, pois possuem itens de cálculo.';
                    } 
                    
                    $qtdHist = $index;
                    return $qtdHist;
                } else {
                    return 'Não foram encontrados lançamentos para retroceder.';
                }

            } else {
                throw new \Exception('Não foram encontrados vínculos para o critério de seleção.', Messages::ERROR_MESSAGE_CODE);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
} 