<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


use HCM\Util\Repositories;

class EsoRemunoutrempr extends \Doctrine\ORM\EntityRepository {
    
   

     public function retornaRemuneracaoOutrasFontes($nrOrg, $cpf, $mesCompetencia){ 

        $esoRemune = Repositories::ESO_REMUNOUTREMPR;
        $gpe_pessoa =  'Teknisa\Model\Gestaopessoas\Entities\GpePessoa';
        $gpe_pessoah =  'Teknisa\Model\Gestaopessoas\Entities\GpePessoah';

$sql = <<<SQL
    SELECT e
    FROM $esoRemune e 
    INNER JOIN
    $gpe_pessoa pm WITH
    e.nrorg = pm.nrorg
	AND e.nrpessoa = pm.nrpessoa  
    INNER JOIN
    $gpe_pessoah ph WITH 
    ph.dtmescompetenc = (
			SELECT MAX(phh.dtmescompetenc)
  			FROM $gpe_pessoah phh
  			WHERE phh.dtmescompetenc <= :p_dtmescompetenc
  			AND ph.nrorg = phh.nrorg
  			AND ph.nrpessoa = phh.nrpessoa
  			)
		AND ph.nrorg = pm.nrorg
		AND ph.nrpessoa = pm.nrpessoa    
    WHERE 
    e.nrorg = :p_nrorg
    and ph.nrcpfpessoa = :cpfpessoa
    and e.dtmescompetenc = :p_dtmescompetenc
    
SQL;
        $params = array(
                'p_dtmescompetenc' => $mesCompetencia,
                'p_nrorg' => $nrOrg,
                'cpfpessoa' => $cpf
            );
            
        
        $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $resultQuery;
     }
    
}